(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/forms'), require('@angular/router'), require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('angular-bootstrap-md', ['exports', '@angular/animations', '@angular/forms', '@angular/router', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global['angular-bootstrap-md'] = {}),global.ng.animations,global.ng.forms,global.ng.router,global.ng.common,global.ng.core,global.rxjs,global.rxjs.operators));
}(this, (function (exports,animations,forms,router,common,i0,rxjs,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MDBBadgeComponent = /** @class */ (function () {
        function MDBBadgeComponent(_el, _renderer) {
            this._el = _el;
            this._renderer = _renderer;
        }
        /**
         * @return {?}
         */
        MDBBadgeComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._renderer.addClass(this._el.nativeElement, 'badge');
                if (this.color) {
                    /** @type {?} */
                    var customClassArr = this.color.split(' ');
                    customClassArr.forEach(( /**
                     * @param {?} el
                     * @return {?}
                     */function (el) {
                        _this._renderer.addClass(_this._el.nativeElement, el);
                    }));
                }
            };
        MDBBadgeComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-badge',
                        template: "<span class=\"{{class}} {{classInside}}\">\n  <ng-content></ng-content>\n</span>\n"
                    }] }
        ];
        /** @nocollapse */
        MDBBadgeComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MDBBadgeComponent.propDecorators = {
            default: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-default',] }],
            primary: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-primary',] }],
            success: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-success',] }],
            info: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-info',] }],
            warning: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-warning',] }],
            danger: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-danger',] }],
            pill: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.badge-pill',] }],
            classInside: [{ type: i0.Input }],
            color: [{ type: i0.Input }],
            class: [{ type: i0.Input }]
        };
        return MDBBadgeComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BadgeModule = /** @class */ (function () {
        function BadgeModule() {
        }
        BadgeModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [MDBBadgeComponent],
                        exports: [MDBBadgeComponent]
                    },] }
        ];
        return BadgeModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbBreadcrumbComponent = /** @class */ (function () {
        function MdbBreadcrumbComponent() {
        }
        MdbBreadcrumbComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-breadcrumb',
                        template: "<ol class=\"breadcrumb list-inline list-unstyled {{customClass}} text-{{textTransform}}\">\n  <ng-content></ng-content>\n</ol>\n"
                    }] }
        ];
        MdbBreadcrumbComponent.propDecorators = {
            customClass: [{ type: i0.Input }],
            textTransform: [{ type: i0.Input }]
        };
        return MdbBreadcrumbComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbBreadcrumbItemComponent = /** @class */ (function () {
        function MdbBreadcrumbItemComponent(_el, _renderer) {
            this._el = _el;
            this._renderer = _renderer;
        }
        /**
         * @return {?}
         */
        MdbBreadcrumbItemComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this._renderer.addClass(this._el.nativeElement, 'breadcrumb-item');
            };
        MdbBreadcrumbItemComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-breadcrumb-item',
                        template: "<li class=\"list-inline-item breadcrumb-item font-weight-{{fontWeight}}\">\n  <ng-content></ng-content>\n</li>\n"
                    }] }
        ];
        /** @nocollapse */
        MdbBreadcrumbItemComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbBreadcrumbItemComponent.propDecorators = {
            fontWeight: [{ type: i0.Input }]
        };
        return MdbBreadcrumbItemComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BreadcrumbModule = /** @class */ (function () {
        function BreadcrumbModule() {
        }
        BreadcrumbModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [MdbBreadcrumbComponent, MdbBreadcrumbItemComponent],
                        exports: [MdbBreadcrumbComponent, MdbBreadcrumbItemComponent]
                    },] }
        ];
        return BreadcrumbModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbBtnDirective = /** @class */ (function () {
        function MdbBtnDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.color = '';
            this.rounded = false;
            this.gradient = '';
            this.outline = false;
            this.flat = false;
            this.size = '';
            this.block = false;
            this.floating = false;
        }
        /**
         * @return {?}
         */
        MdbBtnDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var colorClass = 'btn-' + this.color;
                /** @type {?} */
                var gradientClass = this.gradient + '-gradient';
                /** @type {?} */
                var outlineClass = 'btn-outline-' + this.color;
                /** @type {?} */
                var flatClass = 'btn-flat';
                /** @type {?} */
                var roundedClass = 'btn-rounded';
                /** @type {?} */
                var sizeClass = 'btn-' + this.size;
                /** @type {?} */
                var blockClass = 'btn-block';
                /** @type {?} */
                var floatingClass = 'btn-floating';
                this.renderer.addClass(this.el.nativeElement, 'btn');
                if (this.color !== '') {
                    this.renderer.addClass(this.el.nativeElement, colorClass);
                }
                if (this.rounded) {
                    this.renderer.addClass(this.el.nativeElement, roundedClass);
                }
                if (this.gradient) {
                    if (this.color !== '') {
                        this.renderer.removeClass(this.el.nativeElement, colorClass);
                    }
                    this.renderer.addClass(this.el.nativeElement, gradientClass);
                }
                if (this.outline) {
                    this.renderer.removeClass(this.el.nativeElement, colorClass);
                    this.renderer.addClass(this.el.nativeElement, outlineClass);
                }
                if (this.flat) {
                    if (this.color) {
                        this.renderer.removeClass(this.el.nativeElement, colorClass);
                    }
                    if (this.gradient) {
                        this.renderer.removeClass(this.el.nativeElement, gradientClass);
                    }
                    if (this.outline) {
                        this.renderer.removeClass(this.el.nativeElement, outlineClass);
                    }
                    if (this.rounded) {
                        this.renderer.removeClass(this.el.nativeElement, roundedClass);
                    }
                    this.renderer.addClass(this.el.nativeElement, flatClass);
                }
                if (this.size) {
                    this.renderer.addClass(this.el.nativeElement, sizeClass);
                }
                if (this.block) {
                    this.renderer.addClass(this.el.nativeElement, blockClass);
                }
                if (this.floating) {
                    this.renderer.removeClass(this.el.nativeElement, 'btn');
                    this.renderer.addClass(this.el.nativeElement, floatingClass);
                }
            };
        MdbBtnDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbBtn]'
                    },] }
        ];
        /** @nocollapse */
        MdbBtnDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbBtnDirective.propDecorators = {
            color: [{ type: i0.Input }],
            rounded: [{ type: i0.Input }],
            gradient: [{ type: i0.Input }],
            outline: [{ type: i0.Input }],
            flat: [{ type: i0.Input }],
            size: [{ type: i0.Input }],
            block: [{ type: i0.Input }],
            floating: [{ type: i0.Input }]
        };
        return MdbBtnDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO: config: activeClass - Class to apply to the checked buttons
    /** @type {?} */
    var CHECKBOX_CONTROL_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(( /**
         * @return {?}
         */function () { return ButtonCheckboxDirective; })),
        multi: true
    };
    /**
     * Add checkbox functionality to any element
     */
    var ButtonCheckboxDirective = /** @class */ (function () {
        function ButtonCheckboxDirective() {
            /**
             * Truthy value, will be set to ngModel
             */
            this.btnCheckboxTrue = true;
            /**
             * Falsy value, will be set to ngModel
             */
            this.btnCheckboxFalse = false;
            this.state = false;
            this.onChange = Function.prototype;
            this.onTouched = Function.prototype;
        }
        // view -> model
        // view -> model
        /**
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.onClick =
            // view -> model
            /**
             * @return {?}
             */
            function () {
                if (this.isDisabled) {
                    return;
                }
                this.toggle(!this.state);
                this.onChange(this.value);
            };
        /**
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.toggle(this.trueValue === this.value);
            };
        Object.defineProperty(ButtonCheckboxDirective.prototype, "trueValue", {
            get: /**
             * @protected
             * @return {?}
             */ function () {
                return typeof this.btnCheckboxTrue !== 'undefined'
                    ? this.btnCheckboxTrue
                    : true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ButtonCheckboxDirective.prototype, "falseValue", {
            get: /**
             * @protected
             * @return {?}
             */ function () {
                return typeof this.btnCheckboxFalse !== 'undefined'
                    ? this.btnCheckboxFalse
                    : false;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} state
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.toggle = /**
         * @param {?} state
         * @return {?}
         */
            function (state) {
                this.state = state;
                this.value = this.state ? this.trueValue : this.falseValue;
            };
        // ControlValueAccessor
        // model -> view
        // ControlValueAccessor
        // model -> view
        /**
         * @param {?} value
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.writeValue =
            // ControlValueAccessor
            // model -> view
            /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.state = this.trueValue === value;
                this.value = value ? this.trueValue : this.falseValue;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.isDisabled = isDisabled;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ButtonCheckboxDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        ButtonCheckboxDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[mdbCheckbox]', providers: [CHECKBOX_CONTROL_VALUE_ACCESSOR] },] }
        ];
        ButtonCheckboxDirective.propDecorators = {
            btnCheckboxTrue: [{ type: i0.Input }],
            btnCheckboxFalse: [{ type: i0.Input }],
            state: [{ type: i0.HostBinding, args: ['class.active',] }],
            onClick: [{ type: i0.HostListener, args: ['click',] }]
        };
        return ButtonCheckboxDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var RADIO_CONTROL_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(( /**
         * @return {?}
         */function () { return ButtonRadioDirective; })),
        multi: true
    };
    /**
     * Create radio buttons or groups of buttons.
     * A value of a selected button is bound to a variable specified via ngModel.
     */
    var ButtonRadioDirective = /** @class */ (function () {
        function ButtonRadioDirective(el, renderer) {
            this.renderer = renderer;
            this.onChange = Function.prototype;
            this.onTouched = Function.prototype;
            this.radioElementsArray = [];
            this.el = el;
        }
        Object.defineProperty(ButtonRadioDirective.prototype, "isActive", {
            get: /**
             * @return {?}
             */ function () {
                return this.mdbRadio === this.value;
            },
            enumerable: true,
            configurable: true
        });
        // @HostBinding('class.active')
        // @HostBinding('class.active')
        /**
         * @param {?=} event
         * @return {?}
         */
        ButtonRadioDirective.prototype.onClick =
            // @HostBinding('class.active')
            /**
             * @param {?=} event
             * @return {?}
             */
            function (event) {
                var _this = this;
                try {
                    this.el.nativeElement.parentElement.childNodes.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        _this.radioElementsArray.push(element);
                    }));
                    this.radioElementsArray.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        _this.renderer.removeClass(element, 'active');
                    }));
                    this.renderer.addClass(event.target, 'active');
                }
                catch (error) {
                }
                if (this.el.nativeElement.attributes.disabled) {
                    return;
                }
                if (this.uncheckable && this.mdbRadio === this.value) {
                    this.value = undefined;
                }
                else {
                    this.value = this.mdbRadio;
                }
                this.onTouched();
                this.onChange(this.value);
            };
        /**
         * @return {?}
         */
        ButtonRadioDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.uncheckable = typeof this.uncheckable !== 'undefined';
            };
        /**
         * @return {?}
         */
        ButtonRadioDirective.prototype.onBlur = /**
         * @return {?}
         */
            function () {
                this.onTouched();
            };
        // ControlValueAccessor
        // model -> view
        // ControlValueAccessor
        // model -> view
        /**
         * @param {?} value
         * @return {?}
         */
        ButtonRadioDirective.prototype.writeValue =
            // ControlValueAccessor
            // model -> view
            /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.value = value;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ButtonRadioDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ButtonRadioDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        ButtonRadioDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[mdbRadio]', providers: [RADIO_CONTROL_VALUE_ACCESSOR] },] }
        ];
        /** @nocollapse */
        ButtonRadioDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        ButtonRadioDirective.propDecorators = {
            mdbRadio: [{ type: i0.Input }],
            uncheckable: [{ type: i0.Input }],
            value: [{ type: i0.Input }],
            isActive: [{ type: i0.HostBinding, args: ['class.active',] }],
            onClick: [{ type: i0.HostListener, args: ['click', ['$event'],] }]
        };
        return ButtonRadioDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FixedButtonCaptionDirective = /** @class */ (function () {
        function FixedButtonCaptionDirective(renderer, el) {
            this.renderer = renderer;
            this.el = el;
        }
        /**
         * @return {?}
         */
        FixedButtonCaptionDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.createCaptionElement();
            };
        /**
         * @return {?}
         */
        FixedButtonCaptionDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.renderer.listen(this.collapseButtonActivator, 'click', ( /**
                 * @return {?}
                 */function () {
                    _this.renderer.addClass(_this.paragraphEl, 'fixed-button-caption');
                    _this.renderer.setStyle(_this.paragraphEl, 'position', 'absolute');
                    _this.renderer.setStyle(_this.paragraphEl, 'right', "60px");
                    _this.renderer.setStyle(_this.paragraphEl, 'top', '10px');
                    _this.renderer.setStyle(_this.el.nativeElement, 'overflow', 'visible');
                }));
            };
        /**
         * @return {?}
         */
        FixedButtonCaptionDirective.prototype.createCaptionElement = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var paragraph = this.renderer.createElement('p');
                /** @type {?} */
                var text = this.renderer.createText(this.caption);
                this.renderer.appendChild(paragraph, text);
                this.renderer.appendChild(this.el.nativeElement, paragraph);
                this.paragraphEl = paragraph;
            };
        FixedButtonCaptionDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[mdbFixedCaption]' },] }
        ];
        /** @nocollapse */
        FixedButtonCaptionDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef }
            ];
        };
        FixedButtonCaptionDirective.propDecorators = {
            caption: [{ type: i0.Input, args: ['mdbFixedCaption',] }],
            collapseButtonActivator: [{ type: i0.Input, args: ['collapseButton',] }]
        };
        return FixedButtonCaptionDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonsModule = /** @class */ (function () {
        function ButtonsModule() {
        }
        /**
         * @return {?}
         */
        ButtonsModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: ButtonsModule, providers: [] };
            };
        ButtonsModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [ButtonCheckboxDirective, ButtonRadioDirective, MdbBtnDirective, FixedButtonCaptionDirective],
                        exports: [ButtonCheckboxDirective, ButtonRadioDirective, MdbBtnDirective, FixedButtonCaptionDirective]
                    },] }
        ];
        return ButtonsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardFooterComponent = /** @class */ (function () {
        function MdbCardFooterComponent(_el, _r) {
            this._el = _el;
            this._r = _r;
        }
        /**
         * @return {?}
         */
        MdbCardFooterComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._r.addClass(this._el.nativeElement, 'card-footer');
                if (this.class) {
                    this.class.split(' ').forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        _this._r.addClass(_this._el.nativeElement, element);
                    }));
                }
            };
        MdbCardFooterComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card-footer',
                        template: "<ng-content></ng-content>\n",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        MdbCardFooterComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbCardFooterComponent.propDecorators = {
            class: [{ type: i0.Input }]
        };
        return MdbCardFooterComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardTitleComponent = /** @class */ (function () {
        function MdbCardTitleComponent(_el, _r) {
            this._el = _el;
            this._r = _r;
        }
        /**
         * @return {?}
         */
        MdbCardTitleComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this._r.addClass(this._el.nativeElement, 'card-title');
            };
        MdbCardTitleComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card-title',
                        template: "<ng-content></ng-content>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        MdbCardTitleComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        return MdbCardTitleComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardTextComponent = /** @class */ (function () {
        function MdbCardTextComponent() {
        }
        MdbCardTextComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card-text',
                        template: "<p class=\"card-text {{class}} \">\n    <ng-content></ng-content>\n</p>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        MdbCardTextComponent.propDecorators = {
            class: [{ type: i0.Input }]
        };
        return MdbCardTextComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardBodyComponent = /** @class */ (function () {
        function MdbCardBodyComponent(_el, _r) {
            this._el = _el;
            this._r = _r;
        }
        Object.defineProperty(MdbCardBodyComponent.prototype, "cascade", {
            set: /**
             * @param {?} cascade
             * @return {?}
             */ function (cascade) {
                if (cascade) {
                    this._r.addClass(this._el.nativeElement, 'card-body-cascade');
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MdbCardBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._r.addClass(this._el.nativeElement, 'card-body');
                if (this.class) {
                    this.class.split(' ').forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        _this._r.addClass(_this._el.nativeElement, element);
                    }));
                }
            };
        MdbCardBodyComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card-body',
                        template: "\n    <ng-content></ng-content>\n",
                        encapsulation: i0.ViewEncapsulation.None,
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        MdbCardBodyComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbCardBodyComponent.propDecorators = {
            class: [{ type: i0.Input }],
            cascade: [{ type: i0.Input }]
        };
        return MdbCardBodyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardComponent = /** @class */ (function () {
        function MdbCardComponent(_el, _r) {
            this._el = _el;
            this._r = _r;
        }
        Object.defineProperty(MdbCardComponent.prototype, "narrower", {
            set: /**
             * @param {?} narrower
             * @return {?}
             */ function (narrower) {
                if (narrower) {
                    this._r.addClass(this._el.nativeElement, 'narrower');
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MdbCardComponent.prototype, "reverse", {
            set: /**
             * @param {?} reverse
             * @return {?}
             */ function (reverse) {
                if (reverse) {
                    this._r.addClass(this._el.nativeElement, 'reverse');
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MdbCardComponent.prototype, "dark", {
            set: /**
             * @param {?} dark
             * @return {?}
             */ function (dark) {
                if (dark) {
                    this._r.addClass(this._el.nativeElement, 'card-dark');
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MdbCardComponent.prototype, "bgColor", {
            set: /**
             * @param {?} color
             * @return {?}
             */ function (color) {
                if (color) {
                    this._r.addClass(this.card.nativeElement, color);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MdbCardComponent.prototype, "borderColor", {
            set: /**
             * @param {?} color
             * @return {?}
             */ function (color) {
                if (color) {
                    this._r.addClass(this.card.nativeElement, color);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MdbCardComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._r.addClass(this._el.nativeElement, 'card');
                if (this.cascade) {
                    this._r.addClass(this._el.nativeElement, 'card-cascade');
                }
                if (this.wider) {
                    this._r.addClass(this._el.nativeElement, 'wider');
                }
                if (this.narrower) {
                    this._r.addClass(this._el.nativeElement, 'narrower');
                }
                if (this.class) {
                    this.class.split(' ').forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        _this._r.addClass(_this._el.nativeElement, element);
                    }));
                }
                if (this._el.nativeElement.parentElement.classList.contains('card-deck')) {
                    this._r.addClass(this.card.nativeElement, 'w-100');
                    this._r.addClass(this.card.nativeElement, 'mx-0');
                }
            };
        MdbCardComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card',
                        template: "<div class=\"card\" [ngClass]=\"{'card-cascade': cascade, 'wider': wider}\" #card>\n    <ng-content></ng-content>\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        MdbCardComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbCardComponent.propDecorators = {
            class: [{ type: i0.Input }],
            cascade: [{ type: i0.Input }],
            wider: [{ type: i0.Input }],
            card: [{ type: i0.ViewChild, args: ['card',] }],
            narrower: [{ type: i0.Input }],
            reverse: [{ type: i0.Input }],
            dark: [{ type: i0.Input }],
            bgColor: [{ type: i0.Input }],
            borderColor: [{ type: i0.Input }]
        };
        return MdbCardComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardImageComponent = /** @class */ (function () {
        function MdbCardImageComponent() {
        }
        MdbCardImageComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card-img',
                        template: "<img class=\"img-fluid\" [src]=\"src\" [alt]=\"alt\">",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        MdbCardImageComponent.propDecorators = {
            src: [{ type: i0.Input }],
            alt: [{ type: i0.Input }]
        };
        return MdbCardImageComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbCardHeaderComponent = /** @class */ (function () {
        function MdbCardHeaderComponent(_el, _r) {
            this._el = _el;
            this._r = _r;
        }
        /**
         * @return {?}
         */
        MdbCardHeaderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._r.addClass(this._el.nativeElement, 'card-header');
                if (this.class) {
                    this.class.split(' ').forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        _this._r.addClass(_this._el.nativeElement, element);
                    }));
                }
            };
        MdbCardHeaderComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-card-header',
                        template: "<ng-content></ng-content>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        MdbCardHeaderComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbCardHeaderComponent.propDecorators = {
            class: [{ type: i0.Input }]
        };
        return MdbCardHeaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CardsFreeModule = /** @class */ (function () {
        function CardsFreeModule() {
        }
        /**
         * @return {?}
         */
        CardsFreeModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: CardsFreeModule, providers: [] };
            };
        CardsFreeModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [
                            MdbCardComponent,
                            MdbCardBodyComponent,
                            MdbCardImageComponent,
                            MdbCardTextComponent,
                            MdbCardTitleComponent,
                            MdbCardFooterComponent,
                            MdbCardHeaderComponent
                        ],
                        exports: [
                            MdbCardComponent,
                            MdbCardBodyComponent,
                            MdbCardImageComponent,
                            MdbCardTextComponent,
                            MdbCardTitleComponent,
                            MdbCardFooterComponent,
                            MdbCardHeaderComponent
                        ]
                    },] }
        ];
        return CardsFreeModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /*tslint:disable */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * JS version of browser APIs. This library can only run in the browser.
     * @type {?}
     */
    var win = typeof window !== 'undefined' && window || ( /** @type {?} */({}));
    /** @type {?} */
    var document$1 = win.document;
    /** @type {?} */
    var location = win.location;
    /** @type {?} */
    var gc = win['gc'] ? ( /**
     * @return {?}
     */function () { return win['gc'](); }) : ( /**
     * @return {?}
     */function () { return null; });
    /** @type {?} */
    var performance = win['performance'] ? win['performance'] : null;
    /** @type {?} */
    var Event = win['Event'];
    /** @type {?} */
    var MouseEvent = win['MouseEvent'];
    /** @type {?} */
    var KeyboardEvent = win['KeyboardEvent'];
    /** @type {?} */
    var EventTarget = win['EventTarget'];
    /** @type {?} */
    var History = win['History'];
    /** @type {?} */
    var Location = win['Location'];
    /** @type {?} */
    var EventListener = win['EventListener'];
    /** @type {?} */
    var navigator$1 = win['navigator'];

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function isBs3() {
        return win.__theme === 'bs4';
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // import { CarouselComponent } from './carousel.component';
    var SlideComponent = /** @class */ (function () {
        function SlideComponent(el) {
            this.animated = false;
            this.directionNext = false;
            this.directionLeft = false;
            this.directionPrev = false;
            this.directionRight = false;
            /**
             * Wraps element by appropriate CSS classes
             */
            this.el = null;
            // this.carousel = carousel;
            this.el = el;
        }
        /** Fires changes in container collection after adding a new slide instance */
        /**
         * Fires changes in container collection after adding a new slide instance
         * @return {?}
         */
        SlideComponent.prototype.ngOnInit = /**
         * Fires changes in container collection after adding a new slide instance
         * @return {?}
         */
            function () {
                // this.carousel.addSlide(this);
            };
        /** Fires changes in container collection after removing of this slide instance */
        /**
         * Fires changes in container collection after removing of this slide instance
         * @return {?}
         */
        SlideComponent.prototype.ngOnDestroy = /**
         * Fires changes in container collection after removing of this slide instance
         * @return {?}
         */
            function () {
                // this.carousel.removeSlide(this);
            };
        SlideComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-slide, mdb-carousel-item',
                        template: "\n  <ng-content></ng-content>\n  "
                    }] }
        ];
        /** @nocollapse */
        SlideComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        SlideComponent.propDecorators = {
            active: [{ type: i0.HostBinding, args: ['class.active',] }, { type: i0.Input }],
            animated: [{ type: i0.HostBinding, args: ['class.animated',] }],
            directionNext: [{ type: i0.HostBinding, args: ['class.carousel-item-next',] }],
            directionLeft: [{ type: i0.HostBinding, args: ['class.carousel-item-left',] }],
            directionPrev: [{ type: i0.HostBinding, args: ['class.carousel-item-prev',] }],
            directionRight: [{ type: i0.HostBinding, args: ['class.carousel-item-right',] }],
            el: [{ type: i0.HostBinding, args: ['class.carousel-item',] }]
        };
        return SlideComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CarouselConfig = /** @class */ (function () {
        function CarouselConfig() {
            /**
             * Default interval of auto changing of slides
             */
            this.interval = 5000;
            /**
             * Is loop of auto changing of slides can be paused
             */
            this.noPause = false;
            /**
             * Is slides can wrap from the last to the first slide
             */
            this.noWrap = false;
            this.keyboard = false;
        }
        CarouselConfig.decorators = [
            { type: i0.Injectable }
        ];
        return CarouselConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var Direction = {
        UNKNOWN: 0, NEXT: 1, PREV: 2,
    };
    Direction[Direction.UNKNOWN] = 'UNKNOWN';
    Direction[Direction.NEXT] = 'NEXT';
    Direction[Direction.PREV] = 'PREV';
    /**
     * Base element to create carousel
     */
    var CarouselComponent = /** @class */ (function () {
        function CarouselComponent(config, el, platformId, cdRef, renderer) {
            this.cdRef = cdRef;
            this.renderer = renderer;
            this.SWIPE_ACTION = { LEFT: 'swipeleft', RIGHT: 'swiperight' };
            this.destroyed = false;
            this.el = null;
            this.animationEnd = true;
            this.isBrowser = false;
            this.isControls = true;
            this.class = '';
            this.type = '';
            this.animation = '';
            this.activeSlideChange = new i0.EventEmitter(false);
            this.isBrowser = common.isPlatformBrowser(platformId);
            Object.assign(this, config);
            this.el = el;
        }
        Object.defineProperty(CarouselComponent.prototype, "slides", {
            get: /**
             * @return {?}
             */ function () {
                return this._slidesList.toArray();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CarouselComponent.prototype, "activeSlide", {
            get: /**
             * @return {?}
             */ function () {
                return this._currentActiveSlide;
            },
            set: /**
             * @param {?} index
             * @return {?}
             */ function (index) {
                if (this._slidesList && index !== this._currentActiveSlide) {
                    this._select(index);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CarouselComponent.prototype.checkNavigation = /**
         * @return {?}
         */
            function () {
                if (this.type === 'carousel-multi-item') {
                    return false;
                }
                return true;
            };
        /**
         * @return {?}
         */
        CarouselComponent.prototype.checkDots = /**
         * @return {?}
         */
            function () {
                if (this.type === 'carousel-thumbnails') {
                    return false;
                }
                return true;
            };
        /**
         * @param {?} slide
         * @return {?}
         */
        CarouselComponent.prototype.getImg = /**
         * @param {?} slide
         * @return {?}
         */
            function (slide) {
                return slide.el.nativeElement.querySelector('img').src;
            };
        Object.defineProperty(CarouselComponent.prototype, "interval", {
            get: /**
             * @return {?}
             */ function () {
                return this._interval;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._interval = value;
                this.restartTimer();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CarouselComponent.prototype, "isBs4", {
            get: /**
             * @return {?}
             */ function () {
                return !isBs3();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CarouselComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.destroyed = true;
            };
        /**
         * @return {?}
         */
        CarouselComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._slidesList.changes.subscribe(( /**
                 * @param {?} slidesList
                 * @return {?}
                 */function (slidesList) {
                    _this._slidesList = slidesList;
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this._select(0);
                    }), 0);
                }));
                if (this.activeSlideIndex) {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this._select(_this.activeSlideIndex);
                        _this.activeSlideChange.emit({ 'relatedTarget': _this.activeSlide });
                    }), 0);
                }
                else {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this._select(0);
                    }), 0);
                }
                if (this.isControls) {
                    this.carouselIndicators = this.el.nativeElement.querySelectorAll('.carousel-indicators > li');
                    if (this.carouselIndicators.length && this.activeSlideIndex) {
                        this.renderer.addClass(this.carouselIndicators[this.activeSlideIndex], 'active');
                    }
                    else if (this.carouselIndicators.length) {
                        this.renderer.addClass(this.carouselIndicators[0], 'active');
                    }
                }
            };
        /**
         * @param {?=} action
         * @return {?}
         */
        CarouselComponent.prototype.swipe = /**
         * @param {?=} action
         * @return {?}
         */
            function (action) {
                if (action === void 0) {
                    action = this.SWIPE_ACTION.RIGHT;
                }
                if (action === this.SWIPE_ACTION.RIGHT) {
                    this.previousSlide();
                    this.cdRef.markForCheck();
                }
                if (action === this.SWIPE_ACTION.LEFT) {
                    this.nextSlide();
                    this.cdRef.markForCheck();
                }
            };
        /**
         * @param {?=} force
         * @return {?}
         */
        CarouselComponent.prototype.nextSlide = /**
         * @param {?=} force
         * @return {?}
         */
            function (force) {
                if (force === void 0) {
                    force = false;
                }
                if (this.animation === 'slide') {
                    this.pause();
                    /** @type {?} */
                    var direction = Direction.NEXT;
                    this.slideAnimation(this.findNextSlideIndex(direction, force), direction);
                    this.cdRef.markForCheck();
                }
                else if (this.animation === 'fade') {
                    this.pause();
                    this.fadeAnimation(this.findNextSlideIndex(Direction.NEXT, force), Direction.NEXT);
                    this.cdRef.markForCheck();
                }
                else {
                    this.activeSlide = this.findNextSlideIndex(Direction.NEXT, force);
                    this.cdRef.markForCheck();
                }
                if (!this.animation) {
                    this.activeSlideChange.emit({ 'direction': 'Next', 'relatedTarget': this.activeSlide });
                }
            };
        /**
         * @param {?=} force
         * @return {?}
         */
        CarouselComponent.prototype.previousSlide = /**
         * @param {?=} force
         * @return {?}
         */
            function (force) {
                if (force === void 0) {
                    force = false;
                }
                if (this.animation === 'slide') {
                    this.pause();
                    /** @type {?} */
                    var direction = Direction.PREV;
                    this.slideAnimation(this.findNextSlideIndex(direction, force), direction);
                    this.cdRef.markForCheck();
                }
                else if (this.animation === 'fade') {
                    this.pause();
                    this.fadeAnimation(this.findNextSlideIndex(Direction.PREV, force), Direction.PREV);
                    this.cdRef.markForCheck();
                }
                else {
                    this.activeSlide = this.findNextSlideIndex(Direction.PREV, force);
                    this.cdRef.markForCheck();
                }
                if (!this.animation) {
                    this.activeSlideChange.emit({ 'direction': 'Prev', 'relatedTarget': this.activeSlide });
                }
            };
        /**
         * @protected
         * @param {?} goToIndex
         * @param {?=} direction
         * @return {?}
         */
        CarouselComponent.prototype.fadeAnimation = /**
         * @protected
         * @param {?} goToIndex
         * @param {?=} direction
         * @return {?}
         */
            function (goToIndex, direction) {
                var _this = this;
                /** @type {?} */
                var goToSlide = this.slides[goToIndex];
                if (this.animationEnd) {
                    this.animationEnd = false;
                    goToSlide.directionNext = true;
                    if (this.isBrowser) {
                        setTimeout(( /**
                         * @return {?}
                         */function () {
                            /** @type {?} */
                            var previous = _this.slides[_this._currentActiveSlide].el.nativeElement;
                            _this.renderer.setStyle(previous, 'opacity', '0');
                            _this.renderer.setStyle(previous, 'transition', 'all 600ms');
                            _this.renderer.setStyle(previous, 'display', 'block');
                            _this.renderer.setStyle(goToSlide.el.nativeElement, 'display', 'block');
                            _this.renderer.setStyle(goToSlide.el.nativeElement, 'opacity', '1');
                            _this.renderer.setStyle(goToSlide.el.nativeElement, 'transition', 'all 600ms');
                            if (direction === 1) {
                                _this.activeSlideChange.emit({ 'direction': 'Next', 'relatedTarget': _this.activeSlide });
                            }
                            else if (direction === 2) {
                                _this.activeSlideChange.emit({ 'direction': 'Prev', 'relatedTarget': _this.activeSlide });
                            }
                            goToSlide.directionNext = false;
                            _this.animationEnd = true;
                            _this.activeSlide = goToIndex;
                            _this.activeSlideChange.emit({ 'direction': 'Next', 'relatedTarget': _this.activeSlide });
                            _this.play();
                            _this.cdRef.markForCheck();
                        }), 0);
                    }
                }
            };
        /**
         * @protected
         * @param {?} goToIndex
         * @param {?} direction
         * @return {?}
         */
        CarouselComponent.prototype.slideAnimation = /**
         * @protected
         * @param {?} goToIndex
         * @param {?} direction
         * @return {?}
         */
            function (goToIndex, direction) {
                var _this = this;
                /** @type {?} */
                var currentSlide = this.slides[this._currentActiveSlide];
                /** @type {?} */
                var goToSlide = this.slides[goToIndex];
                if (this.animationEnd) {
                    if (direction === Direction.NEXT) {
                        this.animationEnd = false;
                        goToSlide.directionNext = true;
                        if (this.isBrowser) {
                            setTimeout(( /**
                             * @return {?}
                             */function () {
                                goToSlide.directionLeft = true;
                                currentSlide.directionLeft = true;
                                _this.cdRef.markForCheck();
                            }), 100);
                        }
                    }
                    if (direction === Direction.PREV) {
                        this.animationEnd = false;
                        goToSlide.directionPrev = true;
                        if (this.isBrowser) {
                            setTimeout(( /**
                             * @return {?}
                             */function () {
                                goToSlide.directionRight = true;
                                currentSlide.directionRight = true;
                                _this.cdRef.markForCheck();
                            }), 100);
                        }
                    }
                    if (this.isBrowser) {
                        setTimeout(( /**
                         * @return {?}
                         */function () {
                            goToSlide.directionLeft = false;
                            goToSlide.directionNext = false;
                            currentSlide.directionLeft = false;
                            currentSlide.directionNext = false;
                            goToSlide.directionRight = false;
                            goToSlide.directionPrev = false;
                            currentSlide.directionRight = false;
                            currentSlide.directionPrev = false;
                            _this.animationEnd = true;
                            _this.activeSlide = goToIndex;
                            /** @type {?} */
                            var directionName;
                            if (direction === Direction.NEXT) {
                                directionName = 'Next';
                            }
                            else if (direction === Direction.PREV) {
                                directionName = 'Prev';
                            }
                            _this.activeSlideChange.emit({ 'direction': directionName, 'relatedTarget': _this.activeSlide });
                            _this.play();
                            _this.cdRef.markForCheck();
                        }), 700);
                    }
                }
            };
        /**
         * @param {?} index
         * @return {?}
         */
        CarouselComponent.prototype.selectSlide = /**
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this.pause();
                if (this.animation === 'slide') {
                    if (this.activeSlide < index) {
                        this.slideAnimation(index, Direction.NEXT);
                    }
                    else if (this.activeSlide > index) {
                        this.slideAnimation(index, Direction.PREV);
                    }
                }
                else if (this.animation === 'fade') {
                    if (index !== this.activeSlide) {
                        this.fadeAnimation(index);
                    }
                }
                this.play();
            };
        /**
         * @return {?}
         */
        CarouselComponent.prototype.play = /**
         * @return {?}
         */
            function () {
                if (!this.isPlaying) {
                    this.isPlaying = true;
                    this.restartTimer();
                }
            };
        /**
         * @return {?}
         */
        CarouselComponent.prototype.pause = /**
         * @return {?}
         */
            function () {
                if (!this.noPause) {
                    this.isPlaying = false;
                    this.resetTimer();
                }
            };
        /**
         * @return {?}
         */
        CarouselComponent.prototype.getCurrentSlideIndex = /**
         * @return {?}
         */
            function () {
                return this.slides.findIndex(( /**
                 * @param {?} slide
                 * @return {?}
                 */function (slide) { return slide.active; }));
            };
        /**
         * @param {?} index
         * @return {?}
         */
        CarouselComponent.prototype.isLast = /**
         * @param {?} index
         * @return {?}
         */
            function (index) {
                return index + 1 >= this.slides.length;
            };
        /**
         * @private
         * @param {?} direction
         * @param {?} force
         * @return {?}
         */
        CarouselComponent.prototype.findNextSlideIndex = /**
         * @private
         * @param {?} direction
         * @param {?} force
         * @return {?}
         */
            function (direction, force) {
                /** @type {?} */
                var nextSlideIndex = 0;
                if (!force && (this.isLast(this.activeSlide) && direction !== Direction.PREV && this.noWrap)) {
                    return void 0;
                }
                switch (direction) {
                    case Direction.NEXT:
                        nextSlideIndex = (!this.isLast(this._currentActiveSlide)) ? this._currentActiveSlide + 1 :
                            (!force && this.noWrap) ? this._currentActiveSlide : 0;
                        break;
                    case Direction.PREV:
                        nextSlideIndex = (this._currentActiveSlide > 0) ? this._currentActiveSlide - 1 :
                            (!force && this.noWrap) ? this._currentActiveSlide : this.slides.length - 1;
                        break;
                    default:
                        throw new Error('Unknown direction');
                }
                return nextSlideIndex;
            };
        /**
         * @private
         * @param {?} index
         * @return {?}
         */
        CarouselComponent.prototype._select = /**
         * @private
         * @param {?} index
         * @return {?}
         */
            function (index) {
                if (isNaN(index)) {
                    this.pause();
                    return;
                }
                /** @type {?} */
                var currentSlide = this.slides[this._currentActiveSlide];
                if (currentSlide) {
                    currentSlide.active = false;
                }
                /** @type {?} */
                var nextSlide = this.slides[index];
                if (nextSlide) {
                    this._currentActiveSlide = index;
                    nextSlide.active = true;
                    this.activeSlide = index;
                }
            };
        /**
         * @private
         * @return {?}
         */
        CarouselComponent.prototype.restartTimer = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this.resetTimer();
                if (this.isBrowser) {
                    /** @type {?} */
                    var interval = +this.interval;
                    if (!isNaN(interval) && interval > 0) {
                        this.currentInterval = setInterval(( /**
                         * @return {?}
                         */function () {
                            /** @type {?} */
                            var nInterval = +_this.interval;
                            if (_this.isPlaying && !isNaN(_this.interval) && nInterval > 0 && _this.slides.length) {
                                _this.nextSlide();
                            }
                            else {
                                _this.pause();
                            }
                        }), interval);
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        CarouselComponent.prototype.resetTimer = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.isBrowser) {
                    if (this.currentInterval) {
                        clearInterval(this.currentInterval);
                        this.currentInterval = void 0;
                    }
                }
            };
        /**
         * @protected
         * @param {?} el
         * @param {?} className
         * @return {?}
         */
        CarouselComponent.prototype.hasClass = /**
         * @protected
         * @param {?} el
         * @param {?} className
         * @return {?}
         */
            function (el, className) {
                if (el.classList) {
                    return el.classList.contains(className);
                }
                else {
                    return !!el.className.match(new RegExp('(\\s|^)' + className + '(\\s|$)'));
                }
            };
        /**
         * @protected
         * @param {?} el
         * @param {?} className
         * @return {?}
         */
        CarouselComponent.prototype.classAdd = /**
         * @protected
         * @param {?} el
         * @param {?} className
         * @return {?}
         */
            function (el, className) {
                if (el.classList) {
                    el.classList.add(className);
                }
                else if (!this.hasClass(el, className)) {
                    el.className += ' ' + className;
                }
            };
        /**
         * @protected
         * @param {?} el
         * @param {?} className
         * @return {?}
         */
        CarouselComponent.prototype.removeClass = /**
         * @protected
         * @param {?} el
         * @param {?} className
         * @return {?}
         */
            function (el, className) {
                if (el.classList) {
                    el.classList.remove(className);
                }
                else if (this.hasClass(el, className)) {
                    /** @type {?} */
                    var reg = new RegExp('(\\s|^)' + className + '(\\s|$)');
                    el.className = el.className.replace(reg, ' ');
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        CarouselComponent.prototype.keyboardControl = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.keyboard) {
                    if (event.keyCode === 39) {
                        this.nextSlide();
                    }
                    if (event.keyCode === 37) {
                        this.previousSlide();
                    }
                }
            };
        /**
         * @return {?}
         */
        CarouselComponent.prototype.focus = /**
         * @return {?}
         */
            function () {
                this.el.nativeElement.focus();
            };
        CarouselComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-carousel',
                        template: "<div tabindex=\"0\" (swipeleft)=\"swipe($event.type)\" (swiperight)=\"swipe($event.type)\" (mouseenter)=\"pause()\" (mouseleave)=\"play()\" (mouseup)=\"play()\" class=\"carousel {{ class }} {{ type }}\">\n  <div class=\"controls-top\" *ngIf=\"slides.length > 1 && !checkNavigation() && isControls\">\n    <a class=\"btn-floating\" [class.disabled]=\"activeSlide===0&&noWrap\" (click)=\"previousSlide()\"><i class=\"fas fa-chevron-left\"></i></a>\n    <a class=\"btn-floating\" (click)=\"nextSlide()\" [class.disabled]=\"isLast(activeSlide) && noWrap\"><i class=\"fas fa-chevron-right\"></i></a>\n  </div>\n  <ol class=\"carousel-indicators\" *ngIf=\"slides.length > 1 && checkDots() && isControls\">\n    <li *ngFor=\"let slidez of slides; let i = index;\" [class.active]=\"slidez.active === true\" (click)=\"selectSlide(i)\"></li>\n  </ol>\n  <ol class=\"carousel-indicators\" *ngIf=\"slides.length > 1 && !checkDots() && isControls\">\n    <li *ngFor=\"let slidez of slides; let i = index;\" [class.active]=\"slidez.active === true\" (click)=\"selectSlide(i)\">\n      <img  class=\"d-block w-100 img-fluid\" src=\"{{ getImg(slidez) }}\">\n    </li>\n  </ol>\n  <div class=\"carousel-inner\"><ng-content></ng-content></div>\n  <a class=\"carousel-control-prev\" [class.disabled]=\"activeSlide === 0 && noWrap\" (click)=\"previousSlide()\" *ngIf=\"slides.length > 1 && checkNavigation() && isControls\">\n    <span class=\"carousel-control-prev-icon\" aria-hidden=\"true\"></span>\n    <span  class=\"sr-only\">Previous</span>\n  </a>\n  <a class=\"carousel-control-next\" (click)=\"nextSlide()\" [class.disabled]=\"isLast(activeSlide) && noWrap\" *ngIf=\"slides.length > 1 && checkNavigation() && isControls\">\n    <span class=\"carousel-control-next-icon\" aria-hidden=\"true\"></span>\n    <span class=\"sr-only\">Next</span>\n  </a>\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        CarouselComponent.ctorParameters = function () {
            return [
                { type: CarouselConfig },
                { type: i0.ElementRef },
                { type: String, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] },
                { type: i0.ChangeDetectorRef },
                { type: i0.Renderer2 }
            ];
        };
        CarouselComponent.propDecorators = {
            _slidesList: [{ type: i0.ContentChildren, args: [SlideComponent,] }],
            noWrap: [{ type: i0.Input }],
            noPause: [{ type: i0.Input }],
            isControls: [{ type: i0.Input }],
            keyboard: [{ type: i0.Input }],
            class: [{ type: i0.Input }],
            type: [{ type: i0.Input }],
            animation: [{ type: i0.Input }],
            activeSlideIndex: [{ type: i0.Input }],
            activeSlideChange: [{ type: i0.Output }],
            activeSlide: [{ type: i0.Input }],
            interval: [{ type: i0.Input }],
            play: [{ type: i0.HostListener, args: ['mouseleave',] }],
            pause: [{ type: i0.HostListener, args: ['mouseenter',] }],
            keyboardControl: [{ type: i0.HostListener, args: ['keyup', ['$event'],] }],
            focus: [{ type: i0.HostListener, args: ['click',] }]
        };
        return CarouselComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CarouselModule = /** @class */ (function () {
        function CarouselModule() {
        }
        /**
         * @return {?}
         */
        CarouselModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: CarouselModule, providers: [] };
            };
        CarouselModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [SlideComponent, CarouselComponent],
                        exports: [SlideComponent, CarouselComponent],
                        providers: [CarouselConfig]
                    },] }
        ];
        return CarouselModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BaseChartDirective = /** @class */ (function () {
        function BaseChartDirective(element, platformId) {
            this.labels = [];
            this.options = {
                legend: { display: false }
            };
            this.legend = false;
            this.chartClick = new i0.EventEmitter();
            this.chartHover = new i0.EventEmitter();
            this.initFlag = false;
            this.isBrowser = false;
            this.element = element;
            this.isBrowser = common.isPlatformBrowser(platformId);
        }
        /**
         * @return {?}
         */
        BaseChartDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.isBrowser) {
                    this.ctx = this.element.nativeElement.getContext('2d');
                    this.cvs = this.element.nativeElement;
                    this.initFlag = true;
                    if (this.data || this.datasets) {
                        this.refresh();
                    }
                }
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        BaseChartDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (this.initFlag) {
                    // Check if the changes are in the data or datasets
                    if ((changes.hasOwnProperty('data') || changes.hasOwnProperty('datasets')) && !changes.hasOwnProperty('labels')) {
                        if (changes['data']) {
                            this.updateChartData(changes['data'].currentValue);
                        }
                        else {
                            this.updateChartData(changes['datasets'].currentValue);
                        }
                        this.chart.update();
                    }
                    else {
                        // otherwise rebuild the chart
                        this.refresh();
                    }
                }
            };
        /**
         * @return {?}
         */
        BaseChartDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.chart) {
                    this.chart.destroy();
                    this.chart = void 0;
                }
            };
        /**
         * @param {?} ctx
         * @return {?}
         */
        BaseChartDirective.prototype.getChartBuilder = /**
         * @param {?} ctx
         * @return {?}
         */
            function (ctx /*, data:Array<any>, options:any*/) {
                var _this = this;
                /** @type {?} */
                var datasets = this.getDatasets();
                /** @type {?} */
                var options = Object.assign({}, this.options);
                if (this.legend === false) {
                    options.legend = { display: false };
                }
                // hock for onHover and onClick events
                options.hover = options.hover || {};
                if (!options.hover.onHover) {
                    options.hover.onHover = ( /**
                     * @param {?} event
                     * @param {?} active
                     * @return {?}
                     */function (event, active) {
                        if (active && active.length) {
                            _this.chartHover.emit({ event: event, active: active });
                        }
                    });
                }
                if (!options.onClick) {
                    options.onClick = ( /**
                     * @param {?} event
                     * @param {?} active
                     * @return {?}
                     */function (event, active) {
                        _this.chartClick.emit({ event: event, active: active });
                    });
                }
                /** @type {?} */
                var opts = {
                    type: this.chartType,
                    data: {
                        labels: this.labels,
                        datasets: datasets
                    },
                    options: options
                };
                return new Chart(ctx, opts);
            };
        /**
         * @private
         * @param {?} newDataValues
         * @return {?}
         */
        BaseChartDirective.prototype.updateChartData = /**
         * @private
         * @param {?} newDataValues
         * @return {?}
         */
            function (newDataValues) {
                if (Array.isArray(newDataValues[0].data)) {
                    this.chart.data.datasets.forEach(( /**
                     * @param {?} dataset
                     * @param {?} i
                     * @return {?}
                     */function (dataset, i) {
                        dataset.data = newDataValues[i].data;
                        if (newDataValues[i].label) {
                            dataset.label = newDataValues[i].label;
                        }
                    }));
                }
                else {
                    this.chart.data.datasets[0].data = newDataValues;
                }
            };
        /**
         * @private
         * @return {?}
         */
        BaseChartDirective.prototype.getDatasets = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var datasets = void 0;
                // in case if datasets is not provided, but data is present
                if (!this.datasets || !this.datasets.length && (this.data && this.data.length)) {
                    if (Array.isArray(this.data[0])) {
                        datasets = (( /** @type {?} */(this.data))).map(( /**
                         * @param {?} data
                         * @param {?} index
                         * @return {?}
                         */function (data, index) {
                            return { data: data, label: _this.labels[index] || "Label " + index };
                        }));
                    }
                    else {
                        datasets = [{ data: this.data, label: "Label 0" }];
                    }
                }
                if (this.datasets && this.datasets.length ||
                    (datasets && datasets.length)) {
                    datasets = (this.datasets || datasets)
                        .map(( /**
                 * @param {?} elm
                 * @param {?} index
                 * @return {?}
                 */function (elm, index) {
                        /** @type {?} */
                        var newElm = Object.assign({}, elm);
                        if (_this.colors && _this.colors.length) {
                            Object.assign(newElm, _this.colors[index]);
                        }
                        else {
                            Object.assign(newElm, getColors(_this.chartType, index, newElm.data.length));
                        }
                        return newElm;
                    }));
                }
                if (!datasets) {
                    throw new Error("ng-charts configuration error,\n      data or datasets field are required to render char " + this.chartType);
                }
                return datasets;
            };
        /**
         * @private
         * @return {?}
         */
        BaseChartDirective.prototype.refresh = /**
         * @private
         * @return {?}
         */
            function () {
                this.ngOnDestroy();
                this.chart = this.getChartBuilder(this.ctx /*, data, this.options*/);
            };
        BaseChartDirective.defaultColors = [
            [255, 99, 132],
            [54, 162, 235],
            [255, 206, 86],
            [231, 233, 237],
            [75, 192, 192],
            [151, 187, 205],
            [220, 220, 220],
            [247, 70, 74],
            [70, 191, 189],
            [253, 180, 92],
            [148, 159, 177],
            [77, 83, 96]
        ];
        BaseChartDirective.decorators = [
            { type: i0.Directive, args: [{ selector: 'canvas[mdbChart]', exportAs: 'mdb-base-chart' },] }
        ];
        /** @nocollapse */
        BaseChartDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: String, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        BaseChartDirective.propDecorators = {
            data: [{ type: i0.Input }],
            datasets: [{ type: i0.Input }],
            labels: [{ type: i0.Input }],
            options: [{ type: i0.Input }],
            chartType: [{ type: i0.Input }],
            colors: [{ type: i0.Input }],
            legend: [{ type: i0.Input }],
            chartClick: [{ type: i0.Output }],
            chartHover: [{ type: i0.Output }]
        };
        return BaseChartDirective;
    }());
    /**
     * @param {?} colour
     * @param {?} alpha
     * @return {?}
     */
    function rgba(colour, alpha) {
        return 'rgba(' + colour.concat(alpha).join(',') + ')';
    }
    /**
     * @param {?} min
     * @param {?} max
     * @return {?}
     */
    function getRandomInt(min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }
    /**
     * @param {?} colors
     * @return {?}
     */
    function formatLineColor(colors) {
        return {
            backgroundColor: rgba(colors, 0.4),
            borderColor: rgba(colors, 1),
            pointBackgroundColor: rgba(colors, 1),
            pointBorderColor: '#fff',
            pointHoverBackgroundColor: '#fff',
            pointHoverBorderColor: rgba(colors, 0.8)
        };
    }
    /**
     * @param {?} colors
     * @return {?}
     */
    function formatBarColor(colors) {
        return {
            backgroundColor: rgba(colors, 0.6),
            borderColor: rgba(colors, 1),
            hoverBackgroundColor: rgba(colors, 0.8),
            hoverBorderColor: rgba(colors, 1)
        };
    }
    /**
     * @param {?} colors
     * @return {?}
     */
    function formatPieColors(colors) {
        return {
            backgroundColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 0.6); })),
            borderColor: colors.map(( /**
             * @return {?}
             */function () { return '#fff'; })),
            pointBackgroundColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 1); })),
            pointBorderColor: colors.map(( /**
             * @return {?}
             */function () { return '#fff'; })),
            pointHoverBackgroundColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 1); })),
            pointHoverBorderColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 1); }))
        };
    }
    /**
     * @param {?} colors
     * @return {?}
     */
    function formatPolarAreaColors(colors) {
        return {
            backgroundColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 0.6); })),
            borderColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 1); })),
            hoverBackgroundColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 0.8); })),
            hoverBorderColor: colors.map(( /**
             * @param {?} color
             * @return {?}
             */function (color) { return rgba(color, 1); }))
        };
    }
    /**
     * @return {?}
     */
    function getRandomColor() {
        return [getRandomInt(0, 255), getRandomInt(0, 255), getRandomInt(0, 255)];
    }
    /**
     * Generate colors for line|bar charts
     * @param {?} index
     * @return {?}
     */
    function generateColor(index) {
        return BaseChartDirective.defaultColors[index] || getRandomColor();
    }
    /**
     * Generate colors for pie|doughnut charts
     * @param {?} count
     * @return {?}
     */
    function generateColors(count) {
        /** @type {?} */
        var colorsArr = new Array(count);
        for (var i = 0; i < count; i++) {
            colorsArr[i] = BaseChartDirective.defaultColors[i] || getRandomColor();
        }
        return colorsArr;
    }
    /**
     * Generate colors by chart type
     * @param {?} chartType
     * @param {?} index
     * @param {?} count
     * @return {?}
     */
    function getColors(chartType, index, count) {
        if (chartType === 'pie' || chartType === 'doughnut') {
            return formatPieColors(generateColors(count));
        }
        if (chartType === 'polarArea') {
            return formatPolarAreaColors(generateColors(count));
        }
        if (chartType === 'line' || chartType === 'radar') {
            return formatLineColor(generateColor(index));
        }
        if (chartType === 'bar' || chartType === 'horizontalBar') {
            return formatBarColor(generateColor(index));
        }
        return generateColor(index);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChartsModule = /** @class */ (function () {
        function ChartsModule() {
        }
        ChartsModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            BaseChartDirective
                        ],
                        exports: [
                            BaseChartDirective
                        ],
                        imports: []
                    },] }
        ];
        return ChartsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var CHECKBOX_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(( /**
         * @return {?}
         */function () { return CheckboxComponent; })),
        multi: true
    };
    /** @type {?} */
    var defaultIdNumber = 0;
    var MdbCheckboxChange = /** @class */ (function () {
        function MdbCheckboxChange() {
        }
        return MdbCheckboxChange;
    }());
    var CheckboxComponent = /** @class */ (function () {
        function CheckboxComponent() {
            this.defaultId = "mdb-checkbox-" + ++defaultIdNumber;
            this.id = this.defaultId;
            this.checked = false;
            this.filledIn = false;
            this.indeterminate = false;
            this.rounded = false;
            this.checkboxPosition = 'left';
            this.default = false;
            this.inline = false;
            this.change = new i0.EventEmitter();
            this.checkboxClicked = new rxjs.Subject();
            // Control Value Accessor Methods
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) {
            });
            this.onTouched = ( /**
             * @return {?}
             */function () {
            });
        }
        /**
         * @param {?} event
         * @return {?}
         */
        CheckboxComponent.prototype.onLabelClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                event.stopPropagation();
                this.checkboxClicked.next(true);
            };
        /**
         * @return {?}
         */
        CheckboxComponent.prototype.onDocumentClick = /**
         * @return {?}
         */
            function () {
                this.checkboxClicked.next(false);
            };
        /**
         * @return {?}
         */
        CheckboxComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.indeterminate && !this.filledIn && !this.rounded) {
                    this.inputEl.indeterminate = true;
                }
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        CheckboxComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (changes.hasOwnProperty('checked')) {
                    this.checked = changes.checked.currentValue;
                }
            };
        Object.defineProperty(CheckboxComponent.prototype, "changeEvent", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var newChangeEvent = new MdbCheckboxChange();
                newChangeEvent.element = this;
                newChangeEvent.checked = this.checked;
                return newChangeEvent;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CheckboxComponent.prototype.toggle = /**
         * @return {?}
         */
            function () {
                if (this.disabled) {
                    return;
                }
                this.checked = !this.checked;
                this.indeterminate = false;
                this.onChange(this.checked);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        CheckboxComponent.prototype.onCheckboxClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                event.stopPropagation();
                this.toggle();
            };
        /**
         * @param {?} event
         * @return {?}
         */
        CheckboxComponent.prototype.onCheckboxChange = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                event.stopPropagation();
                rxjs.timer(0).subscribe(( /**
                 * @return {?}
                 */function () { return _this.change.emit(_this.changeEvent); }));
            };
        /**
         * @return {?}
         */
        CheckboxComponent.prototype.onBlur = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.checkboxClicked.pipe(operators.take(1)).subscribe(( /**
                 * @param {?} val
                 * @return {?}
                 */function (val) {
                    if (!val) {
                        _this.onTouched();
                    }
                }));
            };
        /**
         * @param {?} value
         * @return {?}
         */
        CheckboxComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.value = value;
                this.checked = !!value;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        CheckboxComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        CheckboxComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        CheckboxComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.disabled = isDisabled;
            };
        CheckboxComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-checkbox',
                        template: "<div\n  [ngClass]=\"{\n  'custom-control custom-checkbox': default,\n  'form-check': !default,\n  'custom-control-inline': inline,\n  'form-check-inline': inline && !default }\">\n  <input\n    #input\n    type=\"checkbox\"\n    class=\"custom-control-input\"\n    [ngClass]=\"{\n      'filled-in': filledIn || rounded,\n      'custom-control-input': default,\n      'form-check-input': !default }\"\n    [id]=\"id\"\n    [checked]=\"checked\"\n    [disabled]=\"disabled\"\n    [required]=\"required\"\n    [indeterminate]=\"indeterminate\"\n    [attr.name]=\"name\"\n    [attr.value]=\"value\"\n    [tabIndex]=\"tabIndex\"\n    (blur)=\"onBlur()\"\n    (click)=\"onCheckboxClick($event)\"\n    (change)=\"onCheckboxChange($event)\">\n  <label\n    [ngClass]=\"{\n      'custom-control-label': default,\n      'form-check-label': !default,\n      'label-before': checkboxPosition === 'right',\n      'checkbox-rounded': rounded,\n      'disabled': disabled }\"\n    [attr.for]=\"id\">\n    <ng-content></ng-content>\n  </label>\n</div>\n",
                        providers: [CHECKBOX_VALUE_ACCESSOR]
                    }] }
        ];
        /** @nocollapse */
        CheckboxComponent.ctorParameters = function () { return []; };
        CheckboxComponent.propDecorators = {
            inputEl: [{ type: i0.ViewChild, args: ['input',] }],
            class: [{ type: i0.Input }],
            id: [{ type: i0.Input }],
            required: [{ type: i0.Input }],
            name: [{ type: i0.Input }],
            value: [{ type: i0.Input }],
            checked: [{ type: i0.Input }],
            filledIn: [{ type: i0.Input }],
            indeterminate: [{ type: i0.Input }],
            disabled: [{ type: i0.Input }],
            rounded: [{ type: i0.Input }],
            checkboxPosition: [{ type: i0.Input }],
            default: [{ type: i0.Input }],
            inline: [{ type: i0.Input }],
            tabIndex: [{ type: i0.Input }],
            change: [{ type: i0.Output }],
            onLabelClick: [{ type: i0.HostListener, args: ['click', ['$event'],] }],
            onDocumentClick: [{ type: i0.HostListener, args: ['document:click',] }]
        };
        return CheckboxComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CheckboxModule = /** @class */ (function () {
        function CheckboxModule() {
        }
        CheckboxModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            CheckboxComponent
                        ],
                        exports: [
                            CheckboxComponent
                        ],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule
                        ]
                    },] }
        ];
        return CheckboxModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CollapseComponent = /** @class */ (function () {
        function CollapseComponent() {
            this.isCollapsed = true;
            this.showBsCollapse = new i0.EventEmitter();
            this.shownBsCollapse = new i0.EventEmitter();
            this.hideBsCollapse = new i0.EventEmitter();
            this.hiddenBsCollapse = new i0.EventEmitter();
            this.collapsed = new i0.EventEmitter();
            this.expanded = new i0.EventEmitter();
            this.overflow = 'hidden';
        }
        /**
         * @param {?} event
         * @return {?}
         */
        CollapseComponent.prototype.onExpandBodyDone = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.toState === 'expanded') {
                    this.shownBsCollapse.emit(this);
                    this.expanded.emit(this);
                    this.overflow = 'visible';
                }
                else {
                    this.hiddenBsCollapse.emit(this);
                    this.collapsed.emit(this);
                }
            };
        /**
         * @return {?}
         */
        CollapseComponent.prototype.toggle = /**
         * @return {?}
         */
            function () {
                this.isCollapsed ? this.show() : this.hide();
            };
        /**
         * @return {?}
         */
        CollapseComponent.prototype.show = /**
         * @return {?}
         */
            function () {
                this.expandAnimationState = 'expanded';
                this.isCollapsed = false;
                this.showBsCollapse.emit(this);
            };
        /**
         * @return {?}
         */
        CollapseComponent.prototype.hide = /**
         * @return {?}
         */
            function () {
                this.overflow = 'hidden';
                this.expandAnimationState = 'collapsed';
                this.isCollapsed = true;
                this.hideBsCollapse.emit(this);
            };
        /**
         * @return {?}
         */
        CollapseComponent.prototype.initializeCollapseState = /**
         * @return {?}
         */
            function () {
                this.isCollapsed ? this.hide() : this.show();
            };
        /**
         * @return {?}
         */
        CollapseComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.initializeCollapseState();
            };
        CollapseComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[mdbCollapse]',
                        exportAs: 'bs-collapse',
                        template: '<ng-content></ng-content>',
                        animations: [
                            animations.trigger('expandBody', [
                                animations.state('collapsed', animations.style({ height: '0px' })),
                                animations.state('expanded', animations.style({ height: '*' })),
                                animations.transition('expanded <=> collapsed', animations.animate('500ms ease')),
                            ])
                        ]
                    }] }
        ];
        /** @nocollapse */
        CollapseComponent.ctorParameters = function () { return []; };
        CollapseComponent.propDecorators = {
            isCollapsed: [{ type: i0.Input }],
            showBsCollapse: [{ type: i0.Output }],
            shownBsCollapse: [{ type: i0.Output }],
            hideBsCollapse: [{ type: i0.Output }],
            hiddenBsCollapse: [{ type: i0.Output }],
            collapsed: [{ type: i0.Output }],
            expanded: [{ type: i0.Output }],
            expandAnimationState: [{ type: i0.HostBinding, args: ['@expandBody',] }],
            overflow: [{ type: i0.HostBinding, args: ['style.overflow',] }],
            onExpandBodyDone: [{ type: i0.HostListener, args: ['@expandBody.done', ['$event'],] }]
        };
        return CollapseComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CollapseModule = /** @class */ (function () {
        function CollapseModule() {
        }
        /**
         * @return {?}
         */
        CollapseModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: CollapseModule, providers: [] };
            };
        CollapseModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [CollapseComponent],
                        exports: [CollapseComponent]
                    },] }
        ];
        return CollapseModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @copyright Valor Software
     * @copyright Angular ng-bootstrap team
     */
    var Trigger = /** @class */ (function () {
        function Trigger(open, close) {
            this.open = open;
            this.close = close || open;
        }
        /**
         * @return {?}
         */
        Trigger.prototype.isManual = /**
         * @return {?}
         */
            function () {
                return this.open === 'manual' || this.close === 'manual';
            };
        return Trigger;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DEFAULT_ALIASES = {
        hover: ['mouseover', 'mouseout'],
        focus: ['focusin', 'focusout']
    };
    /* tslint:disable-next-line: no-any */
    /**
     * @param {?} triggers
     * @param {?=} aliases
     * @return {?}
     */
    function parseTriggers(triggers, aliases) {
        if (aliases === void 0) {
            aliases = DEFAULT_ALIASES;
        }
        /** @type {?} */
        var trimmedTriggers = (triggers || '').trim();
        if (trimmedTriggers.length === 0) {
            return [];
        }
        /** @type {?} */
        var parsedTriggers = trimmedTriggers
            .split(/\s+/)
            .map(( /**
     * @param {?} trigger
     * @return {?}
     */function (trigger) { return trigger.split(':'); }))
            .map(( /**
     * @param {?} triggerPair
     * @return {?}
     */function (triggerPair) {
            /** @type {?} */
            var alias = aliases[triggerPair[0]] || triggerPair;
            return new Trigger(alias[0], alias[1]);
        }));
        /** @type {?} */
        var manualTriggers = parsedTriggers.filter(( /**
         * @param {?} triggerPair
         * @return {?}
         */function (triggerPair) {
            return triggerPair.isManual();
        }));
        if (manualTriggers.length > 1) {
            throw new Error('Triggers parse error: only one manual trigger is allowed');
        }
        if (manualTriggers.length === 1 && parsedTriggers.length > 1) {
            throw new Error('Triggers parse error: manual trigger can\'t be mixed with other triggers');
        }
        return parsedTriggers;
    }
    /**
     * @param {?} renderer
     * @param {?} options
     * @return {?}
     */
    function listenToTriggersV2(renderer, options) {
        /** @type {?} */
        var parsedTriggers = parseTriggers(options.triggers);
        /** @type {?} */
        var target = options.target;
        // do nothing
        if (parsedTriggers.length === 1 && parsedTriggers[0].isManual()) {
            return Function.prototype;
        }
        // all listeners
        /* tslint:disable-next-line: no-any */
        /** @type {?} */
        var listeners = [];
        // lazy listeners registration
        /** @type {?} */
        var _registerHide = [];
        /** @type {?} */
        var registerHide = ( /**
         * @return {?}
         */function () {
            // add hide listeners to unregister array
            _registerHide.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (fn) { return listeners.push(fn()); }));
            // register hide events only once
            _registerHide.length = 0;
        });
        // register open\close\toggle listeners
        parsedTriggers.forEach(( /**
         * @param {?} trigger
         * @return {?}
         */function (trigger) {
            /** @type {?} */
            var useToggle = trigger.open === trigger.close;
            /** @type {?} */
            var showFn = useToggle ? options.toggle : options.show;
            if (!useToggle) {
                _registerHide.push(( /**
                 * @return {?}
                 */function () {
                    return renderer.listen(target, trigger.close, options.hide);
                }));
            }
            listeners.push(renderer.listen(target, trigger.open, ( /**
             * @return {?}
             */function () { return showFn(registerHide); })));
        }));
        return ( /**
         * @return {?}
         */function () {
            listeners.forEach(( /**
             * @param {?} unsubscribeFn
             * @return {?}
             */function (unsubscribeFn) { return unsubscribeFn(); }));
        });
    }
    /**
     * @param {?} renderer
     * @param {?} options
     * @return {?}
     */
    function registerOutsideClick(renderer, options) {
        if (!options.outsideClick) {
            return Function.prototype;
        }
        /* tslint:disable-next-line: no-any */
        return renderer.listen('document', 'click', ( /**
         * @param {?} event
         * @return {?}
         */function (event) {
            if (options.target && options.target.contains(event.target)) {
                return undefined;
            }
            if (options.targets &&
                options.targets.some(( /**
                 * @param {?} target
                 * @return {?}
                 */function (target) { return target.contains(event.target); }))) {
                return undefined;
            }
            options.hide();
        }));
    }
    /**
     * @param {?} renderer
     * @param {?} options
     * @return {?}
     */
    function registerEscClick(renderer, options) {
        if (!options.outsideEsc) {
            return Function.prototype;
        }
        return renderer.listen('document', 'keyup.esc', ( /**
         * @param {?} event
         * @return {?}
         */function (event) {
            if (options.target && options.target.contains(event.target)) {
                return undefined;
            }
            if (options.targets &&
                options.targets.some(( /**
                 * @param {?} target
                 * @return {?}
                 */function (target) { return target.contains(event.target); }))) {
                return undefined;
            }
            options.hide();
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * JS version of browser APIs. This library can only run in the browser.
     * @type {?}
     */
    var win$1 = (typeof window !== 'undefined' && window) || ( /** @type {?} */({}));
    /** @type {?} */
    var document$2 = win$1.document;
    /** @type {?} */
    var location$1 = win$1.location;
    /** @type {?} */
    var gc$1 = win$1.gc ? ( /**
     * @return {?}
     */function () { return win$1.gc(); }) : ( /**
     * @return {?}
     */function () { return null; });
    /** @type {?} */
    var performance$1 = win$1.performance ? win$1.performance : null;
    /** @type {?} */
    var Event$1 = win$1.Event;
    /** @type {?} */
    var MouseEvent$1 = win$1.MouseEvent;
    /** @type {?} */
    var KeyboardEvent$1 = win$1.KeyboardEvent;
    /** @type {?} */
    var EventTarget$1 = win$1.EventTarget;
    /** @type {?} */
    var History$1 = win$1.History;
    /** @type {?} */
    var Location$1 = win$1.Location;
    /** @type {?} */
    var EventListener$1 = win$1.EventListener;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @copyright Valor Software
     * @copyright Angular ng-bootstrap team
     */
    var ContentRef = /** @class */ (function () {
        function ContentRef(
        /* tslint:disable-next-line: no-any */
        nodes, viewRef, 
        /* tslint:disable-next-line: no-any */
        componentRef) {
            this.nodes = nodes;
            this.viewRef = viewRef;
            this.componentRef = componentRef;
        }
        return ContentRef;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */ ComponentLoader = /** @class */ (function () {
        /**
         * Do not use this directly, it should be instanced via
         * `ComponentLoadFactory.attach`
         * @internal
         */
        // tslint:disable-next-line
        function ComponentLoader(_viewContainerRef, _renderer, _elementRef, _injector, _componentFactoryResolver, _ngZone, _applicationRef, _posService) {
            this._viewContainerRef = _viewContainerRef;
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            this._injector = _injector;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._ngZone = _ngZone;
            this._applicationRef = _applicationRef;
            this._posService = _posService;
            this.onBeforeShow = new i0.EventEmitter();
            /* tslint:disable-next-line: no-any*/
            this.onShown = new i0.EventEmitter();
            /* tslint:disable-next-line: no-any*/
            this.onBeforeHide = new i0.EventEmitter();
            this.onHidden = new i0.EventEmitter();
            this.shown = new i0.EventEmitter();
            this.hidden = new i0.EventEmitter();
            this._providers = [];
            this._isHiding = false;
            /**
             * A selector used if container element was not found
             */
            this.containerDefaultSelector = 'body';
            this._listenOpts = {};
            this._globalListener = Function.prototype;
        }
        Object.defineProperty(ComponentLoader.prototype, "isShown", {
            get: /**
             * @return {?}
             */ function () {
                if (this._isHiding) {
                    return false;
                }
                return !!this._componentRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} compType
         * @return {?}
         */
        ComponentLoader.prototype.attach = /**
         * @param {?} compType
         * @return {?}
         */
            function (compType) {
                this._componentFactory = this._componentFactoryResolver
                    .resolveComponentFactory(compType);
                return this;
            };
        // todo: add behaviour: to target element, `body`, custom element
        // todo: add behaviour: to target element, `body`, custom element
        /**
         * @param {?=} container
         * @return {?}
         */
        ComponentLoader.prototype.to =
            // todo: add behaviour: to target element, `body`, custom element
            /**
             * @param {?=} container
             * @return {?}
             */
            function (container) {
                this.container = container || this.container;
                return this;
            };
        /**
         * @param {?=} opts
         * @return {?}
         */
        ComponentLoader.prototype.position = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                this.attachment = opts.attachment || this.attachment;
                this._elementRef = (( /** @type {?} */(opts.target))) || this._elementRef;
                return this;
            };
        /**
         * @param {?} provider
         * @return {?}
         */
        ComponentLoader.prototype.provide = /**
         * @param {?} provider
         * @return {?}
         */
            function (provider) {
                this._providers.push(provider);
                return this;
            };
        // todo: appendChild to element or document.querySelector(this.container)
        // todo: appendChild to element or document.querySelector(this.container)
        /**
         * @param {?=} opts
         * @return {?}
         */
        ComponentLoader.prototype.show =
            // todo: appendChild to element or document.querySelector(this.container)
            /**
             * @param {?=} opts
             * @return {?}
             */
            function (opts) {
                if (opts === void 0) {
                    opts = {};
                }
                this._subscribePositioning();
                this._innerComponent = null;
                if (!this._componentRef) {
                    this.onBeforeShow.emit();
                    this._contentRef = this._getContentRef(opts.content, opts.data);
                    /** @type {?} */
                    var injector = i0.Injector.create({
                        providers: this._providers,
                        parent: this._injector
                    });
                    this._componentRef = this._componentFactory.create(injector, this._contentRef.nodes);
                    this._applicationRef.attachView(this._componentRef.hostView);
                    // this._componentRef = this._viewContainerRef
                    //   .createComponent(this._componentFactory, 0, injector, this._contentRef.nodes);
                    this.instance = this._componentRef.instance;
                    Object.assign(this._componentRef.instance, opts);
                    if (this.container instanceof i0.ElementRef) {
                        this.container.nativeElement.appendChild(this._componentRef.location.nativeElement);
                    }
                    if (typeof this.container === 'string' && typeof document !== 'undefined') {
                        /** @type {?} */
                        var selectedElement = document.querySelector(this.container) ||
                            document.querySelector(this.containerDefaultSelector);
                        if (selectedElement) {
                            selectedElement.appendChild(this._componentRef.location.nativeElement);
                        }
                    }
                    if (!this.container &&
                        this._elementRef &&
                        this._elementRef.nativeElement.parentElement) {
                        this._elementRef.nativeElement.parentElement.appendChild(this._componentRef.location.nativeElement);
                    }
                    // we need to manually invoke change detection since events registered
                    // via
                    // Renderer::listen() are not picked up by change detection with the
                    // OnPush strategy
                    if (this._contentRef.componentRef) {
                        this._innerComponent = this._contentRef.componentRef.instance;
                        this._contentRef.componentRef.changeDetectorRef.markForCheck();
                        this._contentRef.componentRef.changeDetectorRef.detectChanges();
                    }
                    this._componentRef.changeDetectorRef.markForCheck();
                    this._componentRef.changeDetectorRef.detectChanges();
                    this.onShown.emit(this._componentRef.instance);
                }
                this._registerOutsideClick();
                return this._componentRef;
            };
        /**
         * @return {?}
         */
        ComponentLoader.prototype.hide = /**
         * @return {?}
         */
            function () {
                if (!this._componentRef) {
                    return this;
                }
                this._posService.deletePositionElement(this._componentRef.location);
                this.onBeforeHide.emit(this._componentRef.instance);
                /** @type {?} */
                var componentEl = this._componentRef.location.nativeElement;
                componentEl.parentNode.removeChild(componentEl);
                if (this._contentRef.componentRef) {
                    this._contentRef.componentRef.destroy();
                }
                this._componentRef.destroy();
                if (this._viewContainerRef && this._contentRef.viewRef) {
                    this._viewContainerRef.remove(this._viewContainerRef.indexOf(this._contentRef.viewRef));
                }
                if (this._contentRef.viewRef) {
                    this._contentRef.viewRef.destroy();
                }
                this._contentRef = null;
                this._componentRef = null;
                this._removeGlobalListener();
                this.onHidden.emit();
                return this;
            };
        /**
         * @return {?}
         */
        ComponentLoader.prototype.toggle = /**
         * @return {?}
         */
            function () {
                if (this.isShown) {
                    this.hide();
                    return;
                }
                this.show();
            };
        /**
         * @return {?}
         */
        ComponentLoader.prototype.dispose = /**
         * @return {?}
         */
            function () {
                if (this.isShown) {
                    this.hide();
                }
                this._unsubscribePositioning();
                if (this._unregisterListenersFn) {
                    this._unregisterListenersFn();
                }
            };
        /**
         * @param {?} listenOpts
         * @return {?}
         */
        ComponentLoader.prototype.listen = /**
         * @param {?} listenOpts
         * @return {?}
         */
            function (listenOpts) {
                var _this = this;
                this.triggers = listenOpts.triggers || this.triggers;
                this._listenOpts.outsideClick = listenOpts.outsideClick;
                this._listenOpts.outsideEsc = listenOpts.outsideEsc;
                listenOpts.target = listenOpts.target || this._elementRef.nativeElement;
                /** @type {?} */
                var hide = (this._listenOpts.hide = ( /**
                 * @return {?}
                 */function () {
                    return listenOpts.hide ? listenOpts.hide() : void _this.hide();
                }));
                /** @type {?} */
                var show = (this._listenOpts.show = ( /**
                 * @param {?} registerHide
                 * @return {?}
                 */function (registerHide) {
                    listenOpts.show ? listenOpts.show(registerHide) : _this.show(registerHide);
                    registerHide();
                }));
                /** @type {?} */
                var toggle = ( /**
                 * @param {?} registerHide
                 * @return {?}
                 */function (registerHide) {
                    _this.isShown ? hide() : show(registerHide);
                });
                this._unregisterListenersFn = listenToTriggersV2(this._renderer, {
                    target: listenOpts.target,
                    triggers: listenOpts.triggers,
                    show: show,
                    hide: hide,
                    toggle: toggle
                });
                return this;
            };
        /**
         * @return {?}
         */
        ComponentLoader.prototype._removeGlobalListener = /**
         * @return {?}
         */
            function () {
                if (this._globalListener) {
                    this._globalListener();
                    this._globalListener = null;
                }
            };
        /**
         * @param {?} vRef
         * @param {?} template
         * @return {?}
         */
        ComponentLoader.prototype.attachInline = /**
         * @param {?} vRef
         * @param {?} template
         * @return {?}
         */
            function (vRef, 
            /* tslint:disable-next-line: no-any*/
            template) {
                this._inlineViewRef = vRef.createEmbeddedView(template);
                return this;
            };
        /**
         * @return {?}
         */
        ComponentLoader.prototype._registerOutsideClick = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this._componentRef || !this._componentRef.location) {
                    return;
                }
                // why: should run after first event bubble
                if (this._listenOpts && this._listenOpts.outsideClick) {
                    /** @type {?} */
                    var target_1 = this._componentRef.location.nativeElement;
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this._globalListener = registerOutsideClick(_this._renderer, {
                            targets: [target_1, _this._elementRef.nativeElement],
                            outsideClick: _this._listenOpts.outsideClick,
                            hide: ( /**
                             * @return {?}
                             */function () { return _this._listenOpts.hide(); })
                        });
                    }));
                }
                if (this._listenOpts.outsideEsc) {
                    /** @type {?} */
                    var target = this._componentRef.location.nativeElement;
                    this._globalListener = registerEscClick(this._renderer, {
                        targets: [target, this._elementRef.nativeElement],
                        outsideEsc: this._listenOpts.outsideEsc,
                        hide: ( /**
                         * @return {?}
                         */function () { return _this._listenOpts.hide(); })
                    });
                }
            };
        /**
         * @return {?}
         */
        ComponentLoader.prototype.getInnerComponent = /**
         * @return {?}
         */
            function () {
                return this._innerComponent;
            };
        /**
         * @private
         * @return {?}
         */
        ComponentLoader.prototype._subscribePositioning = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                if (this._zoneSubscription || !this.attachment) {
                    return;
                }
                this.onShown.subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._posService.position({
                        element: _this._componentRef.location,
                        target: _this._elementRef,
                        attachment: _this.attachment,
                        appendToBody: _this.container === 'body'
                    });
                }));
                this._zoneSubscription = this._ngZone.onStable.subscribe(( /**
                 * @return {?}
                 */function () {
                    if (!_this._componentRef) {
                        return;
                    }
                    _this._posService.calcPosition();
                }));
            };
        /**
         * @private
         * @return {?}
         */
        ComponentLoader.prototype._unsubscribePositioning = /**
         * @private
         * @return {?}
         */
            function () {
                if (!this._zoneSubscription) {
                    return;
                }
                this._zoneSubscription.unsubscribe();
                this._zoneSubscription = null;
            };
        /**
         * @private
         * @param {?} content
         * @param {?=} data
         * @return {?}
         */
        ComponentLoader.prototype._getContentRef = /**
         * @private
         * @param {?} content
         * @param {?=} data
         * @return {?}
         */
            function (
            /* tslint:disable-next-line: no-any*/
            content, 
            /* tslint:disable-next-line: no-any*/
            data) {
                if (!content) {
                    return new ContentRef([]);
                }
                if (content instanceof i0.TemplateRef) {
                    if (this._viewContainerRef) {
                        /** @type {?} */
                        var _viewRef = this._viewContainerRef
                            .createEmbeddedView(content);
                        _viewRef.markForCheck();
                        return new ContentRef([_viewRef.rootNodes], _viewRef);
                    }
                    /** @type {?} */
                    var viewRef = content.createEmbeddedView({});
                    this._applicationRef.attachView(viewRef);
                    return new ContentRef([viewRef.rootNodes], viewRef);
                }
                if (typeof content === 'function') {
                    /** @type {?} */
                    var contentCmptFactory = this._componentFactoryResolver.resolveComponentFactory(content);
                    /** @type {?} */
                    var modalContentInjector = i0.Injector.create({
                        providers: this._providers,
                        parent: this._injector
                    });
                    /** @type {?} */
                    var componentRef = contentCmptFactory.create(modalContentInjector);
                    Object.assign(componentRef.instance, data);
                    this._applicationRef.attachView(componentRef.hostView);
                    return new ContentRef([[componentRef.location.nativeElement]], componentRef.hostView, componentRef);
                }
                return new ContentRef([[this._renderer.createText("" + content)]]);
            };
        return ComponentLoader;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Get CSS computed property of the given element
     * @param {?} element
     * @param {?=} property
     * @return {?}
     */
    function getStyleComputedProperty(element, property) {
        if (element.nodeType !== 1) {
            return [];
        }
        // NOTE: 1 DOM access here
        /** @type {?} */
        var window = element.ownerDocument.defaultView;
        /** @type {?} */
        var css = window.getComputedStyle(element, null);
        return property ? css[( /** @type {?} */(property))] : css;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns the parentNode or the host of the element
     * @param {?} element
     * @return {?}
     */
    function getParentNode(element) {
        if (element.nodeName === 'HTML') {
            return element;
        }
        return element.parentNode || element.host;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function getScrollParent(element) {
        // Return body, `getScroll` will take care to get the correct `scrollTop` from it
        if (!element) {
            return document.body;
        }
        switch (element.nodeName) {
            case 'HTML':
            case 'BODY':
                return element.ownerDocument.body;
            case '#document':
                return element.body;
            default:
        }
        // Firefox want us to check `-x` and `-y` variations as well
        var _a = getStyleComputedProperty(element), overflow = _a.overflow, overflowX = _a.overflowX, overflowY = _a.overflowY;
        if (/(auto|scroll|overlay)/.test(String(overflow) + String(overflowY) + String(overflowX))) {
            return element;
        }
        return getScrollParent(getParentNode(element));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var isBrowser = typeof window !== 'undefined' && typeof document !== 'undefined';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var isIE11 = isBrowser && !!((( /** @type {?} */(window))).MSInputMethodContext && (( /** @type {?} */(document))).documentMode);
    /** @type {?} */
    var isIE10 = isBrowser && !!((( /** @type {?} */(window))).MSInputMethodContext && /MSIE 10/.test((( /** @type {?} */(navigator))).userAgent));
    /**
     * @param {?=} version
     * @return {?}
     */
    function isIE(version) {
        if (version === 11) {
            return isIE11;
        }
        if (version === 10) {
            return isIE10;
        }
        return isIE11 || isIE10;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function getOffsetParent(element) {
        if (!element) {
            return document.documentElement;
        }
        /** @type {?} */
        var noOffsetParent = isIE(10) ? document.body : null;
        // NOTE: 1 DOM access here
        /** @type {?} */
        var offsetParent = element.offsetParent || null;
        // Skip hidden elements which don't have an offsetParent
        /** @type {?} */
        var sibling;
        while (offsetParent === noOffsetParent && element.nextElementSibling && element.nodeName !== 'BODY') {
            sibling = element.nextElementSibling;
            offsetParent = sibling.offsetParent;
        }
        /** @type {?} */
        var nodeName = offsetParent && offsetParent.nodeName;
        if (!nodeName || nodeName === 'BODY' || nodeName === 'HTML') {
            return sibling ? sibling.ownerDocument.documentElement : document.documentElement;
        }
        // .offsetParent will return the closest TH, TD or TABLE in case
        // no offsetParent is present, I hate this job...
        if (['TH', 'TD', 'TABLE'].indexOf(offsetParent.nodeName) !== -1 &&
            getStyleComputedProperty(offsetParent, 'position') === 'static') {
            return getOffsetParent(offsetParent);
        }
        return offsetParent;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function isOffsetContainer(element) {
        var nodeName = element.nodeName;
        if (nodeName === 'BODY') {
            return false;
        }
        return (nodeName === 'HTML' || getOffsetParent(element.firstElementChild) === element);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Finds the root node (document, shadowDOM root) of the given element
     * @param {?} node
     * @return {?}
     */
    function getRoot(node) {
        if (node.parentNode !== null) {
            return getRoot(node.parentNode);
        }
        return node;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element1
     * @param {?} element2
     * @return {?}
     */
    function findCommonOffsetParent(element1, element2) {
        // This check is needed to avoid errors in case one of the elements isn't defined for any reason
        if (!element1 || !element1.nodeType || !element2 || !element2.nodeType) {
            return document.documentElement;
        }
        // Here we make sure to give as "start" the element that comes first in the DOM
        /* tslint:disable-next-line: no-bitwise */
        /** @type {?} */
        var order = element1.compareDocumentPosition(element2) & Node.DOCUMENT_POSITION_FOLLOWING;
        /** @type {?} */
        var start = order ? element1 : element2;
        /** @type {?} */
        var end = order ? element2 : element1;
        // Get common ancestor container
        /** @type {?} */
        var range = document.createRange();
        range.setStart(start, 0);
        range.setEnd(end, 0);
        var commonAncestorContainer = range.commonAncestorContainer;
        // Both nodes are inside #document
        if ((element1 !== commonAncestorContainer &&
            element2 !== commonAncestorContainer) ||
            start.contains(end)) {
            if (isOffsetContainer(commonAncestorContainer)) {
                return commonAncestorContainer;
            }
            return getOffsetParent(commonAncestorContainer);
        }
        // one of the nodes is inside shadowDOM, find which one
        /** @type {?} */
        var element1root = getRoot(element1);
        if (element1root.host) {
            return findCommonOffsetParent(element1root.host, element2);
        }
        else {
            return findCommonOffsetParent(element1, getRoot(element2).host);
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Helper to detect borders of a given element
     */
    /**
     * @param {?} styles
     * @param {?} axis
     * @return {?}
     */
    function getBordersSize(styles, axis) {
        /** @type {?} */
        var sideA = axis === 'x' ? 'Left' : 'Top';
        /** @type {?} */
        var sideB = sideA === 'Left' ? 'Right' : 'Bottom';
        return (parseFloat(styles[( /** @type {?} */("border" + sideA + "Width"))]) +
            parseFloat(styles[( /** @type {?} */("border" + sideB + "Width"))]));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} axis
     * @param {?} body
     * @param {?} html
     * @param {?} computedStyle
     * @return {?}
     */
    function getSize(axis, body, html, computedStyle) {
        return Math.max((( /** @type {?} */(body)))["offset" + axis], (( /** @type {?} */(body)))["scroll" + axis], (( /** @type {?} */(html)))["client" + axis], (( /** @type {?} */(html)))["offset" + axis], (( /** @type {?} */(html)))["scroll" + axis], isIE(10)
            ? (parseInt((( /** @type {?} */(html)))["offset" + axis], 10) +
                parseInt(computedStyle[( /** @type {?} */("margin" + (axis === 'Height' ? 'Top' : 'Left')))], 10) +
                parseInt(computedStyle[( /** @type {?} */("margin" + (axis === 'Height' ? 'Bottom' : 'Right')))], 10))
            : 0);
    }
    /**
     * @param {?} document
     * @return {?}
     */
    function getWindowSizes(document) {
        /** @type {?} */
        var body = document.body;
        /** @type {?} */
        var html = document.documentElement;
        /** @type {?} */
        var computedStyle = isIE(10) && getComputedStyle(html);
        return {
            height: getSize('Height', body, html, computedStyle),
            width: getSize('Width', body, html, computedStyle)
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Gets the scroll value of the given element in the given side (top and left)
     * @param {?} element
     * @param {?=} side
     * @return {?}
     */
    function getScroll(element, side) {
        if (side === void 0) {
            side = 'top';
        }
        /** @type {?} */
        var upperSide = side === 'top' ? 'scrollTop' : 'scrollLeft';
        /** @type {?} */
        var nodeName = element.nodeName;
        if (nodeName === 'BODY' || nodeName === 'HTML') {
            /** @type {?} */
            var html = element.ownerDocument.documentElement;
            /** @type {?} */
            var scrollingElement = element.ownerDocument.scrollingElement || html;
            return scrollingElement[upperSide];
        }
        return element[upperSide];
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} offsets
     * @return {?}
     */
    function getClientRect(offsets) {
        return __assign({}, offsets, { right: offsets.left + offsets.width, bottom: offsets.top + offsets.height });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function getBoundingClientRect(element) {
        /** @type {?} */
        var rect = {};
        // IE10 10 FIX: Please, don't ask, the element isn't
        // considered in DOM in some circumstances...
        // This isn't reproducible in IE10 compatibility mode of IE11
        try {
            if (isIE(10)) {
                rect = element.getBoundingClientRect();
                /** @type {?} */
                var scrollTop = getScroll(element, 'top');
                /** @type {?} */
                var scrollLeft = getScroll(element, 'left');
                rect.top += scrollTop;
                rect.left += scrollLeft;
                rect.bottom += scrollTop;
                rect.right += scrollLeft;
            }
            else {
                rect = element.getBoundingClientRect();
            }
        }
        catch (e) {
            return undefined;
        }
        /** @type {?} */
        var result = {
            left: rect.left,
            top: rect.top,
            width: rect.right - rect.left,
            height: rect.bottom - rect.top
        };
        // subtract scrollbar size from sizes
        /** @type {?} */
        var sizes = element.nodeName === 'HTML' ? getWindowSizes(element.ownerDocument) : {};
        /** @type {?} */
        var width = sizes.width || element.clientWidth || result.right - result.left;
        /** @type {?} */
        var height = sizes.height || element.clientHeight || result.bottom - result.top;
        /** @type {?} */
        var horizScrollbar = element.offsetWidth - width;
        /** @type {?} */
        var vertScrollbar = element.offsetHeight - height;
        // if an hypothetical scrollbar is detected, we must be sure it's not a `border`
        // we make this check conditional for performance reasons
        if (horizScrollbar || vertScrollbar) {
            /** @type {?} */
            var styles = getStyleComputedProperty(element);
            horizScrollbar -= getBordersSize(styles, 'x');
            vertScrollbar -= getBordersSize(styles, 'y');
            result.width -= horizScrollbar;
            result.height -= vertScrollbar;
        }
        return getClientRect(result);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} rect
     * @param {?} element
     * @param {?=} subtract
     * @return {?}
     */
    function includeScroll(rect, element, subtract) {
        if (subtract === void 0) {
            subtract = false;
        }
        /** @type {?} */
        var scrollTop = getScroll(element, 'top');
        /** @type {?} */
        var scrollLeft = getScroll(element, 'left');
        /** @type {?} */
        var modifier = subtract ? -1 : 1;
        rect.top += scrollTop * modifier;
        rect.bottom += scrollTop * modifier;
        rect.left += scrollLeft * modifier;
        rect.right += scrollLeft * modifier;
        return rect;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} children
     * @param {?} parent
     * @param {?=} fixedPosition
     * @return {?}
     */
    function getOffsetRectRelativeToArbitraryNode(children, parent, fixedPosition) {
        if (fixedPosition === void 0) {
            fixedPosition = false;
        }
        /** @type {?} */
        var isIE10 = isIE(10);
        /** @type {?} */
        var isHTML = parent.nodeName === 'HTML';
        /** @type {?} */
        var childrenRect = getBoundingClientRect(children);
        /** @type {?} */
        var parentRect = getBoundingClientRect(parent);
        /** @type {?} */
        var scrollParent = getScrollParent(children);
        /** @type {?} */
        var styles = getStyleComputedProperty(parent);
        /** @type {?} */
        var borderTopWidth = parseFloat(styles.borderTopWidth);
        /** @type {?} */
        var borderLeftWidth = parseFloat(styles.borderLeftWidth);
        // In cases where the parent is fixed, we must ignore negative scroll in offset calc
        if (fixedPosition && isHTML) {
            parentRect.top = Math.max(parentRect.top, 0);
            parentRect.left = Math.max(parentRect.left, 0);
        }
        /** @type {?} */
        var offsets = getClientRect({
            top: childrenRect.top - parentRect.top - borderTopWidth,
            left: childrenRect.left - parentRect.left - borderLeftWidth,
            width: childrenRect.width,
            height: childrenRect.height
        });
        offsets.marginTop = 0;
        offsets.marginLeft = 0;
        // Subtract margins of documentElement in case it's being used as parent
        // we do this only on HTML because it's the only element that behaves
        // differently when margins are applied to it. The margins are included in
        // the box of the documentElement, in the other cases not.
        if (!isIE10 && isHTML) {
            /** @type {?} */
            var marginTop = parseFloat(styles.marginTop);
            /** @type {?} */
            var marginLeft = parseFloat(styles.marginLeft);
            offsets.top -= borderTopWidth - marginTop;
            offsets.bottom -= borderTopWidth - marginTop;
            offsets.left -= borderLeftWidth - marginLeft;
            offsets.right -= borderLeftWidth - marginLeft;
            // Attach marginTop and marginLeft because in some circumstances we may need them
            offsets.marginTop = marginTop;
            offsets.marginLeft = marginLeft;
        }
        if (isIE10 && !fixedPosition
            ? parent.contains(scrollParent)
            : parent === scrollParent && scrollParent.nodeName !== 'BODY') {
            offsets = includeScroll(offsets, parent);
        }
        return offsets;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @param {?=} excludeScroll
     * @return {?}
     */
    function getViewportOffsetRectRelativeToArtbitraryNode(element, excludeScroll) {
        if (excludeScroll === void 0) {
            excludeScroll = false;
        }
        /** @type {?} */
        var html = element.ownerDocument.documentElement;
        /** @type {?} */
        var relativeOffset = getOffsetRectRelativeToArbitraryNode(element, html);
        /** @type {?} */
        var width = Math.max(html.clientWidth, window.innerWidth || 0);
        /** @type {?} */
        var height = Math.max(html.clientHeight, window.innerHeight || 0);
        /** @type {?} */
        var scrollTop = !excludeScroll ? getScroll(html) : 0;
        /** @type {?} */
        var scrollLeft = !excludeScroll ? getScroll(html, 'left') : 0;
        /** @type {?} */
        var offset = {
            top: scrollTop - Number(relativeOffset.top) + Number(relativeOffset.marginTop),
            left: scrollLeft - Number(relativeOffset.left) + Number(relativeOffset.marginLeft),
            width: width,
            height: height
        };
        return getClientRect(offset);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function isFixed(element) {
        /** @type {?} */
        var nodeName = element.nodeName;
        if (nodeName === 'BODY' || nodeName === 'HTML') {
            return false;
        }
        if (getStyleComputedProperty(element, 'position') === 'fixed') {
            return true;
        }
        return isFixed(getParentNode(element));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function getFixedPositionOffsetParent(element) {
        // This check is needed to avoid errors in case one of the elements isn't defined for any reason
        if (!element || !element.parentElement || isIE()) {
            return document.documentElement;
        }
        /** @type {?} */
        var el = element.parentElement;
        while (el && getStyleComputedProperty(el, 'transform') === 'none') {
            el = el.parentElement;
        }
        return el || document.documentElement;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} target
     * @param {?} host
     * @param {?=} padding
     * @param {?=} boundariesElement
     * @param {?=} fixedPosition
     * @return {?}
     */
    function getBoundaries(target, host, padding, boundariesElement, fixedPosition) {
        // NOTE: 1 DOM access here
        if (padding === void 0) {
            padding = 0;
        }
        if (fixedPosition === void 0) {
            fixedPosition = false;
        }
        // NOTE: 1 DOM access here
        /** @type {?} */
        var boundaries = { top: 0, left: 0 };
        /** @type {?} */
        var offsetParent = fixedPosition ? getFixedPositionOffsetParent(target) : findCommonOffsetParent(target, host);
        // Handle viewport case
        if (boundariesElement === 'viewport') {
            boundaries = getViewportOffsetRectRelativeToArtbitraryNode(offsetParent, fixedPosition);
        }
        else {
            // Handle other cases based on DOM element used as boundaries
            /** @type {?} */
            var boundariesNode = void 0;
            if (boundariesElement === 'scrollParent') {
                boundariesNode = getScrollParent(getParentNode(host));
                if (boundariesNode.nodeName === 'BODY') {
                    boundariesNode = target.ownerDocument.documentElement;
                }
            }
            else if (boundariesElement === 'window') {
                boundariesNode = target.ownerDocument.documentElement;
            }
            else {
                boundariesNode = boundariesElement;
            }
            /** @type {?} */
            var offsets = getOffsetRectRelativeToArbitraryNode(boundariesNode, offsetParent, fixedPosition);
            // In case of HTML, we need a different computation
            if (boundariesNode.nodeName === 'HTML' && !isFixed(offsetParent)) {
                var _a = getWindowSizes(target.ownerDocument), height = _a.height, width = _a.width;
                boundaries.top += offsets.top - offsets.marginTop;
                boundaries.bottom = Number(height) + Number(offsets.top);
                boundaries.left += offsets.left - offsets.marginLeft;
                boundaries.right = Number(width) + Number(offsets.left);
            }
            else {
                // for all the other DOM elements, this one is good
                boundaries = offsets;
            }
        }
        // Add paddings
        boundaries.left += padding;
        boundaries.top += padding;
        boundaries.right -= padding;
        boundaries.bottom -= padding;
        return boundaries;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} __0
     * @return {?}
     */
    function getArea(_a) {
        var width = _a.width, height = _a.height;
        return width * height;
    }
    /**
     * @param {?} placement
     * @param {?} refRect
     * @param {?} target
     * @param {?} host
     * @param {?=} allowedPositions
     * @param {?=} boundariesElement
     * @param {?=} padding
     * @return {?}
     */
    function computeAutoPlacement(placement, refRect, target, host, allowedPositions, boundariesElement, padding) {
        if (allowedPositions === void 0) {
            allowedPositions = ['top', 'left', 'bottom', 'right'];
        }
        if (boundariesElement === void 0) {
            boundariesElement = 'viewport';
        }
        if (padding === void 0) {
            padding = 0;
        }
        if (placement.indexOf('auto') === -1) {
            return placement;
        }
        /** @type {?} */
        var boundaries = getBoundaries(target, host, padding, boundariesElement);
        /** @type {?} */
        var rects = {
            top: {
                width: boundaries.width,
                height: refRect.top - boundaries.top
            },
            right: {
                width: boundaries.right - refRect.right,
                height: boundaries.height
            },
            bottom: {
                width: boundaries.width,
                height: boundaries.bottom - refRect.bottom
            },
            left: {
                width: refRect.left - boundaries.left,
                height: boundaries.height
            }
        };
        /** @type {?} */
        var sortedAreas = Object.keys(rects)
            .map(( /**
     * @param {?} key
     * @return {?}
     */function (key) { return (__assign({ key: key }, rects[key], { area: getArea(rects[key]) })); }))
            .sort(( /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */function (a, b) { return b.area - a.area; }));
        /** @type {?} */
        var filteredAreas = sortedAreas.filter(( /**
         * @param {?} __0
         * @return {?}
         */function (_a) {
            var width = _a.width, height = _a.height;
            return width >= target.clientWidth && height >= target.clientHeight;
        }));
        filteredAreas = allowedPositions
            .reduce(( /**
     * @param {?} obj
     * @param {?} key
     * @return {?}
     */function (obj, key) {
            var _a;
            return __assign({}, obj, (_a = {}, _a[key] = filteredAreas[key], _a));
        }), {});
        /** @type {?} */
        var computedPlacement = filteredAreas.length > 0
            ? filteredAreas[0].key
            : sortedAreas[0].key;
        /** @type {?} */
        var variation = placement.split(' ')[1];
        target.className = target.className.replace(/auto/g, computedPlacement);
        return computedPlacement + (variation ? "-" + variation : '');
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} data
     * @return {?}
     */
    function getOffsets(data) {
        return {
            width: data.offsets.target.width,
            height: data.offsets.target.height,
            left: Math.floor(data.offsets.target.left),
            top: Math.round(data.offsets.target.top),
            bottom: Math.round(data.offsets.target.bottom),
            right: Math.floor(data.offsets.target.right)
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Get the opposite placement of the given one
     * @param {?} placement
     * @return {?}
     */
    function getOppositePlacement(placement) {
        /** @type {?} */
        var hash = { left: 'right', right: 'left', bottom: 'top', top: 'bottom' };
        return placement.replace(/left|right|bottom|top/g, ( /**
         * @param {?} matched
         * @return {?}
         */function (matched) { return (( /** @type {?} */(hash)))[matched]; }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Get the opposite placement variation of the given one
     * @param {?} variation
     * @return {?}
     */
    function getOppositeVariation(variation) {
        if (variation === 'right') {
            return 'left';
        }
        else if (variation === 'left') {
            return 'right';
        }
        return variation;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Get the outer sizes of the given element (offset size + margins)
     * @param {?} element
     * @return {?}
     */
    function getOuterSizes(element) {
        /** @type {?} */
        var window = element.ownerDocument.defaultView;
        /** @type {?} */
        var styles = window.getComputedStyle(element);
        /** @type {?} */
        var x = parseFloat(styles.marginTop || 0) + parseFloat(styles.marginBottom || 0);
        /** @type {?} */
        var y = parseFloat(styles.marginLeft || 0) + parseFloat(styles.marginRight || 0);
        return {
            width: Number(element.offsetWidth) + y,
            height: Number(element.offsetHeight) + x
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} target
     * @param {?} host
     * @param {?=} fixedPosition
     * @return {?}
     */
    function getReferenceOffsets(target, host, fixedPosition) {
        if (fixedPosition === void 0) {
            fixedPosition = null;
        }
        /** @type {?} */
        var commonOffsetParent = fixedPosition
            ? getFixedPositionOffsetParent(target)
            : findCommonOffsetParent(target, host);
        return getOffsetRectRelativeToArbitraryNode(host, commonOffsetParent, fixedPosition);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} target
     * @param {?} hostOffsets
     * @param {?} position
     * @return {?}
     */
    function getTargetOffsets(target, hostOffsets, position) {
        /** @type {?} */
        var placement = position.split(' ')[0];
        // Get target node sizes
        /** @type {?} */
        var targetRect = getOuterSizes(target);
        // Add position, width and height to our offsets object
        /** @type {?} */
        var targetOffsets = {
            width: targetRect.width,
            height: targetRect.height
        };
        // depending by the target placement we have to compute its offsets slightly differently
        /** @type {?} */
        var isHoriz = ['right', 'left'].indexOf(placement) !== -1;
        /** @type {?} */
        var mainSide = isHoriz ? 'top' : 'left';
        /** @type {?} */
        var secondarySide = isHoriz ? 'left' : 'top';
        /** @type {?} */
        var measurement = isHoriz ? 'height' : 'width';
        /** @type {?} */
        var secondaryMeasurement = !isHoriz ? 'height' : 'width';
        (( /** @type {?} */(targetOffsets)))[mainSide] =
            hostOffsets[mainSide] +
                hostOffsets[measurement] / 2 -
                targetRect[measurement] / 2;
        (( /** @type {?} */(targetOffsets)))[secondarySide] = placement === secondarySide
            ? hostOffsets[secondarySide] - targetRect[secondaryMeasurement]
            : (( /** @type {?} */(hostOffsets)))[getOppositePlacement(secondarySide)];
        return targetOffsets;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Helper used to know if the given modifier is enabled.
     * @param {?} options
     * @param {?} modifierName
     * @return {?}
     */
    function isModifierEnabled(options, modifierName) {
        return options
            && options.modifiers
            && options.modifiers[modifierName]
            && options.modifiers[modifierName].enabled;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Tells if a given input is a number
     * @param {?} n
     * @return {?}
     */
    function isNumeric(n) {
        return n !== '' && !isNaN(parseFloat(n)) && isFinite(n);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @param {?} styles
     * @param {?=} renderer
     * @return {?}
     */
    function setStyles(element, styles, renderer) {
        Object.keys(styles).forEach(( /**
         * @param {?} prop
         * @return {?}
         */function (prop) {
            /** @type {?} */
            var unit = '';
            // add unit if the value is numeric and is one of the following
            if (['width', 'height', 'top', 'right', 'bottom', 'left'].indexOf(prop) !== -1 &&
                isNumeric(styles[prop])) {
                unit = 'px';
            }
            if (renderer) {
                renderer.setStyle(element, prop, "" + String(styles[prop]) + unit);
                return;
            }
            element.style[prop] = String(styles[prop]) + unit;
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} data
     * @param {?=} renderer
     * @return {?}
     */
    function setAllStyles(data, renderer) {
        /** @type {?} */
        var target = data.instance.target;
        /** @type {?} */
        var offsets = getOffsets(data);
        setStyles(target, {
            'will-change': 'transform',
            top: '0px',
            left: '0px',
            transform: "translate3d(" + offsets.left + "px, " + offsets.top + "px, 0px)"
        }, renderer);
        if (data.instance.arrow) {
            setStyles(data.instance.arrow, data.offsets.arrow, renderer);
        }
        if (data.placementAuto) {
            if (renderer) {
                renderer.setAttribute(target, 'class', target.className.replace(/bs-popover-auto/g, "bs-popover-" + data.placement));
                renderer.setAttribute(target, 'class', target.className.replace(/bs-tooltip-auto/g, "bs-tooltip-" + data.placement));
                renderer.setAttribute(target, 'class', target.className.replace(/\sauto/g, "s" + data.placement));
                if (target.className.match(/popover/g)) {
                    renderer.addClass(target, 'popover-auto');
                }
                if (target.className.match(/tooltip/g)) {
                    renderer.addClass(target, 'tooltip-auto');
                }
            }
            else {
                target.className = target.className.replace(/bs-popover-auto/g, "bs-popover-" + data.placement);
                target.className = target.className.replace(/bs-tooltip-auto/g, "bs-tooltip-" + data.placement);
                target.className = target.className.replace(/\sauto/g, "s" + data.placement);
                if (target.className.match(/popover/g)) {
                    target.classList.add('popover-auto');
                }
                if (target.className.match(/tooltip/g)) {
                    target.classList.add('tooltip-auto');
                }
            }
        }
        if (renderer) {
            renderer.setAttribute(target, 'class', target.className.replace(/left|right|top|bottom/g, "" + data.placement.split(' ')[0]));
        }
        else {
            target.className = target.className.replace(/left|right|top|bottom/g, "" + data.placement.split(' ')[0]);
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} data
     * @return {?}
     */
    function arrow(data) {
        var _a;
        /** @type {?} */
        var targetOffsets = data.offsets.target;
        // if arrowElement is a string, suppose it's a CSS selector
        /** @type {?} */
        var arrowElement = data.instance.target.querySelector('.arrow');
        // if arrowElement is not found, don't run the modifier
        if (!arrowElement) {
            return data;
        }
        /** @type {?} */
        var isVertical = ['left', 'right'].indexOf(data.placement) !== -1;
        /** @type {?} */
        var len = isVertical ? 'height' : 'width';
        /** @type {?} */
        var sideCapitalized = isVertical ? 'Top' : 'Left';
        /** @type {?} */
        var side = sideCapitalized.toLowerCase();
        /** @type {?} */
        var altSide = isVertical ? 'left' : 'top';
        /** @type {?} */
        var opSide = isVertical ? 'bottom' : 'right';
        /** @type {?} */
        var arrowElementSize = getOuterSizes(arrowElement)[len];
        // top/left side
        if (data.offsets.host[opSide] - arrowElementSize < (( /** @type {?} */(targetOffsets)))[side]) {
            (( /** @type {?} */(targetOffsets)))[side] -=
                (( /** @type {?} */(targetOffsets)))[side] - (data.offsets.host[opSide] - arrowElementSize);
        }
        // bottom/right side
        if (Number((( /** @type {?} */(data))).offsets.host[side]) + Number(arrowElementSize) > (( /** @type {?} */(targetOffsets)))[opSide]) {
            (( /** @type {?} */(targetOffsets)))[side] +=
                Number((( /** @type {?} */(data))).offsets.host[side]) + Number(arrowElementSize) - Number((( /** @type {?} */(targetOffsets)))[opSide]);
        }
        targetOffsets = getClientRect(targetOffsets);
        // compute center of the target
        /** @type {?} */
        var center = Number((( /** @type {?} */(data))).offsets.host[side]) + Number(data.offsets.host[len] / 2 - arrowElementSize / 2);
        // Compute the sideValue using the updated target offsets
        // take target margin in account because we don't have this info available
        /** @type {?} */
        var css = getStyleComputedProperty(data.instance.target);
        /** @type {?} */
        var targetMarginSide = parseFloat(css["margin" + sideCapitalized]);
        /** @type {?} */
        var targetBorderSide = parseFloat(css["border" + sideCapitalized + "Width"]);
        /** @type {?} */
        var sideValue = center - (( /** @type {?} */(targetOffsets)))[side] - targetMarginSide - targetBorderSide;
        // prevent arrowElement from being placed not contiguously to its target
        sideValue = Math.max(Math.min(targetOffsets[len] - arrowElementSize, sideValue), 0);
        data.offsets.arrow = (_a = {},
            _a[side] = Math.round(sideValue),
            _a[altSide] = '' // make sure to unset any eventual altSide value from the DOM node
            ,
                _a);
        data.instance.arrow = arrowElement;
        return data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} data
     * @return {?}
     */
    function flip(data) {
        data.offsets.target = getClientRect(data.offsets.target);
        if (!isModifierEnabled(data.options, 'flip')) {
            data.offsets.target = __assign({}, data.offsets.target, getTargetOffsets(data.instance.target, data.offsets.host, data.placement));
            return data;
        }
        /** @type {?} */
        var boundaries = getBoundaries(data.instance.target, data.instance.host, 0, // padding
        'viewport', false // positionFixed
        );
        /** @type {?} */
        var placement = data.placement.split(' ')[0];
        /** @type {?} */
        var variation = data.placement.split(' ')[1] || '';
        /** @type {?} */
        var offsetsHost = data.offsets.host;
        /** @type {?} */
        var target = data.instance.target;
        /** @type {?} */
        var host = data.instance.host;
        /** @type {?} */
        var adaptivePosition = variation
            ? computeAutoPlacement('auto', offsetsHost, target, host, ['top', 'bottom'])
            : computeAutoPlacement('auto', offsetsHost, target, host);
        /** @type {?} */
        var flipOrder = [placement, adaptivePosition];
        /* tslint:disable-next-line: cyclomatic-complexity */
        flipOrder.forEach(( /**
         * @param {?} step
         * @param {?} index
         * @return {?}
         */function (step, index) {
            if (placement !== step || flipOrder.length === index + 1) {
                return data;
            }
            placement = data.placement.split(' ')[0];
            // using floor because the host offsets may contain decimals we are not going to consider here
            /** @type {?} */
            var overlapsRef = (placement === 'left' &&
                Math.floor(data.offsets.target.right) > Math.floor(data.offsets.host.left)) ||
                (placement === 'right' &&
                    Math.floor(data.offsets.target.left) < Math.floor(data.offsets.host.right)) ||
                (placement === 'top' &&
                    Math.floor(data.offsets.target.bottom) > Math.floor(data.offsets.host.top)) ||
                (placement === 'bottom' &&
                    Math.floor(data.offsets.target.top) < Math.floor(data.offsets.host.bottom));
            /** @type {?} */
            var overflowsLeft = Math.floor(data.offsets.target.left) < Math.floor(boundaries.left);
            /** @type {?} */
            var overflowsRight = Math.floor(data.offsets.target.right) > Math.floor(boundaries.right);
            /** @type {?} */
            var overflowsTop = Math.floor(data.offsets.target.top) < Math.floor(boundaries.top);
            /** @type {?} */
            var overflowsBottom = Math.floor(data.offsets.target.bottom) > Math.floor(boundaries.bottom);
            /** @type {?} */
            var overflowsBoundaries = (placement === 'left' && overflowsLeft) ||
                (placement === 'right' && overflowsRight) ||
                (placement === 'top' && overflowsTop) ||
                (placement === 'bottom' && overflowsBottom);
            // flip the variation if required
            /** @type {?} */
            var isVertical = ['top', 'bottom'].indexOf(placement) !== -1;
            /** @type {?} */
            var flippedVariation = ((isVertical && variation === 'left' && overflowsLeft) ||
                (isVertical && variation === 'right' && overflowsRight) ||
                (!isVertical && variation === 'left' && overflowsTop) ||
                (!isVertical && variation === 'right' && overflowsBottom));
            if (overlapsRef || overflowsBoundaries || flippedVariation) {
                if (overlapsRef || overflowsBoundaries) {
                    placement = flipOrder[index + 1];
                }
                if (flippedVariation) {
                    variation = getOppositeVariation(variation);
                }
                data.placement = placement + (variation ? " " + variation : '');
                data.offsets.target = __assign({}, data.offsets.target, getTargetOffsets(data.instance.target, data.offsets.host, data.placement));
            }
        }));
        return data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} targetElement
     * @param {?} hostElement
     * @param {?} position
     * @param {?} options
     * @return {?}
     */
    function initData(targetElement, hostElement, position, options) {
        /** @type {?} */
        var hostElPosition = getReferenceOffsets(targetElement, hostElement);
        /** @type {?} */
        var placementAuto = !!position.match(/auto/g);
        // support old placements 'auto left|right|top|bottom'
        /** @type {?} */
        var placement = !!position.match(/auto\s(left|right|top|bottom)/g)
            ? position.split(' ')[1] || ''
            : position;
        /** @type {?} */
        var targetOffset = getTargetOffsets(targetElement, hostElPosition, placement);
        placement = computeAutoPlacement(placement, hostElPosition, targetElement, hostElement);
        return {
            options: options,
            instance: {
                target: targetElement,
                host: hostElement,
                arrow: null
            },
            offsets: {
                target: targetOffset,
                host: hostElPosition,
                arrow: null
            },
            positionFixed: false,
            placement: placement,
            placementAuto: placementAuto
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} data
     * @return {?}
     */
    function preventOverflow(data) {
        if (!isModifierEnabled(data.options, 'preventOverflow')) {
            return data;
        }
        // NOTE: DOM access here
        // resets the targetOffsets's position so that the document size can be calculated excluding
        // the size of the targetOffsets element itself
        /** @type {?} */
        var transformProp = 'transform';
        /** @type {?} */
        var targetStyles = data.instance.target.style;
        // assignment to help minification
        var top = targetStyles.top, left = targetStyles.left, _a = transformProp, transform = targetStyles[_a];
        targetStyles.top = '';
        targetStyles.left = '';
        targetStyles[transformProp] = '';
        /** @type {?} */
        var boundaries = getBoundaries(data.instance.target, data.instance.host, 0, // padding
        'scrollParent', false // positionFixed
        );
        // NOTE: DOM access here
        // restores the original style properties after the offsets have been computed
        targetStyles.top = top;
        targetStyles.left = left;
        targetStyles[transformProp] = transform;
        /** @type {?} */
        var order = ['left', 'right', 'top', 'bottom'];
        /** @type {?} */
        var check = {
            primary: /**
             * @param {?} placement
             * @return {?}
             */ function (placement) {
                var _a;
                /** @type {?} */
                var value = (( /** @type {?} */(data))).offsets.target[placement];
                if ((( /** @type {?} */(data))).offsets.target[placement] < boundaries[placement] &&
                    !false // options.escapeWithReference
                ) {
                    value = Math.max((( /** @type {?} */(data))).offsets.target[placement], boundaries[placement]);
                }
                return _a = {}, _a[placement] = value, _a;
            },
            secondary: /**
             * @param {?} placement
             * @return {?}
             */ function (placement) {
                var _a;
                /** @type {?} */
                var mainSide = placement === 'right' ? 'left' : 'top';
                /** @type {?} */
                var value = data.offsets.target[mainSide];
                if ((( /** @type {?} */(data))).offsets.target[placement] > boundaries[placement] &&
                    !false // escapeWithReference
                ) {
                    value = Math.min(data.offsets.target[mainSide], boundaries[placement] -
                        (placement === 'right' ? data.offsets.target.width : data.offsets.target.height));
                }
                return _a = {}, _a[mainSide] = value, _a;
            }
        };
        /** @type {?} */
        var side;
        order.forEach(( /**
         * @param {?} placement
         * @return {?}
         */function (placement) {
            side = ['left', 'top']
                .indexOf(placement) !== -1
                ? 'primary'
                : 'secondary';
            data.offsets.target = __assign({}, data.offsets.target, (( /** @type {?} */(check)))[side](placement));
        }));
        return data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} data
     * @return {?}
     */
    function shift(data) {
        var _a, _b;
        /** @type {?} */
        var placement = data.placement;
        /** @type {?} */
        var basePlacement = placement.split(' ')[0];
        /** @type {?} */
        var shiftvariation = placement.split(' ')[1];
        if (shiftvariation) {
            var _c = data.offsets, host = _c.host, target = _c.target;
            /** @type {?} */
            var isVertical = ['bottom', 'top'].indexOf(basePlacement) !== -1;
            /** @type {?} */
            var side = isVertical ? 'left' : 'top';
            /** @type {?} */
            var measurement = isVertical ? 'width' : 'height';
            /** @type {?} */
            var shiftOffsets = {
                left: (_a = {}, _a[side] = host[side], _a),
                right: (_b = {},
                    _b[side] = host[side] + host[measurement] - host[measurement],
                    _b)
            };
            data.offsets.target = __assign({}, target, (( /** @type {?} */(shiftOffsets)))[shiftvariation]);
        }
        return data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Positioning = /** @class */ (function () {
        function Positioning() {
        }
        /**
         * @param {?} hostElement
         * @param {?} targetElement
         * @return {?}
         */
        Positioning.prototype.position = /**
         * @param {?} hostElement
         * @param {?} targetElement
         * @return {?}
         */
            function (hostElement, targetElement) {
                return this.offset(hostElement, targetElement);
            };
        /**
         * @param {?} hostElement
         * @param {?} targetElement
         * @return {?}
         */
        Positioning.prototype.offset = /**
         * @param {?} hostElement
         * @param {?} targetElement
         * @return {?}
         */
            function (hostElement, targetElement) {
                return getReferenceOffsets(targetElement, hostElement);
            };
        /**
         * @param {?} hostElement
         * @param {?} targetElement
         * @param {?} position
         * @param {?=} _appendToBody
         * @param {?=} options
         * @return {?}
         */
        Positioning.prototype.positionElements = /**
         * @param {?} hostElement
         * @param {?} targetElement
         * @param {?} position
         * @param {?=} _appendToBody
         * @param {?=} options
         * @return {?}
         */
            function (hostElement, targetElement, position, _appendToBody, options) {
                /** @type {?} */
                var chainOfModifiers = [flip, shift, preventOverflow, arrow];
                return chainOfModifiers.reduce(( /**
                 * @param {?} modifiedData
                 * @param {?} modifier
                 * @return {?}
                 */function (modifiedData, modifier) { return modifier(modifiedData); }), initData(targetElement, hostElement, position, options));
            };
        return Positioning;
    }());
    /** @type {?} */
    var positionService = new Positioning();
    /**
     * @param {?} hostElement
     * @param {?} targetElement
     * @param {?} placement
     * @param {?=} appendToBody
     * @param {?=} options
     * @param {?=} renderer
     * @return {?}
     */
    function positionElements(hostElement, targetElement, placement, appendToBody, options, renderer) {
        /** @type {?} */
        var data = positionService.positionElements(hostElement, targetElement, placement, appendToBody, options);
        setAllStyles(data, renderer);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PositioningService = /** @class */ (function () {
        function PositioningService(rendererFactory, platformId) {
            var _this = this;
            this.update$$ = new rxjs.Subject();
            this.positionElements = new Map();
            if (common.isPlatformBrowser(platformId)) {
                rxjs.merge(rxjs.fromEvent(window, 'scroll'), rxjs.fromEvent(window, 'resize'), rxjs.of(0, rxjs.animationFrameScheduler), this.update$$)
                    .subscribe(( /**
             * @return {?}
             */function () {
                    _this.positionElements
                        .forEach(( /**
                 * @param {?} positionElement
                 * @return {?}
                 */function (positionElement) {
                        positionElements(_getHtmlElement(positionElement.target), _getHtmlElement(positionElement.element), positionElement.attachment, positionElement.appendToBody, _this.options, rendererFactory.createRenderer(null, null));
                    }));
                }));
            }
        }
        /**
         * @param {?} options
         * @return {?}
         */
        PositioningService.prototype.position = /**
         * @param {?} options
         * @return {?}
         */
            function (options) {
                this.addPositionElement(options);
            };
        /**
         * @param {?} options
         * @return {?}
         */
        PositioningService.prototype.addPositionElement = /**
         * @param {?} options
         * @return {?}
         */
            function (options) {
                this.positionElements.set(_getHtmlElement(options.element), options);
            };
        /**
         * @return {?}
         */
        PositioningService.prototype.calcPosition = /**
         * @return {?}
         */
            function () {
                this.update$$.next();
            };
        /**
         * @param {?} elRef
         * @return {?}
         */
        PositioningService.prototype.deletePositionElement = /**
         * @param {?} elRef
         * @return {?}
         */
            function (elRef) {
                this.positionElements.delete(_getHtmlElement(elRef));
            };
        /**
         * @param {?} options
         * @return {?}
         */
        PositioningService.prototype.setOptions = /**
         * @param {?} options
         * @return {?}
         */
            function (options) {
                this.options = options;
            };
        PositioningService.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        PositioningService.ctorParameters = function () {
            return [
                { type: i0.RendererFactory2 },
                { type: Number, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        return PositioningService;
    }());
    /**
     * @param {?} element
     * @return {?}
     */
    function _getHtmlElement(element) {
        // it means that we got a selector
        if (element && typeof element === 'string') {
            return document.querySelector(element);
        }
        if (element instanceof i0.ElementRef) {
            return element.nativeElement;
        }
        return element;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ComponentLoaderFactory = /** @class */ (function () {
        function ComponentLoaderFactory(_componentFactoryResolver, _ngZone, _injector, _posService, _applicationRef) {
            this._componentFactoryResolver = _componentFactoryResolver;
            this._ngZone = _ngZone;
            this._injector = _injector;
            this._posService = _posService;
            this._applicationRef = _applicationRef;
        }
        /**
         * @template T
         * @param {?} _elementRef
         * @param {?} _viewContainerRef
         * @param {?} _renderer
         * @return {?}
         */
        ComponentLoaderFactory.prototype.createLoader = /**
         * @template T
         * @param {?} _elementRef
         * @param {?} _viewContainerRef
         * @param {?} _renderer
         * @return {?}
         */
            function (_elementRef, _viewContainerRef, _renderer) {
                return new ComponentLoader(_viewContainerRef, _renderer, _elementRef, this._injector, this._componentFactoryResolver, this._ngZone, this._applicationRef, this._posService);
            };
        ComponentLoaderFactory.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        ComponentLoaderFactory.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver },
                { type: i0.NgZone },
                { type: i0.Injector },
                { type: PositioningService },
                { type: i0.ApplicationRef }
            ];
        };
        return ComponentLoaderFactory;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Default dropdown configuration
     */
    var BsDropdownConfig = /** @class */ (function () {
        function BsDropdownConfig() {
            /**
             * default dropdown auto closing behavior
             */
            this.autoClose = true;
        }
        BsDropdownConfig.decorators = [
            { type: i0.Injectable }
        ];
        return BsDropdownConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BsDropdownState = /** @class */ (function () {
        function BsDropdownState() {
            var _this = this;
            this.direction = 'down';
            this.isOpenChange = new i0.EventEmitter();
            this.isDisabledChange = new i0.EventEmitter();
            this.toggleClick = new i0.EventEmitter();
            this.dropdownMenu = new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (resolve) {
                _this.resolveDropdownMenu = resolve;
            }));
        }
        BsDropdownState.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        BsDropdownState.ctorParameters = function () { return []; };
        return BsDropdownState;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BsDropdownContainerComponent = /** @class */ (function () {
        function BsDropdownContainerComponent(_state) {
            var _this = this;
            this._state = _state;
            this.isOpen = false;
            this.display = 'block';
            this.position = 'absolute';
            this._subscription = _state.isOpenChange.subscribe(( /**
             * @param {?} value
             * @return {?}
             */function (value) {
                _this.isOpen = value;
            }));
        }
        Object.defineProperty(BsDropdownContainerComponent.prototype, "direction", {
            get: /**
             * @return {?}
             */ function () {
                return this._state.direction;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BsDropdownContainerComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._subscription.unsubscribe();
            };
        BsDropdownContainerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-dropdown-container',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: "\n  <div [class.dropup]=\"direction === 'up'\"\n  [class.dropdown]=\"direction === 'down'\"\n  [class.show]=\"isOpen\"\n  [class.open]=\"isOpen\">\n    <ng-content></ng-content>\n  </div>\n  "
                    }] }
        ];
        /** @nocollapse */
        BsDropdownContainerComponent.ctorParameters = function () {
            return [
                { type: BsDropdownState }
            ];
        };
        BsDropdownContainerComponent.propDecorators = {
            display: [{ type: i0.HostBinding, args: ['style.display',] }],
            position: [{ type: i0.HostBinding, args: ['style.position',] }]
        };
        return BsDropdownContainerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BsDropdownDirective = /** @class */ (function () {
        function BsDropdownDirective(_elementRef, _renderer, _viewContainerRef, _cis, _config, _state) {
            this._elementRef = _elementRef;
            this._renderer = _renderer;
            this._viewContainerRef = _viewContainerRef;
            this._cis = _cis;
            this._config = _config;
            this._state = _state;
            // todo: move to component loader
            this._isInlineOpen = false;
            this._subscriptions = [];
            this._isInited = false;
            // create dropdown component loader
            this._dropdown = this._cis
                .createLoader(this._elementRef, this._viewContainerRef, this._renderer)
                .provide({ provide: BsDropdownState, useValue: this._state });
            this.onShown = this._dropdown.onShown;
            this.shown = this._dropdown.shown;
            this.onHidden = this._dropdown.onHidden;
            this.hidden = this._dropdown.hidden;
            this.isOpenChange = this._state.isOpenChange;
            // set initial dropdown state from config
            this._state.autoClose = this._config.autoClose;
        }
        Object.defineProperty(BsDropdownDirective.prototype, "autoClose", {
            get: /**
             * @return {?}
             */ function () {
                return this._state.autoClose;
            },
            /**
             * Indicates that dropdown will be closed on item or document click,
             * and after pressing ESC
             */
            set: /**
             * Indicates that dropdown will be closed on item or document click,
             * and after pressing ESC
             * @param {?} value
             * @return {?}
             */ function (value) {
                if (typeof value === 'boolean') {
                    this._state.autoClose = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BsDropdownDirective.prototype, "isDisabled", {
            get: /**
             * @return {?}
             */ function () { return this._isDisabled; },
            /**
             * Disables dropdown toggle and hides dropdown menu if opened
             */
            set: /**
             * Disables dropdown toggle and hides dropdown menu if opened
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._isDisabled = value;
                this._state.isDisabledChange.emit(value);
                if (value) {
                    this.hide();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BsDropdownDirective.prototype, "isOpen", {
            /**
             * Returns whether or not the popover is currently being shown
             */
            get: /**
             * Returns whether or not the popover is currently being shown
             * @return {?}
             */ function () {
                if (this._showInline) {
                    return this._isInlineOpen;
                }
                return this._dropdown.isShown;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                if (value) {
                    this.show();
                }
                else {
                    this.hide();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BsDropdownDirective.prototype, "isBs4", {
            get: /**
             * @return {?}
             */ function () {
                return !isBs3();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BsDropdownDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // fix: seems there are an issue with `routerLinkActive`
                // which result in duplicated call ngOnInit without call to ngOnDestroy
                // read more: https://github.com/valor-software/ngx-bootstrap/issues/1885
                if (this._isInited) {
                    return;
                }
                this._isInited = true;
                this._showInline = !this.container;
                // attach DOM listeners
                this._dropdown.listen({
                    triggers: this.triggers,
                    show: ( /**
                     * @return {?}
                     */function () { return _this.show(); })
                });
                // toggle visibility on toggle element click
                this._subscriptions.push(this._state
                    .toggleClick.subscribe(( /**
             * @param {?} value
             * @return {?}
             */function (value) { return _this.toggle(value); })));
                // hide dropdown if set disabled while opened
                this._subscriptions.push(this._state
                    .isDisabledChange
                    .subscribe(( /**
             * @param {?} element
             * @return {?}
             */function (element) {
                    if (element === true) {
                        _this.hide();
                    }
                })));
                // attach dropdown menu inside of dropdown
                if (this._showInline) {
                    this._state.dropdownMenu
                        .then(( /**
                 * @param {?} dropdownMenu
                 * @return {?}
                 */function (dropdownMenu) {
                        _this._inlinedMenu = dropdownMenu.viewContainer.createEmbeddedView(dropdownMenu.templateRef);
                    }));
                }
                this._state.isOpenChange.subscribe(( /**
                 * @return {?}
                 */function () {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        /** @type {?} */
                        var dropdownContainer = _this._elementRef.nativeElement.lastElementChild;
                        /** @type {?} */
                        var left = dropdownContainer.getBoundingClientRect().left;
                        if (dropdownContainer.classList.contains('dropdown-menu-right') && left <= dropdownContainer.clientWidth) {
                            if (left < 0) {
                                _this._renderer.setStyle(dropdownContainer, 'right', left + 'px');
                            }
                            else {
                                _this._renderer.setStyle(dropdownContainer, 'right', '0');
                            }
                        }
                    }), 0);
                }));
            };
        /**
         * Opens an element’s popover. This is considered a “manual” triggering of
         * the popover.
         */
        /**
         * Opens an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
        BsDropdownDirective.prototype.show = /**
         * Opens an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.isOpen || this.isDisabled) {
                    return;
                }
                // material and dropup dropdown animation
                // const parent = this._elementRef.nativeElement.classList;
                /** @type {?} */
                var container = this._elementRef.nativeElement.lastElementChild;
                setTimeout(( /**
                 * @return {?}
                 */function () { container.classList.add('fadeInDropdown'); }), 200);
                if (this._showInline) {
                    this._isInlineOpen = true;
                    this.onShown.emit(true);
                    this.shown.emit(true);
                    this._state.isOpenChange.emit(true);
                    return;
                }
                this._state.dropdownMenu
                    .then(( /**
             * @param {?} dropdownMenu
             * @return {?}
             */function (dropdownMenu) {
                    // check direction in which dropdown should be opened
                    /** @type {?} */
                    var _dropup = _this.dropup === true ||
                        (typeof _this.dropup !== 'undefined' && _this.dropup !== false);
                    _this._state.direction = _dropup ? 'up' : 'down';
                    /** @type {?} */
                    var _placement = _this.placement ||
                        (_dropup ? 'top left' : 'bottom left');
                    // show dropdown
                    _this._dropdown
                        .attach(BsDropdownContainerComponent)
                        .to(_this.container)
                        .position({ attachment: _placement })
                        .show({
                        content: dropdownMenu.templateRef,
                        placement: _placement
                    });
                    _this._state.isOpenChange.emit(true);
                }));
            };
        /**
         * Closes an element’s popover. This is considered a “manual” triggering of
         * the popover.
         */
        /**
         * Closes an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
        BsDropdownDirective.prototype.hide = /**
         * Closes an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.isOpen) {
                    return;
                }
                /** @type {?} */
                var parent = this._elementRef.nativeElement.classList;
                /** @type {?} */
                var container = this._elementRef.nativeElement.lastElementChild;
                if ((parent.value === 'dropdown open show') || (parent.value === 'btn-group dropup open show')) {
                    container.classList.remove('fadeInDropdown');
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        if (_this._showInline) {
                            _this._isInlineOpen = false;
                            _this.onHidden.emit(true);
                            _this.hidden.emit(true);
                        }
                        else {
                            _this._dropdown.hide();
                        }
                        _this._state.isOpenChange.emit(false);
                    }), 560);
                }
                else {
                    if (this._showInline) {
                        this._isInlineOpen = false;
                        this.onHidden.emit(true);
                        this.hidden.emit(true);
                    }
                    else {
                        this._dropdown.hide();
                    }
                    this._state.isOpenChange.emit(false);
                }
            };
        /**
         * Toggles an element’s popover. This is considered a “manual” triggering of
         * the popover.
         */
        /**
         * Toggles an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @param {?=} value
         * @return {?}
         */
        BsDropdownDirective.prototype.toggle = /**
         * Toggles an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (this.isOpen || value === false) {
                    return this.hide();
                }
                return this.show();
            };
        /**
         * @return {?}
         */
        BsDropdownDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                var e_1, _a;
                try {
                    // clean up subscriptions and destroy dropdown
                    for (var _b = __values(this._subscriptions), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var sub = _c.value;
                        sub.unsubscribe();
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                this._dropdown.dispose();
            };
        BsDropdownDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbDropdown],[dropdown]',
                        exportAs: 'bs-dropdown',
                        providers: [BsDropdownState]
                    },] }
        ];
        /** @nocollapse */
        BsDropdownDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 },
                { type: i0.ViewContainerRef },
                { type: ComponentLoaderFactory },
                { type: BsDropdownConfig },
                { type: BsDropdownState }
            ];
        };
        BsDropdownDirective.propDecorators = {
            placement: [{ type: i0.Input }],
            triggers: [{ type: i0.Input }],
            container: [{ type: i0.Input }],
            dropup: [{ type: i0.HostBinding, args: ['class.dropup',] }, { type: i0.Input }],
            autoClose: [{ type: i0.Input }],
            isDisabled: [{ type: i0.Input }],
            isOpen: [{ type: i0.HostBinding, args: ['class.open',] }, { type: i0.HostBinding, args: ['class.show',] }, { type: i0.Input }],
            isOpenChange: [{ type: i0.Output }],
            onShown: [{ type: i0.Output }],
            shown: [{ type: i0.Output }],
            onHidden: [{ type: i0.Output }],
            hidden: [{ type: i0.Output }]
        };
        return BsDropdownDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BsDropdownMenuDirective = /** @class */ (function () {
        function BsDropdownMenuDirective(_state, _viewContainer, _templateRef) {
            _state.resolveDropdownMenu({
                templateRef: _templateRef,
                viewContainer: _viewContainer
            });
        }
        BsDropdownMenuDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbDropdownMenu],[dropdownMenu]',
                        exportAs: 'bs-dropdown-menu'
                    },] }
        ];
        /** @nocollapse */
        BsDropdownMenuDirective.ctorParameters = function () {
            return [
                { type: BsDropdownState },
                { type: i0.ViewContainerRef },
                { type: i0.TemplateRef }
            ];
        };
        return BsDropdownMenuDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BsDropdownToggleDirective = /** @class */ (function () {
        function BsDropdownToggleDirective(_state, _element) {
            var _this = this;
            this._state = _state;
            this._element = _element;
            this._subscriptions = [];
            this.ariaHaspopup = true;
            // @HostBinding('attr.disabled') isDisabled: boolean = null;
            this.isDisabled = null;
            // sync is open value with state
            this._subscriptions.push(this._state
                .isOpenChange.subscribe(( /**
         * @param {?} value
         * @return {?}
         */function (value) { return _this.isOpen = value; })));
            // populate disabled state
            this._subscriptions.push(this._state
                .isDisabledChange
                // .subscribe((value: boolean) => this.isDisabled = value || null));
                .subscribe(( /**
         * @param {?} value
         * @return {?}
         */function (value) { return _this.isDisabled = value || null; })));
        }
        /**
         * @return {?}
         */
        BsDropdownToggleDirective.prototype.onClick = /**
         * @return {?}
         */
            function () {
                if (this.isDisabled) {
                    return;
                }
                this._state.toggleClick.emit();
            };
        /**
         * @param {?} event
         * @return {?}
         */
        BsDropdownToggleDirective.prototype.onDocumentClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this._state.autoClose && event.button !== 2 &&
                    !this._element.nativeElement.contains(event.target)) {
                    this._state.toggleClick.emit(false);
                }
            };
        /**
         * @return {?}
         */
        BsDropdownToggleDirective.prototype.onEsc = /**
         * @return {?}
         */
            function () {
                if (this._state.autoClose) {
                    this._state.toggleClick.emit(false);
                }
            };
        /**
         * @return {?}
         */
        BsDropdownToggleDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                var e_1, _a;
                try {
                    for (var _b = __values(this._subscriptions), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var sub = _c.value;
                        sub.unsubscribe();
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            };
        BsDropdownToggleDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbDropdownToggle],[dropdownToggle]',
                        exportAs: 'bs-dropdown-toggle'
                    },] }
        ];
        /** @nocollapse */
        BsDropdownToggleDirective.ctorParameters = function () {
            return [
                { type: BsDropdownState },
                { type: i0.ElementRef }
            ];
        };
        BsDropdownToggleDirective.propDecorators = {
            ariaHaspopup: [{ type: i0.HostBinding, args: ['attr.aria-haspopup',] }],
            isDisabled: [{ type: i0.HostBinding, args: ['attr.disabled',] }],
            isOpen: [{ type: i0.HostBinding, args: ['attr.aria-expanded',] }],
            onClick: [{ type: i0.HostListener, args: ['click',] }],
            onDocumentClick: [{ type: i0.HostListener, args: ['document:click', ['$event'],] }],
            onEsc: [{ type: i0.HostListener, args: ['keyup.esc',] }]
        };
        return BsDropdownToggleDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DropdownModule = /** @class */ (function () {
        function DropdownModule() {
        }
        /**
         * @param {?=} config
         * @return {?}
         */
        DropdownModule.forRoot = /**
         * @param {?=} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: DropdownModule, providers: [
                        ComponentLoaderFactory,
                        PositioningService,
                        BsDropdownState,
                        { provide: BsDropdownConfig, useValue: config ? config : { autoClose: true } }
                    ]
                };
            };
        DropdownModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            BsDropdownMenuDirective,
                            BsDropdownToggleDirective,
                            BsDropdownContainerComponent,
                            BsDropdownDirective
                        ],
                        exports: [
                            BsDropdownMenuDirective,
                            BsDropdownToggleDirective,
                            BsDropdownDirective
                        ],
                        entryComponents: [BsDropdownContainerComponent]
                    },] }
        ];
        return DropdownModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbIconComponent = /** @class */ (function () {
        function MdbIconComponent(_el, _renderer) {
            this._el = _el;
            this._renderer = _renderer;
            this.fab = false;
            this.far = false;
            this.fal = false;
            this.fas = true;
            this.sizeClass = '';
        }
        /**
         * @return {?}
         */
        MdbIconComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.size) {
                    this.sizeClass = "fa-" + this.size;
                }
                if (this._el.nativeElement.parentElement.classList.contains('md-form')) {
                    this._renderer.addClass(this._el.nativeElement, 'prefix');
                }
                /** @type {?} */
                var classList = this._el.nativeElement.classList;
                this.fab = classList.contains('fab');
                this.far = classList.contains('far');
                this.fas = classList.contains('fas');
                this.fal = classList.contains('fal');
                /** @type {?} */
                var formWrapper = this._getClosestEl(this._el.nativeElement, '.md-form') ||
                    this._getClosestEl(this._el.nativeElement, '.md-outline');
                if (formWrapper) {
                    formWrapper.childNodes.forEach(( /**
                     * @param {?} el
                     * @return {?}
                     */function (el) {
                        if (el.tagName == 'INPUT') {
                            _this._renderer.listen(el, 'focus', ( /**
                             * @return {?}
                             */function () {
                                _this._renderer.addClass(_this._el.nativeElement, 'active');
                            }));
                            _this._renderer.listen(el, 'blur', ( /**
                             * @return {?}
                             */function () {
                                _this._renderer.removeClass(_this._el.nativeElement, 'active');
                            }));
                        }
                    }));
                }
            };
        /**
         * @private
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
        MdbIconComponent.prototype._getClosestEl = /**
         * @private
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
            function (el, selector) {
                for (; el && el !== document$1; el = el.parentNode) {
                    if (el.matches && el.matches(selector)) {
                        return el;
                    }
                }
                return null;
            };
        MdbIconComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-icon',
                        template: "<i [ngClass]=\"{'fas': fas, 'far': far, 'fab': fab, 'fal': fal}\" class=\"fa-{{icon}} {{class}} {{classInside}} {{sizeClass}}\"></i>\n"
                    }] }
        ];
        /** @nocollapse */
        MdbIconComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbIconComponent.propDecorators = {
            icon: [{ type: i0.Input }],
            size: [{ type: i0.Input }],
            class: [{ type: i0.Input }],
            classInside: [{ type: i0.Input }]
        };
        return MdbIconComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FalDirective = /** @class */ (function () {
        function FalDirective(_el, _r) {
            this._el = _el;
            this._r = _r;
            this._r.addClass(this._el.nativeElement, 'fal');
        }
        FalDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[fal], [light]' },] }
        ];
        /** @nocollapse */
        FalDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        return FalDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FarDirective = /** @class */ (function () {
        function FarDirective(_el, _r) {
            this._el = _el;
            this._r = _r;
            this._r.addClass(this._el.nativeElement, 'far');
        }
        FarDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[far], [regular]' },] }
        ];
        /** @nocollapse */
        FarDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        return FarDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FasDirective = /** @class */ (function () {
        function FasDirective(_el, _r) {
            this._el = _el;
            this._r = _r;
            this._r.addClass(this._el.nativeElement, 'fas');
        }
        FasDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[fas], [solid]' },] }
        ];
        /** @nocollapse */
        FasDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        return FasDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FabDirective = /** @class */ (function () {
        function FabDirective(_el, _r) {
            this._el = _el;
            this._r = _r;
            this._r.addClass(this._el.nativeElement, 'fab');
        }
        FabDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[fab], [brands]' },] }
        ];
        /** @nocollapse */
        FabDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        return FabDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var IconsModule = /** @class */ (function () {
        function IconsModule() {
        }
        IconsModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            MdbIconComponent,
                            FabDirective,
                            FarDirective,
                            FasDirective,
                            FalDirective
                        ],
                        imports: [common.CommonModule],
                        exports: [
                            MdbIconComponent,
                            FabDirective,
                            FarDirective,
                            FasDirective,
                            FalDirective
                        ]
                    },] }
        ];
        return IconsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var defaultIdNumber$1 = 0;
    var MdbErrorDirective = /** @class */ (function () {
        function MdbErrorDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.id = "mdb-error-" + defaultIdNumber$1++;
            this.errorMsg = true;
            this.messageId = this.id;
        }
        /**
         * @private
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
        MdbErrorDirective.prototype._getClosestEl = /**
         * @private
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
            function (el, selector) {
                for (; el && el !== document; el = el.previousElementSibling) {
                    if (el.matches(selector)) {
                        return el;
                    }
                }
                return null;
            };
        /**
         * @return {?}
         */
        MdbErrorDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var textarea = this._getClosestEl(this.el.nativeElement, '.md-textarea');
                if (textarea) {
                    /** @type {?} */
                    var height_1 = textarea.offsetHeight + 4 + 'px';
                    this.renderer.setStyle(this.el.nativeElement, 'top', height_1);
                    this.textareaListenFunction = this.renderer.listen(textarea, 'keyup', ( /**
                     * @return {?}
                     */function () {
                        height_1 = textarea.offsetHeight + 4 + 'px';
                        _this.renderer.setStyle(_this.el.nativeElement, 'top', height_1);
                    }));
                }
            };
        /**
         * @return {?}
         */
        MdbErrorDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.textareaListenFunction) {
                    this.textareaListenFunction();
                }
            };
        MdbErrorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'mdb-error'
                    },] }
        ];
        /** @nocollapse */
        MdbErrorDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbErrorDirective.propDecorators = {
            id: [{ type: i0.Input }],
            errorMsg: [{ type: i0.HostBinding, args: ['class.error-message',] }],
            messageId: [{ type: i0.HostBinding, args: ['attr.id',] }]
        };
        return MdbErrorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var defaultIdNumber$2 = 0;
    var MdbSuccessDirective = /** @class */ (function () {
        function MdbSuccessDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.id = "mdb-success-" + defaultIdNumber$2++;
            this.successMsg = true;
            this.messageId = this.id;
        }
        /**
         * @private
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
        MdbSuccessDirective.prototype._getClosestEl = /**
         * @private
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
            function (el, selector) {
                for (; el && el !== document; el = el.previousElementSibling) {
                    if (el.matches(selector)) {
                        return el;
                    }
                }
                return null;
            };
        /**
         * @return {?}
         */
        MdbSuccessDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var textarea = this._getClosestEl(this.el.nativeElement, '.md-textarea');
                if (textarea) {
                    /** @type {?} */
                    var height_1 = textarea.offsetHeight + 4 + 'px';
                    this.renderer.setStyle(this.el.nativeElement, 'top', height_1);
                    this.textareaListenFunction = this.renderer.listen(textarea, 'keyup', ( /**
                     * @return {?}
                     */function () {
                        height_1 = textarea.offsetHeight + 4 + 'px';
                        _this.renderer.setStyle(_this.el.nativeElement, 'top', height_1);
                    }));
                }
            };
        /**
         * @return {?}
         */
        MdbSuccessDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.textareaListenFunction) {
                    this.textareaListenFunction();
                }
            };
        MdbSuccessDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'mdb-success'
                    },] }
        ];
        /** @nocollapse */
        MdbSuccessDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbSuccessDirective.propDecorators = {
            id: [{ type: i0.Input }],
            successMsg: [{ type: i0.HostBinding, args: ['class.success-message',] }],
            messageId: [{ type: i0.HostBinding, args: ['attr.id',] }]
        };
        return MdbSuccessDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbValidateDirective = /** @class */ (function () {
        function MdbValidateDirective(renderer, el) {
            this.renderer = renderer;
            this.el = el;
            this._validate = true;
            this._validateSuccess = true;
            this._validateError = true;
        }
        Object.defineProperty(MdbValidateDirective.prototype, "validate", {
            get: /**
             * @return {?}
             */ function () { return this._validate; },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._validate = value;
                this.updateErrorClass();
                this.updateSuccessClass();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MdbValidateDirective.prototype, "validateSuccess", {
            get: /**
             * @return {?}
             */ function () { return this._validateSuccess; },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._validateSuccess = value;
                this.updateSuccessClass();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MdbValidateDirective.prototype, "validateError", {
            get: /**
             * @return {?}
             */ function () { return this._validateError; },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._validateError = value;
                this.updateErrorClass();
                this.updateSuccessClass();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MdbValidateDirective.prototype.updateSuccessClass = /**
         * @return {?}
         */
            function () {
                if (this.validate && this.validateSuccess) {
                    this.renderer.addClass(this.el.nativeElement, 'validate-success');
                }
                else {
                    this.renderer.removeClass(this.el.nativeElement, 'validate-success');
                }
            };
        /**
         * @return {?}
         */
        MdbValidateDirective.prototype.updateErrorClass = /**
         * @return {?}
         */
            function () {
                if (this.validate && this.validateError) {
                    this.renderer.addClass(this.el.nativeElement, 'validate-error');
                }
                else {
                    this.renderer.removeClass(this.el.nativeElement, 'validate-error');
                }
            };
        /**
         * @return {?}
         */
        MdbValidateDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.updateSuccessClass();
                this.updateErrorClass();
            };
        MdbValidateDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbValidate]'
                    },] }
        ];
        /** @nocollapse */
        MdbValidateDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef }
            ];
        };
        MdbValidateDirective.propDecorators = {
            mdbValidate: [{ type: i0.Input }],
            validate: [{ type: i0.Input }],
            validateSuccess: [{ type: i0.Input }],
            validateError: [{ type: i0.Input }]
        };
        return MdbValidateDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InputUtilitiesModule = /** @class */ (function () {
        function InputUtilitiesModule() {
        }
        InputUtilitiesModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [MdbErrorDirective, MdbSuccessDirective, MdbValidateDirective],
                        exports: [MdbErrorDirective, MdbSuccessDirective, MdbValidateDirective],
                    },] }
        ];
        return InputUtilitiesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var EqualValidatorDirective = /** @class */ (function () {
        function EqualValidatorDirective(validateEqual, reverse) {
            this.validateEqual = validateEqual;
            this.reverse = reverse;
        }
        Object.defineProperty(EqualValidatorDirective.prototype, "isReverse", {
            get: /**
             * @private
             * @return {?}
             */ function () {
                if (!this.reverse) {
                    return false;
                }
                return this.reverse === 'true' ? true : false;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} c
         * @return {?}
         */
        EqualValidatorDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                /** @type {?} */
                var setToNullValue = null;
                // self value (e.g. retype password)
                /** @type {?} */
                var v = c.value;
                // control value (e.g. password)
                // const e: any = c.root.get(this.validateEqual);
                /** @type {?} */
                var e = c.root.get(this.validateEqual);
                // value not equal
                if (e && v !== e.value) {
                    return { validateEqual: false };
                }
                // value equal and reverse
                if (e && v === e.value && this.isReverse) {
                    delete e.errors['validateEqual'];
                    if (!Object.keys(e.errors).length) {
                        e.setErrors(null);
                    }
                }
                // value not equal and reverse
                if (e && v !== e.value && this.isReverse) {
                    e.setErrors({
                        validateEqual: false
                    });
                }
                // return null;
                return setToNullValue;
            };
        EqualValidatorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdb-validateEqual][formControlName],[validateEqual][formControl],[validateEqual][ngModel]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: i0.forwardRef(( /**
                                     * @return {?}
                                     */function () { return EqualValidatorDirective; })), multi: true }
                        ]
                    },] }
        ];
        /** @nocollapse */
        EqualValidatorDirective.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Attribute, args: ['validateEqual',] }] },
                { type: String, decorators: [{ type: i0.Attribute, args: ['reverse',] }] }
            ];
        };
        return EqualValidatorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbInputDirective = /** @class */ (function () {
        function MdbInputDirective(_elRef, _renderer, platformId) {
            this._elRef = _elRef;
            this._renderer = _renderer;
            this.el = null;
            this.elLabel = null;
            this.elIcon = null;
            this.element = null;
            this.mdbValidate = true;
            this.validateSuccess = true;
            this.validateError = true;
            this.focusCheckbox = true;
            this.focusRadio = true;
            this.isBrowser = false;
            this.isClicked = false;
            this.el = _elRef;
            this.isBrowser = common.isPlatformBrowser(platformId);
        }
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.onfocus = /**
         * @return {?}
         */
            function () {
                try {
                    this._renderer.addClass(this.elLabel, 'active');
                    this.isClicked = true;
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.onblur = /**
         * @return {?}
         */
            function () {
                this.validationFunction();
                try {
                    if (this.el.nativeElement.value === '') {
                        this._renderer.removeClass(this.elLabel, 'active');
                    }
                    this.isClicked = false;
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.onchange = /**
         * @return {?}
         */
            function () {
                try {
                    this.checkValue();
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.oniput = /**
         * @return {?}
         */
            function () {
                this.validationFunction();
            };
        /**
         * @param {?} event
         * @return {?}
         */
        MdbInputDirective.prototype.onkeydown = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                try {
                    if (event.target.type === 'number') {
                        if (event.shiftKey) {
                            switch (event.keyCode) {
                                case 38:
                                    event.target.value = +event.target.value + 10;
                                    break;
                                case 40:
                                    event.target.value = +event.target.value - 10;
                                    break;
                            }
                        }
                        if (event.altKey) {
                            switch (event.keyCode) {
                                case 38:
                                    event.target.value = +event.target.value + 0.1;
                                    break;
                                case 40:
                                    event.target.value = +event.target.value - 0.1;
                                    break;
                            }
                        }
                    }
                }
                catch (error) {
                }
                this.delayedResize();
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.oncut = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.onpaste = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.ondrop = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) {
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        MdbInputDirective.prototype.updateErrorMsg = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (this.wrongTextContainer) {
                    this.wrongTextContainer.innerHTML = value;
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        MdbInputDirective.prototype.updateSuccessMsg = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (this.rightTextContainer) {
                    this.rightTextContainer.innerHTML = value;
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) {
                    console.log(error);
                }
                // Inititalise a new <span> wrong/right elements and render it below the host component.
                if (this.mdbValidate) {
                    this.wrongTextContainer = this._renderer.createElement('span');
                    this._renderer.addClass(this.wrongTextContainer, 'inputVal');
                    this._renderer.addClass(this.wrongTextContainer, 'text-danger');
                    this._renderer.appendChild(this._elRef.nativeElement.parentElement, this.wrongTextContainer);
                    /** @type {?} */
                    var textWrong = this._elRef.nativeElement.getAttribute('data-error');
                    this.wrongTextContainer.innerHTML = (textWrong ? textWrong : 'wrong');
                    if (!textWrong && this.errorMessage !== undefined) {
                        this.wrongTextContainer.innerHTML = this.errorMessage;
                    }
                    this._renderer.setStyle(this.wrongTextContainer, 'visibility', 'hidden');
                    this.rightTextContainer = this._renderer.createElement('span');
                    this._renderer.addClass(this.rightTextContainer, 'inputVal');
                    this._renderer.addClass(this.rightTextContainer, 'text-success');
                    this._renderer.appendChild(this._elRef.nativeElement.parentElement, this.rightTextContainer);
                    /** @type {?} */
                    var textSuccess = this._elRef.nativeElement.getAttribute('data-success');
                    this.rightTextContainer.innerHTML = (textSuccess ? textSuccess : 'success');
                    if (!textSuccess && this.successMessage !== undefined) {
                        this.rightTextContainer.innerHTML = this.successMessage;
                    }
                    this._renderer.setStyle(this.rightTextContainer, 'visibility', 'hidden');
                }
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        MdbInputDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (changes.hasOwnProperty('errorMessage')) {
                    /** @type {?} */
                    var newErrorMsg = changes.errorMessage.currentValue;
                    this.updateErrorMsg(newErrorMsg);
                }
                if (changes.hasOwnProperty('successMessage')) {
                    /** @type {?} */
                    var newSuccessMsg = changes.successMessage.currentValue;
                    this.updateSuccessMsg(newSuccessMsg);
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                if (this.mdbValidate &&
                    this._elRef.nativeElement.classList.contains('ng-valid') &&
                    this._elRef.nativeElement.classList.contains('ng-dirty') &&
                    !this._elRef.nativeElement.classList.contains('counter-success')) {
                    this._renderer.addClass(this._elRef.nativeElement, 'counter-success');
                    this._renderer.setStyle(this.wrongTextContainer, 'visibility', 'hidden');
                    this._renderer.setStyle(this.rightTextContainer, 'visibility', 'visible');
                    this._renderer.setStyle(this.rightTextContainer, 'top', this._elRef.nativeElement.offsetHeight + 'px');
                    this._renderer.setStyle(this.wrongTextContainer, 'top', this._elRef.nativeElement.offsetHeight + 'px');
                }
                if (this.mdbValidate &&
                    this._elRef.nativeElement.classList.contains('ng-invalid') &&
                    this._elRef.nativeElement.classList.contains('ng-dirty') &&
                    !this._elRef.nativeElement.classList.contains('counter-danger')) {
                    this._renderer.addClass(this._elRef.nativeElement, 'counter-danger');
                    this._renderer.setStyle(this.rightTextContainer, 'visibility', 'hidden');
                    this._renderer.setStyle(this.wrongTextContainer, 'visibility', 'visible');
                    this._renderer.setStyle(this.rightTextContainer, 'top', this._elRef.nativeElement.offsetHeight + 'px');
                    this._renderer.setStyle(this.wrongTextContainer, 'top', this._elRef.nativeElement.offsetHeight + 'px');
                }
                if (this._elRef.nativeElement.classList.contains('ng-invalid') &&
                    this._elRef.nativeElement.classList.contains('ng-pristine') &&
                    this._elRef.nativeElement.classList.contains('ng-untouched') || this._elRef.nativeElement.disabled) {
                    if (this._elRef.nativeElement.classList.contains('counter-success')) {
                        this._renderer.removeClass(this._elRef.nativeElement, 'counter-success');
                        this._renderer.setStyle(this.rightTextContainer, 'visibility', 'hidden');
                    }
                    else if (this._elRef.nativeElement.classList.contains('counter-danger')) {
                        this._renderer.removeClass(this._elRef.nativeElement, 'counter-danger');
                        this._renderer.setStyle(this.wrongTextContainer, 'visibility', 'hidden');
                    }
                }
                if (!this.validateSuccess) {
                    this._renderer.removeClass(this._elRef.nativeElement, 'counter-success');
                    this._renderer.setStyle(this.rightTextContainer, 'display', 'none');
                    if (this._elRef.nativeElement.classList.contains('ng-valid')) {
                        this._renderer.removeClass(this._elRef.nativeElement, 'counter-danger');
                    }
                }
                if (!this.validateError) {
                    this._renderer.removeClass(this._elRef.nativeElement, 'counter-danger');
                    this._renderer.setStyle(this.wrongTextContainer, 'display', 'none');
                    if (this._elRef.nativeElement.classList.contains('ng-invalid')) {
                        this._renderer.removeClass(this._elRef.nativeElement, 'counter-success');
                    }
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.validationFunction = /**
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    if (_this._elRef.nativeElement.classList.contains('ng-invalid')) {
                        _this._renderer.removeClass(_this._elRef.nativeElement, 'counter-success');
                        _this._renderer.removeClass(_this._elRef.nativeElement, 'counter-danger');
                    }
                    if (_this._elRef.nativeElement.classList.contains('ng-touched') &&
                        _this._elRef.nativeElement.classList.contains('ng-invalid')) {
                        if (_this.mdbValidate) {
                            _this._renderer.addClass(_this._elRef.nativeElement, 'counter-danger');
                            _this._renderer.setStyle(_this.rightTextContainer, 'visibility', 'hidden');
                            _this._renderer.setStyle(_this.wrongTextContainer, 'visibility', 'visible');
                            _this._renderer.setStyle(_this.rightTextContainer, 'top', _this._elRef.nativeElement.offsetHeight + 'px');
                            _this._renderer.setStyle(_this.wrongTextContainer, 'top', _this._elRef.nativeElement.offsetHeight + 'px');
                        }
                    }
                    else if (_this._elRef.nativeElement.classList.contains('ng-touched') &&
                        _this._elRef.nativeElement.classList.contains('ng-valid')) {
                        if (_this.mdbValidate) {
                            _this._renderer.addClass(_this._elRef.nativeElement, 'counter-success');
                            _this._renderer.setStyle(_this.rightTextContainer, 'visibility', 'visible');
                            _this._renderer.setStyle(_this.wrongTextContainer, 'visibility', 'hidden');
                            _this._renderer.setStyle(_this.rightTextContainer, 'top', _this._elRef.nativeElement.offsetHeight + 'px');
                            _this._renderer.setStyle(_this.wrongTextContainer, 'top', _this._elRef.nativeElement.offsetHeight + 'px');
                        }
                    }
                }), 0);
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                if (this.isBrowser) {
                    try {
                        this.element = document.querySelector('.md-textarea-auto');
                    }
                    catch (error) {
                    }
                }
                /** @type {?} */
                var type = this.el.nativeElement.type;
                if (this.focusCheckbox && type === 'checkbox') {
                    this._renderer.addClass(this.el.nativeElement, 'onFocusSelect');
                }
                if (this.focusRadio && type === 'radio') {
                    this._renderer.addClass(this.el.nativeElement, 'onFocusSelect');
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.ngAfterViewChecked = /**
         * @return {?}
         */
            function () {
                this.initComponent();
                this.checkValue();
                // tslint:disable-next-line:max-line-length
                /* if (this.el.nativeElement.tagName === 'MDB-COMPLETER' && this.el.nativeElement.getAttribute('ng-reflect-model') == null && !this.isClicked) {
                    this._renderer.removeClass(this.elLabel, 'active');
                } */
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.resize = /**
         * @return {?}
         */
            function () {
                if (this.el.nativeElement.classList.contains('md-textarea-auto')) {
                    this._renderer.setStyle(this.el.nativeElement, 'height', 'auto');
                    this._renderer.setStyle(this.el.nativeElement, 'height', this.el.nativeElement.scrollHeight + 'px');
                }
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.delayedResize = /**
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.resize();
                }), 0);
            };
        /**
         * @return {?}
         */
        MdbInputDirective.prototype.initComponent = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var inputId;
                /** @type {?} */
                var inputP;
                if (this.isBrowser) {
                    try {
                        inputId = this.el.nativeElement.id;
                    }
                    catch (err) {
                    }
                    try {
                        inputP = this.el.nativeElement.parentNode;
                    }
                    catch (err) {
                    }
                    this.elLabel = inputP.querySelector('label[for="' + inputId + '"]') || inputP.querySelector('label');
                    if (this.elLabel && this.el.nativeElement.value !== '') {
                        this._renderer.addClass(this.elLabel, 'active');
                    }
                    this.elIcon = inputP.querySelector('i') || false;
                    if (this.elIcon) {
                        this._renderer.addClass(this.elIcon, 'active');
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        MdbInputDirective.prototype.checkValue = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var value = '';
                if (this.elLabel != null) {
                    value = this.el.nativeElement.value || '';
                    if (value === '') {
                        this._renderer.removeClass(this.elLabel, 'active');
                        if (this.elIcon) {
                            this._renderer.removeClass(this.elIcon, 'active');
                        }
                        // tslint:disable-next-line:max-line-length
                    }
                    if (value === '' && this.isClicked ||
                        value === '' && this.el.nativeElement.placeholder ||
                        value === '' && this.el.nativeElement.attributes.placeholder) {
                        this._renderer.addClass(this.elLabel, 'active');
                    }
                    if (this.el.nativeElement.getAttribute('ng-reflect-model') != null) ;
                }
            };
        MdbInputDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbInputDirective]'
                    },] }
        ];
        /** @nocollapse */
        MdbInputDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 },
                { type: String, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        MdbInputDirective.propDecorators = {
            mdbInputDirective: [{ type: i0.Input, args: ['mdbInputDirective',] }],
            customRegex: [{ type: i0.Input, args: ['customRegex',] }],
            mdbValidate: [{ type: i0.Input, args: ['mdbValidation',] }],
            validateSuccess: [{ type: i0.Input, args: ['validateSuccess',] }],
            validateError: [{ type: i0.Input, args: ['validateError',] }],
            focusCheckbox: [{ type: i0.Input, args: ['focusCheckbox',] }],
            focusRadio: [{ type: i0.Input, args: ['focusRadio',] }],
            errorMessage: [{ type: i0.Input }],
            successMessage: [{ type: i0.Input }],
            onfocus: [{ type: i0.HostListener, args: ['focus',] }],
            onblur: [{ type: i0.HostListener, args: ['blur',] }],
            onchange: [{ type: i0.HostListener, args: ['change',] }],
            oniput: [{ type: i0.HostListener, args: ['input',] }],
            onkeydown: [{ type: i0.HostListener, args: ['keydown', ['$event'],] }],
            oncut: [{ type: i0.HostListener, args: ['cut',] }],
            onpaste: [{ type: i0.HostListener, args: ['paste',] }],
            ondrop: [{ type: i0.HostListener, args: ['drop',] }]
        };
        return MdbInputDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbInput = /** @class */ (function () {
        function MdbInput(el, _renderer, platformId) {
            this.el = el;
            this._renderer = _renderer;
            this.elLabel = null;
            this.elIcon = null;
            this.element = null;
            this.focusCheckbox = true;
            this.focusRadio = true;
            this.isBrowser = false;
            this.isClicked = false;
            this.isBrowser = common.isPlatformBrowser(platformId);
        }
        /**
         * @return {?}
         */
        MdbInput.prototype.onfocus = /**
         * @return {?}
         */
            function () {
                try {
                    this._renderer.addClass(this.elLabel, 'active');
                    this.isClicked = true;
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.onblur = /**
         * @return {?}
         */
            function () {
                try {
                    if (this.el.nativeElement.value === '') {
                        this._renderer.removeClass(this.elLabel, 'active');
                    }
                    this.isClicked = false;
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.onchange = /**
         * @return {?}
         */
            function () {
                try {
                    this.checkValue();
                }
                catch (error) {
                }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.oniput = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} event
         * @return {?}
         */
        MdbInput.prototype.onkeydown = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                try {
                    if (event.target.type === 'number') {
                        if (event.shiftKey) {
                            switch (event.keyCode) {
                                case 38:
                                    event.target.value = +event.target.value + 10;
                                    break;
                                case 40:
                                    event.target.value = +event.target.value - 10;
                                    break;
                            }
                        }
                        if (event.altKey) {
                            switch (event.keyCode) {
                                case 38:
                                    event.target.value = +event.target.value + 0.1;
                                    break;
                                case 40:
                                    event.target.value = +event.target.value - 0.1;
                                    break;
                            }
                        }
                    }
                }
                catch (error) { }
                this.delayedResize();
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.oncut = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) { }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.onpaste = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) { }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.ondrop = /**
         * @return {?}
         */
            function () {
                var _this = this;
                try {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.delayedResize();
                    }), 0);
                }
                catch (error) { }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                if (this.isBrowser) {
                    try {
                        this.element = document.querySelector('.md-textarea-auto');
                    }
                    catch (error) { }
                }
                /** @type {?} */
                var type = this.el.nativeElement.type;
                if (this.focusCheckbox && type === 'checkbox') {
                    this._renderer.addClass(this.el.nativeElement, 'onFocusSelect');
                }
                if (this.focusRadio && type === 'radio') {
                    this._renderer.addClass(this.el.nativeElement, 'onFocusSelect');
                }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.ngAfterViewChecked = /**
         * @return {?}
         */
            function () {
                this.initComponent();
                this.checkValue();
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.resize = /**
         * @return {?}
         */
            function () {
                if (this.el.nativeElement.classList.contains('md-textarea-auto')) {
                    this._renderer.setStyle(this.el.nativeElement, 'height', 'auto');
                    this._renderer.setStyle(this.el.nativeElement, 'height', this.el.nativeElement.scrollHeight + 'px');
                }
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.delayedResize = /**
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.resize();
                }), 0);
            };
        /**
         * @return {?}
         */
        MdbInput.prototype.initComponent = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var inputId;
                /** @type {?} */
                var inputP;
                if (this.isBrowser) {
                    try {
                        inputId = this.el.nativeElement.id;
                    }
                    catch (err) { }
                    try {
                        inputP = this.el.nativeElement.parentNode;
                    }
                    catch (err) { }
                    this.elLabel = inputP.querySelector('label[for="' + inputId + '"]') || inputP.querySelector('label');
                    if (this.elLabel && this.el.nativeElement.value !== '') {
                        this._renderer.addClass(this.elLabel, 'active');
                    }
                    this.elIcon = inputP.querySelector('i') || false;
                    if (this.elIcon) {
                        this._renderer.addClass(this.elIcon, 'active');
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        MdbInput.prototype.checkValue = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var value = '';
                if (this.elLabel != null) {
                    value = this.el.nativeElement.value || '';
                    if (value === '') {
                        this._renderer.removeClass(this.elLabel, 'active');
                        if (this.elIcon) {
                            this._renderer.removeClass(this.elIcon, 'active');
                        }
                    }
                    if (value === '' && this.isClicked ||
                        value === '' && this.el.nativeElement.placeholder ||
                        value === '' && this.el.nativeElement.attributes.placeholder) {
                        this._renderer.addClass(this.elLabel, 'active');
                    }
                }
            };
        MdbInput.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbInput]'
                    },] }
        ];
        /** @nocollapse */
        MdbInput.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 },
                { type: String, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        MdbInput.propDecorators = {
            focusCheckbox: [{ type: i0.Input, args: ['focusCheckbox',] }],
            focusRadio: [{ type: i0.Input, args: ['focusRadio',] }],
            onfocus: [{ type: i0.HostListener, args: ['focus',] }],
            onblur: [{ type: i0.HostListener, args: ['blur',] }],
            onchange: [{ type: i0.HostListener, args: ['change',] }],
            oniput: [{ type: i0.HostListener, args: ['input',] }],
            onkeydown: [{ type: i0.HostListener, args: ['keydown', ['$event'],] }],
            oncut: [{ type: i0.HostListener, args: ['cut',] }],
            onpaste: [{ type: i0.HostListener, args: ['paste',] }],
            ondrop: [{ type: i0.HostListener, args: ['drop',] }]
        };
        return MdbInput;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InputsModule = /** @class */ (function () {
        function InputsModule() {
        }
        /**
         * @return {?}
         */
        InputsModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: InputsModule, providers: [] };
            };
        InputsModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [MdbInput, MdbInputDirective, EqualValidatorDirective],
                        exports: [MdbInput, MdbInputDirective, EqualValidatorDirective],
                        schemas: [i0.NO_ERRORS_SCHEMA],
                    },] }
        ];
        return InputsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalOptions = /** @class */ (function () {
        function ModalOptions() {
        }
        ModalOptions.decorators = [
            { type: i0.Injectable }
        ];
        return ModalOptions;
    }());
    var MDBModalRef = /** @class */ (function () {
        function MDBModalRef() {
        }
        /**
         * Hides the modal
         */
        /**
         * Hides the modal
         * @return {?}
         */
        MDBModalRef.prototype.hide = /**
         * Hides the modal
         * @return {?}
         */
            function () { };
        MDBModalRef.decorators = [
            { type: i0.Injectable }
        ];
        return MDBModalRef;
    }());
    /** @type {?} */
    var modalConfigDefaults = {
        backdrop: true,
        keyboard: true,
        focus: true,
        show: false,
        ignoreBackdropClick: false,
        class: '',
        containerClass: '',
        animated: true,
        scroll: false,
        data: {}
    };
    /** @type {?} */
    var ClassName = {
        SCROLLBAR_MEASURER: 'modal-scrollbar-measure',
        BACKDROP: 'modal-backdrop',
        OPEN: 'modal-open',
        FADE: 'fade',
        IN: 'in',
        // bs3
        SHOW: 'show' // bs4
    };
    /** @type {?} */
    var TransitionDurations = {
        MODAL: 300,
        BACKDROP: 150
    };
    /** @type {?} */
    var DISMISS_REASONS = {
        BACKRDOP: 'backdrop-click',
        ESC: 'esc'
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Utils$1 = /** @class */ (function () {
        function Utils() {
        }
        /**
         * @param {?} element
         * @return {?}
         */
        Utils.reflow = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                (( /**
                 * @param {?} bs
                 * @return {?}
                 */function (bs) { return bs; }))(element.offsetHeight);
            };
        // source: https://github.com/jquery/jquery/blob/master/src/css/var/getStyles.js
        // source: https://github.com/jquery/jquery/blob/master/src/css/var/getStyles.js
        /**
         * @param {?} elem
         * @return {?}
         */
        Utils.getStyles =
            // source: https://github.com/jquery/jquery/blob/master/src/css/var/getStyles.js
            /**
             * @param {?} elem
             * @return {?}
             */
            function (elem) {
                // Support: IE <=11 only, Firefox <=30 (#15098, #14150)
                // IE throws on elements created in popups
                // FF meanwhile throws on frame elements through "defaultView.getComputedStyle"
                /** @type {?} */
                var view = elem.ownerDocument.defaultView;
                if (!view || !view.opener) {
                    view = win;
                }
                return view.getComputedStyle(elem);
            };
        /**
         * @param {?} event
         * @param {?} el
         * @return {?}
         */
        Utils.prototype.focusTrapModal = /**
         * @param {?} event
         * @param {?} el
         * @return {?}
         */
            function (event, el) {
                /** @type {?} */
                var focusableElements;
                /** @type {?} */
                var firstFocusableElement;
                /** @type {?} */
                var lastFocusableElement;
                /** @type {?} */
                var KEYCODE_TAB = 9;
                /*tslint:disable-next-line:max-line-length */
                focusableElements = el.nativeElement.querySelectorAll('a[href], button, textarea, input, select, form, mdb-select, mdb-auto-completer, mdb-checkbox, mdb-range-input');
                firstFocusableElement = focusableElements[0];
                lastFocusableElement = focusableElements[focusableElements.length - 1];
                if (event.key === 'Tab' || event.keyCode === KEYCODE_TAB) {
                    if (event.shiftKey) {
                        if (document$1 && document$1.activeElement === firstFocusableElement) {
                            lastFocusableElement.focus();
                            event.preventDefault();
                        }
                    }
                    else {
                        if (document$1 && document$1.activeElement === lastFocusableElement) {
                            firstFocusableElement.focus();
                            event.preventDefault();
                        }
                    }
                }
            };
        /**
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
        Utils.prototype.getClosestEl = /**
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
            function (el, selector) {
                for (; el && el !== document$1; el = el.parentNode) {
                    if (el.matches && el.matches(selector)) {
                        return el;
                    }
                }
                return null;
            };
        /**
         * @param {?} elem
         * @return {?}
         */
        Utils.prototype.getCoords = /**
         * @param {?} elem
         * @return {?}
         */
            function (elem) {
                /** @type {?} */
                var box = elem.getBoundingClientRect();
                /** @type {?} */
                var body = document$1.body;
                /** @type {?} */
                var docEl = document$1.documentElement;
                /** @type {?} */
                var scrollTop = win.pageYOffset || docEl.scrollTop || body.scrollTop;
                /** @type {?} */
                var scrollLeft = win.pageXOffset || docEl.scrollLeft || body.scrollLeft;
                /** @type {?} */
                var clientTop = docEl.clientTop || body.clientTop || 0;
                /** @type {?} */
                var clientLeft = docEl.clientLeft || body.clientLeft || 0;
                /** @type {?} */
                var top = box.top + scrollTop - clientTop;
                /** @type {?} */
                var left = box.left + scrollLeft - clientLeft;
                return { top: Math.round(top), left: Math.round(left) };
            };
        return Utils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalBackdropOptions = /** @class */ (function () {
        function ModalBackdropOptions(options) {
            this.animate = true;
            Object.assign(this, options);
        }
        return ModalBackdropOptions;
    }());
    /**
     * This component will be added as background layout for modals if enabled
     */
    var ModalBackdropComponent = /** @class */ (function () {
        function ModalBackdropComponent(element, renderer) {
            this.classNameBackDrop = true;
            this._isShown = false;
            this.element = element;
            this.renderer = renderer;
        }
        Object.defineProperty(ModalBackdropComponent.prototype, "isAnimated", {
            get: /**
             * @return {?}
             */ function () {
                return this._isAnimated;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._isAnimated = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ModalBackdropComponent.prototype, "isShown", {
            get: /**
             * @return {?}
             */ function () {
                return this._isShown;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._isShown = value;
                if (value) {
                    this.renderer.addClass(this.element.nativeElement, "" + ClassName.IN);
                    if (!isBs3()) {
                        this.renderer.addClass(this.element.nativeElement, "" + ClassName.SHOW);
                    }
                }
                else {
                    this.renderer.removeClass(this.element.nativeElement, "" + ClassName.IN);
                    if (!isBs3()) {
                        this.renderer.removeClass(this.element.nativeElement, "" + ClassName.SHOW);
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ModalBackdropComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.isAnimated) {
                    this.renderer.addClass(this.element.nativeElement, "" + ClassName.FADE);
                    Utils$1.reflow(this.element.nativeElement);
                }
                else {
                    this.renderer.addClass(this.element.nativeElement, "" + ClassName.FADE);
                    Utils$1.reflow(this.element.nativeElement);
                }
                this.isShown = true;
            };
        ModalBackdropComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-modal-backdrop',
                        template: ""
                    }] }
        ];
        /** @nocollapse */
        ModalBackdropComponent.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        ModalBackdropComponent.propDecorators = {
            classNameBackDrop: [{ type: i0.HostBinding, args: ['class.modal-backdrop',] }]
        };
        return ModalBackdropComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TRANSITION_DURATION = 300;
    /** @type {?} */
    var BACKDROP_TRANSITION_DURATION = 150;
    /**
     * Mark any code with directive to show it's content in modal
     */
    var ModalDirective = /** @class */ (function () {
        function ModalDirective(_element, _viewContainerRef, _renderer, clf) {
            /**
             * This event fires immediately when the `show` instance method is called.
             */
            this.onShow = new i0.EventEmitter();
            this.open = new i0.EventEmitter();
            /**
             * This event is fired when the modal has been made visible to the user (will wait for CSS transitions to complete)
             */
            this.onShown = new i0.EventEmitter();
            this.opened = new i0.EventEmitter();
            /**
             * This event is fired immediately when the hide instance method has been called.
             */
            this.onHide = new i0.EventEmitter();
            this.close = new i0.EventEmitter();
            /**
             * This event is fired when the modal has finished being hidden from the user (will wait for CSS transitions to complete).
             */
            this.onHidden = new i0.EventEmitter();
            this.closed = new i0.EventEmitter();
            // seems like an Options
            this.isAnimated = true;
            this._isShown = false;
            this.isBodyOverflowing = false;
            this.originalBodyPadding = 0;
            this.scrollbarWidth = 0;
            this.timerHideModal = 0;
            this.timerRmBackDrop = 0;
            this.isNested = false;
            this.utils = new Utils$1();
            this._element = _element;
            this._renderer = _renderer;
            this._backdrop = clf.createLoader(_element, _viewContainerRef, _renderer);
        }
        Object.defineProperty(ModalDirective.prototype, "config", {
            // public get config(): ModalOptions {
            get: 
            // public get config(): ModalOptions {
            /**
             * @return {?}
             */
            function () {
                return this._config;
            },
            /** allows to set modal configuration via element property */
            set: /**
             * allows to set modal configuration via element property
             * @param {?} conf
             * @return {?}
             */ function (conf) {
                this._config = this.getConfig(conf);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ModalDirective.prototype, "isShown", {
            get: /**
             * @return {?}
             */ function () {
                return this._isShown;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        ModalDirective.prototype.onKeyDown = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.utils.focusTrapModal(event, this._element);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        ModalDirective.prototype.onClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.config.ignoreBackdropClick || this.config.backdrop === 'static' || event.target !== this._element.nativeElement) {
                    return;
                }
                this.dismissReason = DISMISS_REASONS.BACKRDOP;
                this.hide(event);
            };
        // todo: consider preventing default and stopping propagation
        // todo: consider preventing default and stopping propagation
        /**
         * @return {?}
         */
        ModalDirective.prototype.onEsc =
            // todo: consider preventing default and stopping propagation
            /**
             * @return {?}
             */
            function () {
                if (this.config.keyboard) {
                    this.dismissReason = DISMISS_REASONS.ESC;
                    this.hide();
                }
            };
        /**
         * @return {?}
         */
        ModalDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.config = void 0;
                if (this._isShown) {
                    this._isShown = false;
                    this.hideModal();
                    this._backdrop.dispose();
                }
            };
        /**
         * @return {?}
         */
        ModalDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._config = this._config || this.getConfig();
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    if (_this._config.show) {
                        _this.show();
                    }
                }), 0);
            };
        /* Public methods */
        /** Allows to manually toggle modal visibility */
        /* Public methods */
        /**
         * Allows to manually toggle modal visibility
         * @return {?}
         */
        ModalDirective.prototype.toggle = /* Public methods */
            /**
             * Allows to manually toggle modal visibility
             * @return {?}
             */
            function () {
                return this._isShown ? this.hide() : this.show();
            };
        /** Allows to manually open modal */
        /**
         * Allows to manually open modal
         * @return {?}
         */
        ModalDirective.prototype.show = /**
         * Allows to manually open modal
         * @return {?}
         */
            function () {
                var _this = this;
                this.dismissReason = null;
                this.onShow.emit(this);
                this.open.emit(this);
                if (this._isShown) {
                    return;
                }
                clearTimeout(this.timerHideModal);
                clearTimeout(this.timerRmBackDrop);
                this._isShown = true;
                this.checkScrollbar();
                this.setScrollbar();
                if (document$1 && document$1.body) {
                    if (document$1.body.classList.contains(ClassName.OPEN)) {
                        this.isNested = true;
                    }
                    else {
                        this._renderer.addClass(document$1.body, ClassName.OPEN);
                    }
                }
                this.showBackdrop(( /**
                 * @return {?}
                 */function () {
                    _this.showElement();
                }));
                if (!this.config.backdrop && this.config.ignoreBackdropClick) {
                    /** @type {?} */
                    var modalHeight = this._element.nativeElement.firstElementChild.firstElementChild.clientHeight + 12;
                    this._renderer.setStyle(this._element.nativeElement, 'position', 'fixed');
                    this._renderer.setStyle(this._element.nativeElement, 'height', modalHeight + "px");
                    if (navigator$1.userAgent.indexOf('Safari') != -1 && navigator$1.userAgent.indexOf('Chrome') == -1) {
                        this._renderer.setStyle(this._element.nativeElement, 'overflow', 'unset');
                        this._renderer.setStyle(this._element.nativeElement, 'overflow-y', 'unset');
                        this._renderer.setStyle(this._element.nativeElement, 'overflow-x', 'unset');
                    }
                }
            };
        /** Allows to manually close modal */
        /**
         * Allows to manually close modal
         * @param {?=} event
         * @return {?}
         */
        ModalDirective.prototype.hide = /**
         * Allows to manually close modal
         * @param {?=} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                if (event) {
                    event.preventDefault();
                }
                this.onHide.emit(this);
                this.close.emit(this);
                // todo: add an option to prevent hiding
                if (!this._isShown) {
                    return;
                }
                clearTimeout(this.timerHideModal);
                clearTimeout(this.timerRmBackDrop);
                this._isShown = false;
                this._renderer.removeClass(this._element.nativeElement, ClassName.IN);
                if (!isBs3()) {
                    this._renderer.removeClass(this._element.nativeElement, ClassName.SHOW);
                }
                if (this.isAnimated) {
                    this.timerHideModal = setTimeout(( /**
                     * @return {?}
                     */function () { return _this.hideModal(); }), TRANSITION_DURATION);
                }
                else {
                    this.hideModal();
                }
            };
        /** Private methods @internal */
        /**
         * Private methods \@internal
         * @protected
         * @param {?=} config
         * @return {?}
         */
        ModalDirective.prototype.getConfig = /**
         * Private methods \@internal
         * @protected
         * @param {?=} config
         * @return {?}
         */
            function (config) {
                return Object.assign({}, modalConfigDefaults, config);
            };
        /**
         *  Show dialog
         *  @internal
         */
        /**
         *  Show dialog
         * \@internal
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.showElement = /**
         *  Show dialog
         * \@internal
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                // todo: replace this with component loader usage
                if (!this._element.nativeElement.parentNode ||
                    (this._element.nativeElement.parentNode.nodeType !== Node.ELEMENT_NODE)) {
                    // don't move modals dom position
                    if (document$1 && document$1.body) {
                        document$1.body.appendChild(this._element.nativeElement);
                    }
                }
                this._renderer.setAttribute(this._element.nativeElement, 'aria-hidden', 'false');
                this._renderer.setStyle(this._element.nativeElement, 'display', 'block');
                this._renderer.setProperty(this._element.nativeElement, 'scrollTop', 0);
                if (this.isAnimated) {
                    Utils$1.reflow(this._element.nativeElement);
                }
                this._renderer.addClass(this._element.nativeElement, ClassName.IN);
                if (!isBs3()) {
                    this._renderer.addClass(this._element.nativeElement, ClassName.SHOW);
                }
                /** @type {?} */
                var transitionComplete = ( /**
                 * @return {?}
                 */function () {
                    if (_this._config.focus) {
                        _this._element.nativeElement.focus();
                    }
                    _this.onShown.emit(_this);
                    _this.opened.emit(_this);
                });
                if (this.isAnimated) {
                    setTimeout(transitionComplete, TRANSITION_DURATION);
                }
                else {
                    transitionComplete();
                }
            };
        /** @internal */
        /**
         * \@internal
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.hideModal = /**
         * \@internal
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                this._renderer.setAttribute(this._element.nativeElement, 'aria-hidden', 'true');
                this._renderer.setStyle(this._element.nativeElement, 'display', 'none');
                this.showBackdrop(( /**
                 * @return {?}
                 */function () {
                    if (!_this.isNested) {
                        if (document$1 && document$1.body) {
                            _this._renderer.removeClass(document$1.body, ClassName.OPEN);
                        }
                        _this.resetScrollbar();
                    }
                    _this.resetAdjustments();
                    _this.focusOtherModal();
                    _this.onHidden.emit(_this);
                    _this.closed.emit(_this);
                }));
            };
        // todo: original show was calling a callback when done, but we can use promise
        /** @internal */
        // todo: original show was calling a callback when done, but we can use promise
        /**
         * \@internal
         * @protected
         * @param {?=} callback
         * @return {?}
         */
        ModalDirective.prototype.showBackdrop =
            // todo: original show was calling a callback when done, but we can use promise
            /**
             * \@internal
             * @protected
             * @param {?=} callback
             * @return {?}
             */
            function (callback) {
                var _this = this;
                if (this._isShown && this.config.backdrop && (!this.backdrop || !this.backdrop.instance.isShown)) {
                    this.removeBackdrop();
                    this._backdrop
                        .attach(ModalBackdropComponent)
                        .to('body')
                        .show({ isAnimated: this.isAnimated });
                    this.backdrop = this._backdrop._componentRef;
                    if (!callback) {
                        return;
                    }
                    if (!this.isAnimated) {
                        callback();
                        return;
                    }
                    setTimeout(callback, BACKDROP_TRANSITION_DURATION);
                }
                else if (!this._isShown && this.backdrop) {
                    this.backdrop.instance.isShown = false;
                    /** @type {?} */
                    var callbackRemove = ( /**
                     * @return {?}
                     */function () {
                        _this.removeBackdrop();
                        if (callback) {
                            callback();
                        }
                    });
                    if (this.backdrop.instance.isAnimated) {
                        this.timerRmBackDrop = setTimeout(callbackRemove, BACKDROP_TRANSITION_DURATION);
                    }
                    else {
                        callbackRemove();
                    }
                }
                else if (callback) {
                    callback();
                }
            };
        /** @internal */
        /**
         * \@internal
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.removeBackdrop = /**
         * \@internal
         * @protected
         * @return {?}
         */
            function () {
                this._backdrop.hide();
            };
        /**
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.focusOtherModal = /**
         * @protected
         * @return {?}
         */
            function () {
                try {
                    /** @type {?} */
                    var otherOpenedModals = this._element.nativeElement.parentElement.querySelectorAll('.in[mdbModal]');
                    if (!otherOpenedModals.length) {
                        return;
                    }
                    //  this._renderer.invokeElementMethod(otherOpenedModals[otherOpenedModals.length - 1], 'focus');
                    otherOpenedModals[otherOpenedModals.length - 1].nativeElement.focus();
                }
                catch (error) {
                }
            };
        /** @internal */
        /**
         * \@internal
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.resetAdjustments = /**
         * \@internal
         * @protected
         * @return {?}
         */
            function () {
                this._renderer.setStyle(this._element.nativeElement, 'paddingLeft', '');
                this._renderer.setStyle(this._element.nativeElement, 'paddingRight', '');
            };
        /** Scroll bar tricks */
        /** @internal */
        /** Scroll bar tricks */
        /**
         * \@internal
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.checkScrollbar = /** Scroll bar tricks */
            /**
             * \@internal
             * @protected
             * @return {?}
             */
            function () {
                this.isBodyOverflowing = document$1.body.clientWidth < win.innerWidth;
                this.scrollbarWidth = this.getScrollbarWidth();
            };
        /**
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.setScrollbar = /**
         * @protected
         * @return {?}
         */
            function () {
                if (!document$1) {
                    return;
                }
                this.originalBodyPadding = parseInt(win.getComputedStyle(document$1.body).getPropertyValue('padding-right') || 0, 10);
                if (this.isBodyOverflowing) {
                    document$1.body.style.paddingRight = this.originalBodyPadding + this.scrollbarWidth + "px";
                }
            };
        /**
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.resetScrollbar = /**
         * @protected
         * @return {?}
         */
            function () {
                document$1.body.style.paddingRight = this.originalBodyPadding;
            };
        // thx d.walsh
        // thx d.walsh
        /**
         * @protected
         * @return {?}
         */
        ModalDirective.prototype.getScrollbarWidth =
            // thx d.walsh
            /**
             * @protected
             * @return {?}
             */
            function () {
                /** @type {?} */
                var scrollDiv = this._renderer.createElement('div', void 0);
                this._renderer.appendChild(document$1.body, scrollDiv);
                scrollDiv.className = ClassName.SCROLLBAR_MEASURER;
                /** @type {?} */
                var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
                document$1.body.removeChild(scrollDiv);
                return scrollbarWidth;
            };
        ModalDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbModal]',
                        exportAs: 'mdb-modal, mdbModal'
                    },] }
        ];
        /** @nocollapse */
        ModalDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.ViewContainerRef },
                { type: i0.Renderer2 },
                { type: ComponentLoaderFactory }
            ];
        };
        ModalDirective.propDecorators = {
            config: [{ type: i0.Input }],
            onShow: [{ type: i0.Output }],
            open: [{ type: i0.Output }],
            onShown: [{ type: i0.Output }],
            opened: [{ type: i0.Output }],
            onHide: [{ type: i0.Output }],
            close: [{ type: i0.Output }],
            onHidden: [{ type: i0.Output }],
            closed: [{ type: i0.Output }],
            onKeyDown: [{ type: i0.HostListener, args: ['keydown', ['$event'],] }],
            onClick: [{ type: i0.HostListener, args: ['click', ['$event'],] }],
            onEsc: [{ type: i0.HostListener, args: ['keydown.esc',] }]
        };
        return ModalDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var msConfig = {
        serviceInstance: new Object()
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalContainerComponent = /** @class */ (function () {
        function ModalContainerComponent(options, _element, _renderer) {
            this._renderer = _renderer;
            this.modalClass = 'modal';
            this.tabindex = -1;
            this.role = 'dialog';
            this.modal = true;
            this.isShown = false;
            this.isModalHiding = false;
            this.mdbModalService = msConfig.serviceInstance;
            this._element = _element;
            this.config = Object.assign({}, options);
        }
        /**
         * @param {?} event
         * @return {?}
         */
        ModalContainerComponent.prototype.onClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.config.ignoreBackdropClick ||
                    this.config.backdrop === 'static' ||
                    event.target !== this._element.nativeElement) {
                    return;
                }
                this.mdbModalService.setDismissReason(DISMISS_REASONS.BACKRDOP);
                this.hide();
            };
        /**
         * @return {?}
         */
        ModalContainerComponent.prototype.onEsc = /**
         * @return {?}
         */
            function () {
                if (this.config.keyboard &&
                    this.level === this.mdbModalService.getModalsCount()) {
                    this.mdbModalService.setDismissReason(DISMISS_REASONS.ESC);
                    this.hide();
                }
            };
        /**
         * @return {?}
         */
        ModalContainerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.config.animated) {
                    this._renderer.addClass(this._element.nativeElement, 'fade');
                }
                this._renderer.setStyle(this._element.nativeElement, 'display', 'block');
                if (window && window.navigator.userAgent.indexOf('Edge') !== -1 && this.config && this.config.toString().indexOf('side-modal') === -1 ||
                    window && window.navigator.userAgent.indexOf('Edge') !== -1 && this.config && this.config.toString().indexOf('modal-full-height') === -1) {
                    this.isShown = true;
                    this._renderer.addClass(this._element.nativeElement, isBs3() ? ClassName.IN : ClassName.SHOW);
                    this._renderer.setStyle(this._element.nativeElement, 'transition', 'transform 0.3s ease-out');
                    this._renderer.setStyle(this._element.nativeElement, 'transform', 'translate(0, 25px)');
                }
                else {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.isShown = true;
                        _this._renderer.addClass(_this._element.nativeElement, isBs3() ? ClassName.IN : ClassName.SHOW);
                    }), this.isAnimated ? TransitionDurations.BACKDROP : 0);
                }
                if (document && document.body) {
                    if (this.mdbModalService.getModalsCount() === 1) {
                        this.mdbModalService.checkScrollbar();
                        this.mdbModalService.setScrollbar();
                    }
                    this._renderer.addClass(document.body, ClassName.OPEN);
                }
                if (this.config.containerClass) {
                    this.updateContainerClass();
                }
                if (this.config.scroll) {
                    this._renderer.setStyle(this._element.nativeElement, 'overflow-y', 'auto');
                }
            };
        /**
         * @return {?}
         */
        ModalContainerComponent.prototype.updateContainerClass = /**
         * @return {?}
         */
            function () {
                if (this.config.containerClass) {
                    /** @type {?} */
                    var containerClasses = this.config.containerClass;
                    /** @type {?} */
                    var classArr = containerClasses.split(' ');
                    for (var i = 0; i < classArr.length; i++) {
                        this._renderer.addClass(this._element.nativeElement, classArr[i]);
                    }
                }
            };
        /**
         * @return {?}
         */
        ModalContainerComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.isShown) {
                    this.hide();
                }
            };
        /**
         * @return {?}
         */
        ModalContainerComponent.prototype.hide = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.isModalHiding || !this.isShown) {
                    return;
                }
                this.isModalHiding = true;
                this._renderer.removeClass(this._element.nativeElement, isBs3() ? ClassName.IN : ClassName.SHOW);
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.isShown = false;
                    if (document &&
                        document.body &&
                        _this.mdbModalService.getModalsCount() === 1) {
                        _this._renderer.removeClass(document.body, ClassName.OPEN);
                    }
                    _this.mdbModalService.hide(_this.level);
                    _this.isModalHiding = false;
                }), this.isAnimated ? TransitionDurations.MODAL : 0);
            };
        ModalContainerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-modal-container',
                        template: "<div [class]=\"'modal-dialog' + (config.class ? ' ' + config.class : '')\" role=\"document\">\n  <div class=\"modal-content\"><ng-content></ng-content></div>\n</div>"
                    }] }
        ];
        /** @nocollapse */
        ModalContainerComponent.ctorParameters = function () {
            return [
                { type: ModalOptions },
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        ModalContainerComponent.propDecorators = {
            tabindex: [{ type: i0.HostBinding, args: ['tabindex',] }],
            role: [{ type: i0.HostBinding, args: ['role',] }],
            modal: [{ type: i0.HostBinding, args: ['class.modal',] }],
            onClick: [{ type: i0.HostListener, args: ['click', ['$event'],] }],
            onEsc: [{ type: i0.HostListener, args: ['window:keydown.esc',] }]
        };
        return ModalContainerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MDBModalService = /** @class */ (function () {
        // public constructor(private clf: ComponentLoaderFactory) {
        function MDBModalService(rendererFactory, clf) {
            this.clf = clf;
            // constructor props
            this.config = modalConfigDefaults;
            this.open = new i0.EventEmitter();
            this.opened = new i0.EventEmitter();
            this.close = new i0.EventEmitter();
            this.closed = new i0.EventEmitter();
            this.isBodyOverflowing = false;
            this.originalBodyPadding = 0;
            this.scrollbarWidth = 0;
            this.modalsCount = 0;
            // private lastDismissReason = '';
            this.lastDismissReason = '';
            this.loaders = [];
            //   this._backdropLoader = this.clf.createLoader<ModalBackdropComponent>(null, null, null);
            this._backdropLoader = this.clf.createLoader(this.el, this.vcr, this.renderer);
            this.renderer = rendererFactory.createRenderer(null, null);
            msConfig.serviceInstance = this;
        }
        /** Shows a modal */
        /**
         * Shows a modal
         * @param {?} content
         * @param {?=} config
         * @return {?}
         */
        MDBModalService.prototype.show = /**
         * Shows a modal
         * @param {?} content
         * @param {?=} config
         * @return {?}
         */
            function (content, config) {
                this.modalsCount++;
                this._createLoaders();
                this.config = Object.assign({}, modalConfigDefaults, config);
                this._showBackdrop();
                this.lastDismissReason = null;
                return this._showModal(content);
            };
        /**
         * @param {?} level
         * @return {?}
         */
        MDBModalService.prototype.hide = /**
         * @param {?} level
         * @return {?}
         */
            function (level) {
                var _this = this;
                if (this.modalsCount === 1) {
                    this._hideBackdrop();
                    this.resetScrollbar();
                }
                this.modalsCount = this.modalsCount >= 1 ? this.modalsCount - 1 : 0;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this._hideModal(level);
                    _this.removeLoaders(level);
                }), this.config.animated ? TransitionDurations.BACKDROP : 0);
            };
        /**
         * @return {?}
         */
        MDBModalService.prototype._showBackdrop = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var isBackdropEnabled = this.config.backdrop || this.config.backdrop === 'static';
                /** @type {?} */
                var isBackdropInDOM = !this.backdropRef || !this.backdropRef.instance.isShown;
                if (this.modalsCount === 1) {
                    this.removeBackdrop();
                    if (isBackdropEnabled && isBackdropInDOM) {
                        this._backdropLoader
                            .attach(ModalBackdropComponent)
                            .to('body')
                            .show({ isAnimated: this.config.animated });
                        this.backdropRef = this._backdropLoader._componentRef;
                    }
                }
            };
        /**
         * @return {?}
         */
        MDBModalService.prototype._hideBackdrop = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.backdropRef) {
                    return;
                }
                this.backdropRef.instance.isShown = false;
                /** @type {?} */
                var duration = this.config.animated ? TransitionDurations.BACKDROP : 0;
                setTimeout(( /**
                 * @return {?}
                 */function () { return _this.removeBackdrop(); }), duration);
            };
        /**
         * @param {?} content
         * @return {?}
         */
        MDBModalService.prototype._showModal = /**
         * @param {?} content
         * @return {?}
         */
            function (content) {
                /** @type {?} */
                var modalLoader = this.loaders[this.loaders.length - 1];
                /** @type {?} */
                var mdbModalRef = new MDBModalRef();
                /** @type {?} */
                var modalContainerRef = modalLoader
                    .provide({ provide: ModalOptions, useValue: this.config })
                    .provide({ provide: MDBModalRef, useValue: mdbModalRef })
                    .attach(ModalContainerComponent)
                    .to('body')
                    .show({ content: content, isAnimated: this.config.animated, data: this.config.data });
                modalContainerRef.instance.level = this.getModalsCount();
                mdbModalRef.hide = ( /**
                 * @return {?}
                 */function () {
                    modalContainerRef.instance.hide();
                });
                mdbModalRef.content = modalLoader.getInnerComponent() || null;
                return mdbModalRef;
            };
        /**
         * @param {?} level
         * @return {?}
         */
        MDBModalService.prototype._hideModal = /**
         * @param {?} level
         * @return {?}
         */
            function (level) {
                /** @type {?} */
                var modalLoader = this.loaders[level - 1];
                if (modalLoader) {
                    modalLoader.hide();
                }
            };
        /**
         * @return {?}
         */
        MDBModalService.prototype.getModalsCount = /**
         * @return {?}
         */
            function () {
                return this.modalsCount;
            };
        /**
         * @param {?} reason
         * @return {?}
         */
        MDBModalService.prototype.setDismissReason = /**
         * @param {?} reason
         * @return {?}
         */
            function (reason) {
                this.lastDismissReason = reason;
            };
        /**
         * @protected
         * @return {?}
         */
        MDBModalService.prototype.removeBackdrop = /**
         * @protected
         * @return {?}
         */
            function () {
                this._backdropLoader.hide();
                this.backdropRef = null;
            };
        /** AFTER PR MERGE MODAL.COMPONENT WILL BE USING THIS CODE*/
        /** Scroll bar tricks */
        /** @internal */
        /** AFTER PR MERGE MODAL.COMPONENT WILL BE USING THIS CODE*/
        /** Scroll bar tricks */
        /**
         * \@internal
         * @return {?}
         */
        MDBModalService.prototype.checkScrollbar = /** AFTER PR MERGE MODAL.COMPONENT WILL BE USING THIS CODE*/
            /** Scroll bar tricks */
            /**
             * \@internal
             * @return {?}
             */
            function () {
                this.isBodyOverflowing = document.body.clientWidth < window.innerWidth;
                this.scrollbarWidth = this.getScrollbarWidth();
            };
        /**
         * @return {?}
         */
        MDBModalService.prototype.setScrollbar = /**
         * @return {?}
         */
            function () {
                if (!document) {
                    return;
                }
                this.originalBodyPadding = parseInt(window.getComputedStyle(document.body).getPropertyValue('padding-right') || '0', 10);
                if (this.isBodyOverflowing) {
                    document.body.style.paddingRight = this.originalBodyPadding + this.scrollbarWidth + "px";
                }
            };
        /**
         * @private
         * @return {?}
         */
        MDBModalService.prototype.resetScrollbar = /**
         * @private
         * @return {?}
         */
            function () {
                document.body.style.paddingRight = this.originalBodyPadding + 'px';
            };
        // thx d.walsh
        // thx d.walsh
        /**
         * @private
         * @return {?}
         */
        MDBModalService.prototype.getScrollbarWidth =
            // thx d.walsh
            /**
             * @private
             * @return {?}
             */
            function () {
                /** @type {?} */
                var scrollDiv = this.renderer.createElement('div');
                this.renderer.addClass(scrollDiv, ClassName.SCROLLBAR_MEASURER);
                this.renderer.appendChild(document.body, scrollDiv);
                /** @type {?} */
                var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
                this.renderer.removeChild(document.body, scrollDiv);
                return scrollbarWidth;
            };
        /**
         * @private
         * @return {?}
         */
        MDBModalService.prototype._createLoaders = /**
         * @private
         * @return {?}
         */
            function () {
                // const loader = this.clf.createLoader<ModalContainerComponent>(null, null, null);
                /** @type {?} */
                var loader = this.clf.createLoader(this.el, this.vcr, this.renderer);
                this.copyEvent(loader.onBeforeShow, this.open);
                this.copyEvent(loader.onShown, this.opened);
                this.copyEvent(loader.onBeforeHide, this.close);
                this.copyEvent(loader.onHidden, this.closed);
                this.loaders.push(loader);
            };
        /**
         * @private
         * @param {?} level
         * @return {?}
         */
        MDBModalService.prototype.removeLoaders = /**
         * @private
         * @param {?} level
         * @return {?}
         */
            function (level) {
                this.loaders.splice(level - 1, 1);
                this.loaders.forEach(( /**
                 * @param {?} loader
                 * @param {?} i
                 * @return {?}
                 */function (loader, i) {
                    loader.instance.level = i + 1;
                }));
            };
        /**
         * @private
         * @param {?} from
         * @param {?} to
         * @return {?}
         */
        MDBModalService.prototype.copyEvent = /**
         * @private
         * @param {?} from
         * @param {?} to
         * @return {?}
         */
            function (from, to) {
                var _this = this;
                from.subscribe(( /**
                 * @return {?}
                 */function () {
                    to.emit(_this.lastDismissReason);
                }));
            };
        MDBModalService.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        MDBModalService.ctorParameters = function () {
            return [
                { type: i0.RendererFactory2 },
                { type: ComponentLoaderFactory }
            ];
        };
        return MDBModalService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalModule = /** @class */ (function () {
        function ModalModule() {
        }
        /**
         * @return {?}
         */
        ModalModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: ModalModule, providers: [MDBModalService, ComponentLoaderFactory, PositioningService] };
            };
        ModalModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [ModalBackdropComponent, ModalDirective, ModalContainerComponent],
                        exports: [ModalBackdropComponent, ModalDirective],
                        entryComponents: [ModalBackdropComponent, ModalContainerComponent],
                        schemas: [i0.NO_ERRORS_SCHEMA]
                    },] }
        ];
        return ModalModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NavbarService = /** @class */ (function () {
        function NavbarService() {
            this.navbarLinkClicks = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        NavbarService.prototype.getNavbarLinkClicks = /**
         * @return {?}
         */
            function () {
                return this.navbarLinkClicks.asObservable();
            };
        /**
         * @return {?}
         */
        NavbarService.prototype.setNavbarLinkClicks = /**
         * @return {?}
         */
            function () {
                this.navbarLinkClicks.next();
            };
        NavbarService.decorators = [
            { type: i0.Injectable }
        ];
        return NavbarService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LinksComponent = /** @class */ (function () {
        function LinksComponent(_navbarService) {
            this._navbarService = _navbarService;
            this.linkClick = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        LinksComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var that = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    that.links.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        element.nativeElement.onclick = ( /**
                         * @return {?}
                         */function () {
                            that._navbarService.setNavbarLinkClicks();
                        });
                    }));
                }), 0);
            };
        LinksComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'links',
                        template: " <ng-content></ng-content> "
                    }] }
        ];
        /** @nocollapse */
        LinksComponent.ctorParameters = function () {
            return [
                { type: NavbarService }
            ];
        };
        LinksComponent.propDecorators = {
            links: [{ type: i0.ContentChildren, args: [router.RouterLinkWithHref, { read: i0.ElementRef, descendants: true },] }],
            linkClick: [{ type: i0.Output }]
        };
        return LinksComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NavbarComponent = /** @class */ (function () {
        function NavbarComponent(renderer, _navbarService) {
            var _this = this;
            this.renderer = renderer;
            this._navbarService = _navbarService;
            this.containerInside = true;
            this.collapseId = 'navbarCollapse';
            this.scrollSensitivity = 120;
            this.scrollableNavbar = false;
            this.shown = false;
            this.duration = 350; // ms
            // ms
            this.collapse = true;
            this.showClass = false;
            this.collapsing = false;
            this._itemsLength = 0;
            this.ariaExpanded = false;
            // tslint:disable-next-line:max-line-length
            this.subscription = this._navbarService.getNavbarLinkClicks().subscribe(( /**
             * @param {?} navbarLinkClicks
             * @return {?}
             */function (navbarLinkClicks) {
                _this.closeNavbarOnClick(navbarLinkClicks);
            }));
        }
        /**
         * @param {?} navbarLinkClicks
         * @return {?}
         */
        NavbarComponent.prototype.closeNavbarOnClick = /**
         * @param {?} navbarLinkClicks
         * @return {?}
         */
            function (navbarLinkClicks) {
                this.navbarLinkClicks = navbarLinkClicks;
                if (this.showClass) {
                    this.hide();
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.addTogglerIconClasses = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.iconBackground) {
                    if (Array.isArray(this.iconBackground)) {
                        this.iconBackground.forEach(( /**
                         * @param {?} iconClass
                         * @return {?}
                         */function (iconClass) {
                            _this.renderer.addClass(_this.toggler.nativeElement, iconClass);
                        }));
                    }
                    else {
                        this.renderer.addClass(this.toggler.nativeElement, this.iconBackground);
                    }
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var isDoubleNav = this.SideClass.split(' ');
                if (isDoubleNav.indexOf('double-nav') !== -1) {
                    this.doubleNav = true;
                }
                else {
                    this.doubleNav = false;
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.containerInside) {
                    /** @type {?} */
                    var childrens = Array.from(this.container.nativeElement.children);
                    childrens.forEach(( /**
                     * @param {?} child
                     * @return {?}
                     */function (child) {
                        _this.renderer.appendChild(_this.navbar.nativeElement, child);
                        _this.container.nativeElement.remove();
                    }));
                }
                if (this.el.nativeElement.children.length === 0) {
                    this.el.nativeElement.remove();
                }
                this.addTogglerIconClasses();
                if (this.scrollableNavbar) {
                    this.renderer.addClass(this.el.nativeElement, 'collapsed-navbar-scroll');
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.toggle = /**
         * @return {?}
         */
            function () {
                if (!this.collapsing) {
                    if (this.shown) {
                        this.hide();
                    }
                    else {
                        this.show();
                    }
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.show = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.shown = true;
                this.collapse = false;
                this.collapsing = true;
                this.ariaExpanded = true;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.height = _this.el.nativeElement.scrollHeight;
                    _this.renderer.setStyle(_this.el.nativeElement, 'height', _this.height + 'px');
                }), 0);
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.collapsing = false;
                    _this.collapse = true;
                    _this.showClass = true;
                }), this.duration);
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.hide = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.shown) {
                    this.shown = false;
                    this.collapse = false;
                    this.showClass = false;
                    this.collapsing = true;
                    this.ariaExpanded = false;
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.renderer.setStyle(_this.el.nativeElement, 'height', '0px');
                    }), 0);
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.collapsing = false;
                        _this.collapse = true;
                    }), this.duration);
                }
            };
        Object.defineProperty(NavbarComponent.prototype, "displayStyle", {
            get: /**
             * @return {?}
             */ function () {
                if (!this.containerInside) {
                    return 'flex';
                }
                else {
                    return '';
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        NavbarComponent.prototype.onResize = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                /** @type {?} */
                var breakpoit = 0;
                if (this.SideClass.includes('navbar-expand-xl')) {
                    breakpoit = 1200;
                }
                else if (this.SideClass.includes('navbar-expand-lg')) {
                    breakpoit = 992;
                }
                else if (this.SideClass.includes('navbar-expand-md')) {
                    breakpoit = 768;
                }
                else if (this.SideClass.includes('navbar-expand-sm')) {
                    breakpoit = 576;
                }
                else {
                    breakpoit = event.target.innerWidth + 1;
                }
                if (event.target.innerWidth < breakpoit) {
                    if (!this.shown) {
                        this.collapse = false;
                        this.renderer.setStyle(this.el.nativeElement, 'height', '0px');
                        this.renderer.setStyle(this.el.nativeElement, 'opacity', '0');
                        setTimeout(( /**
                         * @return {?}
                         */function () {
                            _this.height = _this.el.nativeElement.scrollHeight;
                            _this.collapse = true;
                            _this.renderer.setStyle(_this.el.nativeElement, 'opacity', '');
                        }), 4);
                    }
                }
                else {
                    this.collapsing = false;
                    this.shown = false;
                    this.showClass = false;
                    this.collapse = true;
                    this.ariaExpanded = false;
                    this.renderer.setStyle(this.el.nativeElement, 'height', '');
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.onScroll = /**
         * @return {?}
         */
            function () {
                if (this.navbar.nativeElement.classList.contains('scrolling-navbar')) {
                    if (window.pageYOffset > this.scrollSensitivity) {
                        this.renderer.addClass(this.navbar.nativeElement, 'top-nav-collapse');
                    }
                    else {
                        this.renderer.removeClass(this.navbar.nativeElement, 'top-nav-collapse');
                    }
                }
            };
        /**
         * @return {?}
         */
        NavbarComponent.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
            function () {
                if (this.el.nativeElement.firstElementChild) {
                    if (this._itemsLength !== this.el.nativeElement.firstElementChild.firstElementChild.children.length) {
                        this.height = this.el.nativeElement.firstElementChild.firstElementChild.clientHeight;
                        this.renderer.setStyle(this.el.nativeElement, 'height', this.height + 'px');
                    }
                    this._itemsLength = this.el.nativeElement.firstElementChild.firstElementChild.children.length;
                }
            };
        NavbarComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-navbar',
                        template: "<nav class=\"{{SideClass}}\" #nav>\n  <div [ngClass]=\"{'container': containerInside}\" [ngStyle]=\"{'display': displayStyle}\" #container>\n      <ng-content select=\"mdb-navbar-brand\"></ng-content>\n      <ng-content select=\"logo\"></ng-content>\n      <ng-content></ng-content>\n    <ng-content *ngIf=\"this.doubleNav == true\" select=\"navlinks\"></ng-content>\n    <div *ngIf=\"this.doubleNav == false\">\n      <button #toggler class=\"navbar-toggler\" type=\"button\" [attr.aria-controls]=\"collapseId\" [attr.aria-expanded]=\"ariaExpanded\" aria-label=\"Toggle navigation\" (click)=\"toggle(); $event.preventDefault()\" mdbWavesEffect *ngIf=\"this.el.nativeElement.children.length !== 0\">\n        <span class=\"navbar-toggler-icon\">\n        </span>\n      </button>\n    </div>\n    <div #navbar [attr.id]=\"collapseId\" [style.height]=\"height\" class=\"navbar-collapse collapse\" [ngClass]=\"{'collapse': collapse, 'show': showClass, 'collapsing': collapsing}\">\n      <ng-content select=\"links\"></ng-content>\n    </div>\n  </div>\n</nav>\n"
                    }] }
        ];
        /** @nocollapse */
        NavbarComponent.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: NavbarService }
            ];
        };
        NavbarComponent.propDecorators = {
            iconBackground: [{ type: i0.Input }],
            SideClass: [{ type: i0.Input }],
            containerInside: [{ type: i0.Input }],
            collapseId: [{ type: i0.Input }],
            scrollSensitivity: [{ type: i0.Input }],
            scrollableNavbar: [{ type: i0.Input }],
            el: [{ type: i0.ViewChild, args: ['navbar',] }],
            mobile: [{ type: i0.ViewChild, args: ['mobile',] }],
            navbar: [{ type: i0.ViewChild, args: ['nav',] }],
            container: [{ type: i0.ViewChild, args: ['container',] }],
            toggler: [{ type: i0.ViewChild, args: ['toggler',] }],
            links: [{ type: i0.ContentChild, args: [LinksComponent,] }],
            onResize: [{ type: i0.HostListener, args: ['window:resize', ['$event'],] }],
            onScroll: [{ type: i0.HostListener, args: ['document:scroll',] }]
        };
        return NavbarComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LogoComponent = /** @class */ (function () {
        function LogoComponent() {
        }
        LogoComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'logo, mdb-navbar-brand',
                        template: "<ng-content></ng-content>"
                    }] }
        ];
        return LogoComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NavlinksComponent = /** @class */ (function () {
        function NavlinksComponent(_navbarService) {
            this._navbarService = _navbarService;
            this.linkClick = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        NavlinksComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var that = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    that.links.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        element.nativeElement.onclick = ( /**
                         * @return {?}
                         */function () {
                            that._navbarService.setNavbarLinkClicks();
                        });
                    }));
                }), 0);
            };
        NavlinksComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'navlinks',
                        template: " <ng-content></ng-content> "
                    }] }
        ];
        /** @nocollapse */
        NavlinksComponent.ctorParameters = function () {
            return [
                { type: NavbarService }
            ];
        };
        NavlinksComponent.propDecorators = {
            links: [{ type: i0.ContentChildren, args: [router.RouterLinkWithHref, { read: i0.ElementRef, descendants: true },] }],
            linkClick: [{ type: i0.Output }]
        };
        return NavlinksComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NavbarModule = /** @class */ (function () {
        function NavbarModule() {
        }
        NavbarModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [NavbarComponent, LinksComponent, LogoComponent, NavlinksComponent],
                        exports: [NavbarComponent, LinksComponent, LogoComponent, NavlinksComponent],
                        providers: [NavbarService]
                    },] }
        ];
        return NavbarModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Configuration service for the Popover directive.
     * You can inject this service, typically in your root component, and customize
     * the values of its properties in order to provide default values for all the
     * popovers used in the application.
     */
    var PopoverConfig = /** @class */ (function () {
        function PopoverConfig() {
            /**
             * Placement of a popover. Accepts: "top", "bottom", "left", "right"
             */
            this.placement = 'top';
            /**
             * Specifies events that should trigger. Supports a space separated list of
             * event names.
             */
            this.triggers = 'click';
        }
        PopoverConfig.decorators = [
            { type: i0.Injectable }
        ];
        return PopoverConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopoverContainerComponent = /** @class */ (function () {
        function PopoverContainerComponent(config) {
            this.show = '!isBs3';
            this.role = 'tooltip';
            Object.assign(this, config);
        }
        Object.defineProperty(PopoverContainerComponent.prototype, "isBs3", {
            get: /**
             * @return {?}
             */ function () {
                return isBs3();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        PopoverContainerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.class = 'popover-fadeIn popover in popover-' + this.placement + ' ' + this.placement + ' bs-popover-' + this.placement;
            };
        PopoverContainerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-popover-container',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: "\n <h3 class=\"popover-header\" *ngIf=\"title\">{{title}}</h3>\n <div class=\"popover-body\">\n <ng-content></ng-content>\n </div>"
                    }] }
        ];
        /** @nocollapse */
        PopoverContainerComponent.ctorParameters = function () {
            return [
                { type: PopoverConfig }
            ];
        };
        PopoverContainerComponent.propDecorators = {
            placement: [{ type: i0.Input }],
            title: [{ type: i0.Input }],
            show: [{ type: i0.HostBinding, args: ['class.show',] }],
            role: [{ type: i0.HostBinding, args: ['attr.role',] }],
            class: [{ type: i0.HostBinding, args: ['class',] }]
        };
        return PopoverContainerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A lightweight, extensible directive for fancy popover creation.
     */
    var PopoverDirective = /** @class */ (function () {
        function PopoverDirective(_elementRef, _renderer, _viewContainerRef, _config, cis, _positionService) {
            this._positionService = _positionService;
            this.dynamicPosition = true;
            this.outsideClick = false;
            this._popover = cis
                .createLoader(_elementRef, _viewContainerRef, _renderer)
                .provide({ provide: PopoverConfig, useValue: _config });
            Object.assign(this, _config);
            this.onShown = this._popover.onShown;
            this.shown = this._popover.onShown;
            this.onHidden = this._popover.onHidden;
            this.hidden = this._popover.onHidden;
        }
        Object.defineProperty(PopoverDirective.prototype, "isOpen", {
            /**
             * Returns whether or not the popover is currently being shown
             */
            get: /**
             * Returns whether or not the popover is currently being shown
             * @return {?}
             */ function () {
                return this._popover.isShown;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                if (value) {
                    this.show();
                }
                else {
                    this.hide();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Opens an element’s popover. This is considered a “manual” triggering of
         * the popover.
         */
        /**
         * Opens an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
        PopoverDirective.prototype.show = /**
         * Opens an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
            function () {
                if (this._popover.isShown) {
                    return;
                }
                this._positionService.setOptions({
                    modifiers: {
                        flip: {
                            enabled: this.dynamicPosition
                        },
                        preventOverflow: {
                            enabled: this.dynamicPosition
                        }
                    }
                });
                this._popover
                    .attach(PopoverContainerComponent)
                    .to(this.container)
                    .position({ attachment: this.placement })
                    .show({
                    content: this.mdbPopover,
                    placement: this.placement,
                    title: this.mdbPopoverHeader || this.popoverTitle
                });
                this.isOpen = true;
                if (!this.dynamicPosition) {
                    this._positionService.calcPosition();
                    this._positionService.deletePositionElement(this._popover._componentRef.location);
                }
            };
        /**
         * Closes an element’s popover. This is considered a “manual” triggering of
         * the popover.
         */
        /**
         * Closes an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
        PopoverDirective.prototype.hide = /**
         * Closes an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
            function () {
                if (this.isOpen) {
                    this._popover.hide();
                    this.isOpen = false;
                }
            };
        /**
         * Toggles an element’s popover. This is considered a “manual” triggering of
         * the popover.
         */
        /**
         * Toggles an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
        PopoverDirective.prototype.toggle = /**
         * Toggles an element’s popover. This is considered a “manual” triggering of
         * the popover.
         * @return {?}
         */
            function () {
                if (this.isOpen) {
                    return this.hide();
                }
                this.show();
            };
        /**
         * @param {?} event
         * @return {?}
         */
        PopoverDirective.prototype.onclick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.triggers.toString().includes('focus')) {
                    event.stopPropagation();
                    this.show();
                }
            };
        /**
         * @return {?}
         */
        PopoverDirective.prototype.onblur = /**
         * @return {?}
         */
            function () {
                if (this.triggers.toString().includes('focus') && this.isOpen) {
                    this.hide();
                }
            };
        /**
         * @return {?}
         */
        PopoverDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._popover.listen({
                    triggers: this.triggers,
                    outsideClick: this.outsideClick,
                    show: ( /**
                     * @return {?}
                     */function () { return _this.show(); })
                });
            };
        /**
         * @return {?}
         */
        PopoverDirective.prototype.dispose = /**
         * @return {?}
         */
            function () {
                this._popover.dispose();
            };
        /**
         * @return {?}
         */
        PopoverDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._popover.dispose();
            };
        PopoverDirective.decorators = [
            { type: i0.Directive, args: [{ selector: '[mdbPopover]', exportAs: 'bs-mdbPopover' },] }
        ];
        /** @nocollapse */
        PopoverDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 },
                { type: i0.ViewContainerRef },
                { type: PopoverConfig },
                { type: ComponentLoaderFactory },
                { type: PositioningService }
            ];
        };
        PopoverDirective.propDecorators = {
            mdbPopover: [{ type: i0.Input }],
            mdbPopoverHeader: [{ type: i0.Input }],
            popoverTitle: [{ type: i0.Input }],
            placement: [{ type: i0.Input }],
            triggers: [{ type: i0.Input }],
            container: [{ type: i0.Input }],
            isOpen: [{ type: i0.Input }],
            dynamicPosition: [{ type: i0.Input }],
            outsideClick: [{ type: i0.Input }],
            onShown: [{ type: i0.Output }],
            shown: [{ type: i0.Output }],
            onHidden: [{ type: i0.Output }],
            hidden: [{ type: i0.Output }],
            onclick: [{ type: i0.HostListener, args: ['click', ['$event'],] }],
            onblur: [{ type: i0.HostListener, args: ['window:click',] }]
        };
        return PopoverDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopoverModule = /** @class */ (function () {
        function PopoverModule() {
        }
        /**
         * @return {?}
         */
        PopoverModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: PopoverModule,
                    providers: [PopoverConfig, ComponentLoaderFactory, PositioningService]
                };
            };
        PopoverModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [PopoverDirective, PopoverContainerComponent],
                        exports: [PopoverDirective],
                        entryComponents: [PopoverContainerComponent]
                    },] }
        ];
        return PopoverModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbTableDirective = /** @class */ (function () {
        function MdbTableDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.stickyHeader = false;
            this.stickyHeaderBgColor = '';
            this.stickyHeaderTextColor = '';
            this._dataSource = [];
            this._dataSourceChanged = new rxjs.Subject();
        }
        /**
         * @param {?} newRow
         * @return {?}
         */
        MdbTableDirective.prototype.addRow = /**
         * @param {?} newRow
         * @return {?}
         */
            function (newRow) {
                this.getDataSource().push(newRow);
            };
        /**
         * @param {?} index
         * @param {?} row
         * @return {?}
         */
        MdbTableDirective.prototype.addRowAfter = /**
         * @param {?} index
         * @param {?} row
         * @return {?}
         */
            function (index, row) {
                this.getDataSource().splice(index, 0, row);
            };
        /**
         * @param {?} index
         * @return {?}
         */
        MdbTableDirective.prototype.removeRow = /**
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this.getDataSource().splice(index, 1);
            };
        /**
         * @return {?}
         */
        MdbTableDirective.prototype.rowRemoved = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var rowRemoved = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(true);
                }));
                return rowRemoved;
            };
        /**
         * @return {?}
         */
        MdbTableDirective.prototype.removeLastRow = /**
         * @return {?}
         */
            function () {
                this.getDataSource().pop();
            };
        /**
         * @return {?}
         */
        MdbTableDirective.prototype.getDataSource = /**
         * @return {?}
         */
            function () {
                return this._dataSource;
            };
        /**
         * @param {?} data
         * @return {?}
         */
        MdbTableDirective.prototype.setDataSource = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                this._dataSource = data;
                this._dataSourceChanged.next(this.getDataSource());
            };
        /**
         * @return {?}
         */
        MdbTableDirective.prototype.dataSourceChange = /**
         * @return {?}
         */
            function () {
                return this._dataSourceChanged;
            };
        /**
         * @param {?} searchKey
         * @return {?}
         */
        MdbTableDirective.prototype.filterLocalDataBy = /**
         * @param {?} searchKey
         * @return {?}
         */
            function (searchKey) {
                return this.getDataSource().filter(( /**
                 * @param {?} obj
                 * @return {?}
                 */function (obj) {
                    return Object.keys(obj).some(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        if (obj[key]) {
                            return (obj[key].toString().toLowerCase()).includes(searchKey);
                        }
                    }));
                }));
            };
        /**
         * @param {?} searchKey
         * @return {?}
         */
        MdbTableDirective.prototype.searchLocalDataBy = /**
         * @param {?} searchKey
         * @return {?}
         */
            function (searchKey) {
                if (!searchKey) {
                    return this.getDataSource();
                }
                if (searchKey) {
                    return this.filterLocalDataBy(searchKey.toLowerCase());
                }
            };
        /**
         * @param {?} searchKey
         * @return {?}
         */
        MdbTableDirective.prototype.searchDataObservable = /**
         * @param {?} searchKey
         * @return {?}
         */
            function (searchKey) {
                var _this = this;
                /** @type {?} */
                var observable = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(_this.searchLocalDataBy(searchKey));
                }));
                return observable;
            };
        /**
         * @return {?}
         */
        MdbTableDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.renderer.addClass(this.el.nativeElement, 'table');
                if (this.stickyHeader) {
                    /** @type {?} */
                    var tableHead = this.el.nativeElement.querySelector('thead');
                    this.renderer.addClass(tableHead, 'sticky-top');
                    if (this.stickyHeaderBgColor) {
                        this.renderer.setStyle(tableHead, 'background-color', this.stickyHeaderBgColor);
                    }
                    else {
                        this.renderer.setStyle(tableHead, 'background-color', '#f2f2f2');
                    }
                    if (this.stickyHeaderTextColor) {
                        this.renderer.setStyle(tableHead, 'color', this.stickyHeaderTextColor);
                    }
                    else {
                        this.renderer.setStyle(tableHead, 'color', '#000000');
                    }
                }
            };
        MdbTableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbTable]',
                        exportAs: 'mdbTable'
                    },] }
        ];
        /** @nocollapse */
        MdbTableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbTableDirective.propDecorators = {
            striped: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.table-striped',] }],
            bordered: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.table-bordered',] }],
            borderless: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.table-borderless',] }],
            hover: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.table-hover',] }],
            small: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.table-sm',] }],
            responsive: [{ type: i0.Input }, { type: i0.HostBinding, args: ['class.table-responsive',] }],
            stickyHeader: [{ type: i0.Input }],
            stickyHeaderBgColor: [{ type: i0.Input }],
            stickyHeaderTextColor: [{ type: i0.Input }]
        };
        return MdbTableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbTableSortDirective = /** @class */ (function () {
        function MdbTableSortDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.sorted = true;
            this.dataSource = [];
            this.sortEnd = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        MdbTableSortDirective.prototype.onclick = /**
         * @return {?}
         */
            function () {
                this.sortDataBy(this.trimWhiteSigns(this.sortBy.toString()));
                this.sortEnd.emit(this.dataSource);
            };
        /**
         * @param {?} headElement
         * @return {?}
         */
        MdbTableSortDirective.prototype.trimWhiteSigns = /**
         * @param {?} headElement
         * @return {?}
         */
            function (headElement) {
                return headElement.replace(/ /g, '');
            };
        /**
         * @param {?} arr
         * @param {?} oldIndex
         * @param {?} newIndex
         * @return {?}
         */
        MdbTableSortDirective.prototype.moveArrayItem = /**
         * @param {?} arr
         * @param {?} oldIndex
         * @param {?} newIndex
         * @return {?}
         */
            function (arr, oldIndex, newIndex) {
                while (oldIndex < 0) {
                    oldIndex += arr.length;
                }
                while (newIndex < 0) {
                    newIndex += arr.length;
                }
                if (newIndex >= arr.length) {
                    /** @type {?} */
                    var k = newIndex - arr.length;
                    while ((k--) + 1) {
                        arr.push(null);
                    }
                }
                arr.splice(newIndex, 0, arr.splice(oldIndex, 1)[0]);
                return arr;
            };
        /**
         * @param {?} key
         * @return {?}
         */
        MdbTableSortDirective.prototype.sortDataBy = /**
         * @param {?} key
         * @return {?}
         */
            function (key) {
                var _this = this;
                key = key.split('.');
                this.dataSource.sort(( /**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */function (a, b) {
                    /** @type {?} */
                    var i = 0;
                    while (i < key.length) {
                        a = a[key[i]];
                        b = b[key[i]];
                        i++;
                    }
                    if (a < b) {
                        _this.renderer.setAttribute(_this.el.nativeElement, 'aria-sort', 'ascending');
                        _this.renderer.setAttribute(_this.el.nativeElement, 'aria-label', key + ": activate to sort column descending");
                        return _this.sorted ? 1 : -1;
                    }
                    else if (a > b) {
                        _this.renderer.setAttribute(_this.el.nativeElement, 'aria-sort', 'descending');
                        _this.renderer.setAttribute(_this.el.nativeElement, 'aria-label', key + ": activate to sort column ascending");
                        return _this.sorted ? -1 : 1;
                    }
                    else if (a == null || b == null) {
                        return 1;
                    }
                    else {
                        return 0;
                    }
                }));
                this.sorted = !this.sorted;
            };
        /**
         * @return {?}
         */
        MdbTableSortDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var key = this.trimWhiteSigns(this.sortBy.toString()).split('.');
                this.renderer.setAttribute(this.el.nativeElement, 'aria-label', key + ": activate to sort column descending");
            };
        MdbTableSortDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbTableSort]'
                    },] }
        ];
        /** @nocollapse */
        MdbTableSortDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 }
            ];
        };
        MdbTableSortDirective.propDecorators = {
            dataSource: [{ type: i0.Input, args: ['mdbTableSort',] }],
            sortBy: [{ type: i0.Input }],
            sortEnd: [{ type: i0.Output }],
            onclick: [{ type: i0.HostListener, args: ['click',] }]
        };
        return MdbTableSortDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbTableScrollDirective = /** @class */ (function () {
        function MdbTableScrollDirective(renderer, el) {
            this.renderer = renderer;
            this.el = el;
            this.scrollY = false;
            this.maxHeight = null;
            this.scrollX = false;
            this.maxWidth = null;
        }
        /**
         * @param {?} tableWrapper
         * @return {?}
         */
        MdbTableScrollDirective.prototype.wrapTableWithVerticalScrollingWrapper = /**
         * @param {?} tableWrapper
         * @return {?}
         */
            function (tableWrapper) {
                this.renderer.setStyle(tableWrapper, 'max-height', this.maxHeight + 'px');
                this.renderer.setStyle(tableWrapper, 'overflow-y', 'auto');
                this.renderer.setStyle(tableWrapper, 'display', 'block');
            };
        /**
         * @param {?} tableWrapper
         * @return {?}
         */
        MdbTableScrollDirective.prototype.wrapTableWithHorizontalScrollingWrapper = /**
         * @param {?} tableWrapper
         * @return {?}
         */
            function (tableWrapper) {
                this.renderer.setStyle(tableWrapper, 'max-width', this.maxWidth + 'px');
                this.renderer.setStyle(tableWrapper, 'overflow-x', 'auto');
                this.renderer.setStyle(tableWrapper, 'display', 'block');
            };
        /**
         * @param {?} tableWrapper
         * @return {?}
         */
        MdbTableScrollDirective.prototype.wrapTableWithHorizontalAndVerticalScrollingWrapper = /**
         * @param {?} tableWrapper
         * @return {?}
         */
            function (tableWrapper) {
                this.renderer.setStyle(tableWrapper, 'max-height', this.maxHeight + 'px');
                this.renderer.setStyle(tableWrapper, 'max-width', this.maxWidth + 'px');
                this.renderer.setStyle(tableWrapper, 'overflow-x', 'auto');
                this.renderer.setStyle(tableWrapper, 'display', 'block');
            };
        /**
         * @return {?}
         */
        MdbTableScrollDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var parent = this.el.nativeElement.parentNode;
                /** @type {?} */
                var tableWrapper = this.renderer.createElement('div');
                if (this.scrollY && this.scrollX && this.maxHeight && this.maxWidth) {
                    this.wrapTableWithHorizontalAndVerticalScrollingWrapper(tableWrapper);
                }
                if (this.scrollY && this.maxHeight) {
                    this.wrapTableWithVerticalScrollingWrapper(tableWrapper);
                }
                if (this.scrollX && this.maxWidth) {
                    this.wrapTableWithHorizontalScrollingWrapper(tableWrapper);
                }
                this.renderer.insertBefore(parent, tableWrapper, this.el.nativeElement);
                this.renderer.removeChild(parent, this.el.nativeElement);
                this.renderer.appendChild(tableWrapper, this.el.nativeElement);
            };
        MdbTableScrollDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbTableScroll]'
                    },] }
        ];
        /** @nocollapse */
        MdbTableScrollDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef }
            ];
        };
        MdbTableScrollDirective.propDecorators = {
            scrollY: [{ type: i0.Input }],
            maxHeight: [{ type: i0.Input }],
            scrollX: [{ type: i0.Input }],
            maxWidth: [{ type: i0.Input }]
        };
        return MdbTableScrollDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbTableRowDirective = /** @class */ (function () {
        function MdbTableRowDirective(el) {
            this.el = el;
            this.rowCreated = new i0.EventEmitter();
            this.rowRemoved = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        MdbTableRowDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.rowCreated.emit({ created: true, el: this.el.nativeElement });
            };
        /**
         * @return {?}
         */
        MdbTableRowDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.rowRemoved.emit({ removed: true });
            };
        MdbTableRowDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbTableRow]'
                    },] }
        ];
        /** @nocollapse */
        MdbTableRowDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        MdbTableRowDirective.propDecorators = {
            rowCreated: [{ type: i0.Output }],
            rowRemoved: [{ type: i0.Output }]
        };
        return MdbTableRowDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbTableService = /** @class */ (function () {
        function MdbTableService() {
            this._dataSource = [];
            this._dataSourceChanged = new rxjs.Subject();
        }
        /**
         * @param {?} newRow
         * @return {?}
         */
        MdbTableService.prototype.addRow = /**
         * @param {?} newRow
         * @return {?}
         */
            function (newRow) {
                this.getDataSource().push(newRow);
            };
        /**
         * @param {?} index
         * @param {?} row
         * @return {?}
         */
        MdbTableService.prototype.addRowAfter = /**
         * @param {?} index
         * @param {?} row
         * @return {?}
         */
            function (index, row) {
                this.getDataSource().splice(index, 0, row);
            };
        /**
         * @param {?} index
         * @return {?}
         */
        MdbTableService.prototype.removeRow = /**
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this.getDataSource().splice(index, 1);
            };
        /**
         * @return {?}
         */
        MdbTableService.prototype.rowRemoved = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var rowRemoved = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(true);
                }));
                return rowRemoved;
            };
        /**
         * @return {?}
         */
        MdbTableService.prototype.removeLastRow = /**
         * @return {?}
         */
            function () {
                this.getDataSource().pop();
            };
        /**
         * @return {?}
         */
        MdbTableService.prototype.getDataSource = /**
         * @return {?}
         */
            function () {
                return this._dataSource;
            };
        /**
         * @param {?} data
         * @return {?}
         */
        MdbTableService.prototype.setDataSource = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                this._dataSource = data;
                this._dataSourceChanged.next(this.getDataSource());
            };
        /**
         * @return {?}
         */
        MdbTableService.prototype.dataSourceChange = /**
         * @return {?}
         */
            function () {
                return this._dataSourceChanged;
            };
        /**
         * @param {?} searchKey
         * @return {?}
         */
        MdbTableService.prototype.filterLocalDataBy = /**
         * @param {?} searchKey
         * @return {?}
         */
            function (searchKey) {
                return this.getDataSource().filter(( /**
                 * @param {?} obj
                 * @return {?}
                 */function (obj) {
                    return Object.keys(obj).some(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        if (obj[key]) {
                            return (obj[key].toString().toLowerCase()).includes(searchKey);
                        }
                    }));
                }));
            };
        /**
         * @param {?} searchKey
         * @return {?}
         */
        MdbTableService.prototype.searchLocalDataBy = /**
         * @param {?} searchKey
         * @return {?}
         */
            function (searchKey) {
                if (!searchKey) {
                    return this.getDataSource();
                }
                if (searchKey) {
                    return this.filterLocalDataBy(searchKey.toLowerCase());
                }
            };
        /**
         * @param {?} searchKey
         * @return {?}
         */
        MdbTableService.prototype.searchDataObservable = /**
         * @param {?} searchKey
         * @return {?}
         */
            function (searchKey) {
                var _this = this;
                /** @type {?} */
                var observable = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(_this.searchLocalDataBy(searchKey));
                }));
                return observable;
            };
        MdbTableService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        MdbTableService.ctorParameters = function () { return []; };
        /** @nocollapse */ MdbTableService.ngInjectableDef = i0.defineInjectable({ factory: function MdbTableService_Factory() { return new MdbTableService(); }, token: MdbTableService, providedIn: "root" });
        return MdbTableService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MdbTablePaginationComponent = /** @class */ (function () {
        function MdbTablePaginationComponent(cdRef) {
            this.cdRef = cdRef;
            this.searchPagination = false;
            this.searchDataSource = null;
            this.ofKeyword = 'of';
            this.dashKeyword = '-';
            this.paginationAlign = '';
            this.hideDescription = false;
            this.maxVisibleItems = 10;
            this.firstItemIndex = 0;
            this.lastItemIndex = this.maxVisibleItems;
            this.lastVisibleItemIndex = 5;
            this.activePageNumber = 1;
            this.allItemsLength = 0;
            this.nextShouldBeDisabled = false;
            this.previousShouldBeDisabled = true;
            this.searchText = '';
            this.pagination = new rxjs.Subject();
            this.nextPageClick = new i0.EventEmitter();
            this.previousPageClick = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.tableEl) {
                    this.allItemsLength = this.tableEl.getDataSource().length;
                }
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.tableEl) {
                    this.tableEl.dataSourceChange().subscribe(( /**
                     * @param {?} data
                     * @return {?}
                     */function (data) {
                        _this.allItemsLength = data.length;
                        _this.lastVisibleItemIndex = data.length;
                        _this.calculateFirstItemIndex();
                        _this.calculateLastItemIndex();
                        _this.disableNextButton(data);
                        if (_this.searchDataSource) {
                            setTimeout(( /**
                             * @return {?}
                             */function () {
                                if (_this.searchDataSource.length !== data.length) {
                                    _this.activePageNumber = 1;
                                    _this.firstItemIndex = 1;
                                }
                            }), 0);
                        }
                    }));
                }
                this.paginationChange().subscribe(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    _this.firstItemIndex = data.first;
                    _this.lastVisibleItemIndex = data.last;
                }));
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                /** @type {?} */
                var searchDataSource = changes['searchDataSource'];
                if (searchDataSource.currentValue.length !== 0) {
                    this.allItemsLength = searchDataSource.currentValue.length;
                }
                if (this.lastVisibleItemIndex > this.allItemsLength) {
                    this.lastVisibleItemIndex = this.allItemsLength;
                }
                if (searchDataSource.currentValue.length === 0) {
                    this.firstItemIndex = 0;
                    this.lastItemIndex = 0;
                    this.lastVisibleItemIndex = 0;
                    this.allItemsLength = 0;
                }
                if (!searchDataSource.isFirstChange() && searchDataSource.currentValue.length <= this.maxVisibleItems) {
                    this.nextShouldBeDisabled = true;
                    this.lastVisibleItemIndex = searchDataSource.currentValue.length;
                }
                else {
                    this.nextShouldBeDisabled = false;
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.setMaxVisibleItemsNumberTo = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.lastItemIndex = value;
                this.lastVisibleItemIndex = value;
                this.maxVisibleItems = value;
                this.cdRef.detectChanges();
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.searchTextObs = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var observable = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(_this.searchText);
                }));
                return observable;
            };
        /**
         * @param {?} data
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.disableNextButton = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                if (data.length <= this.maxVisibleItems) {
                    this.nextShouldBeDisabled = true;
                }
                else {
                    this.nextShouldBeDisabled = false;
                }
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.calculateFirstItemIndex = /**
         * @return {?}
         */
            function () {
                this.firstItemIndex = this.activePageNumber * this.maxVisibleItems - this.maxVisibleItems + 1;
                this.pagination.next({ first: this.firstItemIndex, last: this.lastItemIndex });
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.calculateLastItemIndex = /**
         * @return {?}
         */
            function () {
                this.lastItemIndex = this.activePageNumber * this.maxVisibleItems;
                this.lastVisibleItemIndex = this.lastItemIndex;
                if (this.searchDataSource && (this.lastItemIndex > this.searchDataSource.length)) {
                    this.lastVisibleItemIndex = this.searchDataSource.length;
                }
                else if (!this.searchDataSource) {
                    this.lastVisibleItemIndex = this.lastItemIndex;
                }
                if (this.lastItemIndex > this.tableEl.getDataSource().length) {
                    this.lastItemIndex = this.tableEl.getDataSource().length;
                    this.lastVisibleItemIndex = this.tableEl.getDataSource().length;
                }
                this.pagination.next({ first: this.firstItemIndex, last: this.lastItemIndex });
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.paginationChange = /**
         * @return {?}
         */
            function () {
                return this.pagination;
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.calculateHowManyPagesShouldBe = /**
         * @return {?}
         */
            function () {
                return Math.ceil(this.tableEl.getDataSource().length / this.maxVisibleItems);
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.previousPage = /**
         * @return {?}
         */
            function () {
                this.activePageNumber--;
                this.calculateFirstItemIndex();
                this.calculateLastItemIndex();
                this.previousPageClick.emit({ first: this.firstItemIndex, last: this.lastItemIndex });
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.nextPage = /**
         * @return {?}
         */
            function () {
                this.activePageNumber++;
                this.calculateFirstItemIndex();
                this.calculateLastItemIndex();
                if (this.lastItemIndex > this.tableEl.getDataSource().length) {
                    this.lastItemIndex = this.tableEl.getDataSource().length;
                }
                if (this.lastVisibleItemIndex > this.allItemsLength) {
                    this.lastVisibleItemIndex = this.allItemsLength;
                }
                this.nextPageClick.emit({ first: this.firstItemIndex, last: this.lastItemIndex });
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.nextPageObservable = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var obs = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(_this.firstItemIndex);
                }));
                return obs;
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.previousPageObservable = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var obs = rxjs.Observable.create(( /**
                 * @param {?} observer
                 * @return {?}
                 */function (observer) {
                    observer.next(_this.lastVisibleItemIndex);
                }));
                return obs;
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.checkIfNextShouldBeDisabled = /**
         * @return {?}
         */
            function () {
                if (this.searchDataSource && (this.lastVisibleItemIndex === this.searchDataSource.length)) {
                    return true;
                }
                if (this.activePageNumber >= this.calculateHowManyPagesShouldBe()) {
                    return true;
                }
                if (this.nextShouldBeDisabled) {
                    return this.nextShouldBeDisabled;
                }
            };
        /**
         * @return {?}
         */
        MdbTablePaginationComponent.prototype.checkIfPreviousShouldBeDisabled = /**
         * @return {?}
         */
            function () {
                if (this.activePageNumber === 1) {
                    return true;
                }
            };
        MdbTablePaginationComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-table-pagination',
                        template: "<!--Pagination -->\n<nav>\n  <ul class=\"pagination pagination-circle pg-blue d-flex flex-center\" [ngClass]=\"{\n      'justify-content-end': paginationAlign =='end',\n      'justify-content-start': paginationAlign =='start'\n    }\">\n\n    <li *ngIf=\"!hideDescription\">{{firstItemIndex}} {{dashKeyword}} {{lastVisibleItemIndex}} {{ofKeyword}} {{allItemsLength}}</li>\n    <!--Arrow left-->\n    <li class=\"page-item\" [ngClass]=\"{'disabled': checkIfPreviousShouldBeDisabled()}\">\n      <a class=\"page-link\" mdbWavesEffect aria-label=\"Previous\" (click)=\"previousPage()\">\n        <span aria-hidden=\"true\">\u00AB</span>\n      </a>\n    </li>\n\n    <!--Arrow right-->\n    <li class=\"page-item\" [ngClass]=\"{'disabled': checkIfNextShouldBeDisabled()}\">\n      <a class=\"page-link\" mdbWavesEffect aria-label=\"Next\" (click)=\"nextPage()\">\n        <span aria-hidden=\"true\">\u00BB</span>\n      </a>\n    </li>\n\n  </ul>\n</nav>\n<!--/Pagination -->\n"
                    }] }
        ];
        /** @nocollapse */
        MdbTablePaginationComponent.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef }
            ];
        };
        MdbTablePaginationComponent.propDecorators = {
            tableEl: [{ type: i0.Input }],
            searchPagination: [{ type: i0.Input }],
            searchDataSource: [{ type: i0.Input }],
            ofKeyword: [{ type: i0.Input }],
            dashKeyword: [{ type: i0.Input }],
            paginationAlign: [{ type: i0.Input }],
            hideDescription: [{ type: i0.Input }],
            nextPageClick: [{ type: i0.Output }],
            previousPageClick: [{ type: i0.Output }]
        };
        return MdbTablePaginationComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableModule = /** @class */ (function () {
        function TableModule() {
        }
        TableModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [
                            MdbTablePaginationComponent,
                            MdbTableRowDirective,
                            MdbTableScrollDirective,
                            MdbTableSortDirective,
                            MdbTableDirective
                        ],
                        exports: [
                            MdbTablePaginationComponent,
                            MdbTableRowDirective,
                            MdbTableScrollDirective,
                            MdbTableSortDirective,
                            MdbTableDirective
                        ],
                        entryComponents: [MdbTablePaginationComponent],
                        providers: [MdbTableService]
                    },] }
        ];
        return TableModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Default values provider for tooltip
     */
    var TooltipConfig = /** @class */ (function () {
        function TooltipConfig() {
            /**
             * tooltip placement, supported positions: 'top', 'bottom', 'left', 'right'
             */
            this.placement = 'top';
            /**
             * array of event names which triggers tooltip opening
             */
            this.triggers = 'hover focus';
        }
        TooltipConfig.decorators = [
            { type: i0.Injectable }
        ];
        return TooltipConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipContainerComponent = /** @class */ (function () {
        function TooltipContainerComponent(config, elem) {
            this.containerClass = '';
            this.show = !this.isBs3;
            this.el = elem;
            Object.assign(this, config);
        }
        Object.defineProperty(TooltipContainerComponent.prototype, "isBs3", {
            get: /**
             * @return {?}
             */ function () {
                return isBs3();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TooltipContainerComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                this.classMap = { in: false, fade: false };
                this.classMap[this.placement] = true;
                this.classMap['tooltip-' + this.placement] = true;
                this.classMap.in = true;
                if (this.animation) {
                    this.classMap.fade = true;
                }
                if (this.popupClass) {
                    this.classMap[this.popupClass] = true;
                }
            };
        TooltipContainerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mdb-tooltip-container',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        host: {
                            '[class]': '"tooltip-fadeIn tooltip in tooltip-" + placement + " " + "bs-tooltip-" + placement + " " + placement + " " + containerClass'
                        },
                        template: "\n    <div #tooltipArrow class=\"tooltip-arrow arrow\"></div>\n    <div #tooltipInner class=\"tooltip-inner\">\n      <ng-content></ng-content>\n    </div>\n  "
                    }] }
        ];
        /** @nocollapse */
        TooltipContainerComponent.ctorParameters = function () {
            return [
                { type: TooltipConfig },
                { type: i0.ElementRef }
            ];
        };
        TooltipContainerComponent.propDecorators = {
            containerClass: [{ type: i0.Input }],
            tooltipInner: [{ type: i0.ViewChild, args: ['tooltipInner',] }],
            tooltipArrow: [{ type: i0.ViewChild, args: ['tooltipArrow',] }],
            show: [{ type: i0.HostBinding, args: ['class.show',] }]
        };
        return TooltipContainerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /*tslint:disable:no-invalid-this */
    /**
     * @return {?}
     */
    function OnChange$1() {
        /** @type {?} */
        var sufix = 'Change';
        return ( /**
         * @param {?} target
         * @param {?} propertyKey
         * @return {?}
         */function OnChangeHandler(target, propertyKey) {
            /** @type {?} */
            var _key = " __" + propertyKey + "Value";
            Object.defineProperty(target, propertyKey, {
                get: /**
                 * @return {?}
                 */ function () { return this[_key]; },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */ function (value) {
                    /** @type {?} */
                    var prevValue = this[_key];
                    this[_key] = value;
                    if (prevValue !== value && this[propertyKey + sufix]) {
                        this[propertyKey + sufix].emit(value);
                    }
                }
            });
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipDirective = /** @class */ (function () {
        function TooltipDirective(_renderer, _elementRef, _positionService, _viewContainerRef, cis, config, platformId) {
            this._elementRef = _elementRef;
            this._positionService = _positionService;
            this.platformId = platformId;
            /**
             * Fired when tooltip content changes
             */
            this.tooltipChange = new i0.EventEmitter();
            this.dynamicPosition = true;
            this.delay = 0;
            this.fadeDuration = 150;
            this.isBrowser = false;
            this.isBrowser = common.isPlatformBrowser((this.platformId));
            this._tooltip = cis
                .createLoader(this._elementRef, _viewContainerRef, _renderer)
                .provide({ provide: TooltipConfig, useValue: config });
            Object.assign(this, config);
            this.onShown = this._tooltip.onShown;
            this.shown = this._tooltip.onShown;
            this.onHidden = this._tooltip.onHidden;
            this.hidden = this._tooltip.onHidden;
        }
        Object.defineProperty(TooltipDirective.prototype, "isOpen", {
            /**
             * Returns whether or not the tooltip is currently being shown
             */
            get: /**
             * Returns whether or not the tooltip is currently being shown
             * @return {?}
             */ function () {
                return this._tooltip.isShown;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                if (value) {
                    this.show();
                }
                else {
                    this.hide();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TooltipDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._tooltip.listen({
                    triggers: this.triggers,
                    show: ( /**
                     * @return {?}
                     */function () { return _this.show(); })
                });
                this.tooltipChange.subscribe(( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) {
                    if (!value) {
                        _this._tooltip.hide();
                    }
                }));
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        TooltipDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (!changes['mdbTooltip'].isFirstChange()) {
                    this.tooltipChange.emit(this.mdbTooltip);
                }
            };
        /**
         * Toggles an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         */
        /**
         * Toggles an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         * @return {?}
         */
        TooltipDirective.prototype.toggle = /**
         * Toggles an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         * @return {?}
         */
            function () {
                if (this.isOpen) {
                    return this.hide();
                }
                this.show();
            };
        /**
         * Opens an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         */
        /**
         * Opens an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         * @return {?}
         */
        TooltipDirective.prototype.show = /**
         * Opens an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.isOpen || this.isDisabled || this._delayTimeoutId || !this.mdbTooltip) {
                    return;
                }
                this._positionService.setOptions({
                    modifiers: {
                        flip: {
                            enabled: this.dynamicPosition
                        },
                        preventOverflow: {
                            enabled: this.dynamicPosition
                        }
                    }
                });
                /** @type {?} */
                var showTooltip = ( /**
                 * @return {?}
                 */function () {
                    _this._tooltip
                        .attach(TooltipContainerComponent)
                        .to(_this.container)
                        .position({ attachment: _this.placement })
                        .show({
                        content: _this.mdbTooltip,
                        placement: _this.placement,
                    });
                });
                this.showTooltip(showTooltip);
            };
        /**
         * @private
         * @param {?} fn
         * @return {?}
         */
        TooltipDirective.prototype.showTooltip = /**
         * @private
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                if (this.delay) {
                    this._delayTimeoutId = setTimeout(( /**
                     * @return {?}
                     */function () {
                        fn();
                    }), this.delay);
                }
                else {
                    fn();
                }
            };
        /**
         * Closes an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         */
        /**
         * Closes an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         * @return {?}
         */
        TooltipDirective.prototype.hide = /**
         * Closes an element’s tooltip. This is considered a “manual” triggering of
         * the tooltip.
         * @return {?}
         */
            function () {
                var _this = this;
                if (this._delayTimeoutId) {
                    clearTimeout(this._delayTimeoutId);
                    this._delayTimeoutId = undefined;
                }
                if (!this._tooltip.isShown) {
                    return;
                }
                this._tooltip.instance.classMap.in = false;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this._tooltip.hide();
                }), this.fadeDuration);
            };
        /**
         * @return {?}
         */
        TooltipDirective.prototype.dispose = /**
         * @return {?}
         */
            function () {
                this._tooltip.dispose();
            };
        /**
         * @return {?}
         */
        TooltipDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._tooltip.dispose();
            };
        TooltipDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbTooltip]',
                        exportAs: 'mdb-tooltip'
                    },] }
        ];
        /** @nocollapse */
        TooltipDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef },
                { type: PositioningService },
                { type: i0.ViewContainerRef },
                { type: ComponentLoaderFactory },
                { type: TooltipConfig },
                { type: String, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        TooltipDirective.propDecorators = {
            mdbTooltip: [{ type: i0.Input }],
            tooltipChange: [{ type: i0.Output }],
            placement: [{ type: i0.Input }],
            triggers: [{ type: i0.Input }],
            container: [{ type: i0.Input }],
            isOpen: [{ type: i0.Input }],
            isDisabled: [{ type: i0.Input }],
            dynamicPosition: [{ type: i0.Input }],
            onShown: [{ type: i0.Output }],
            shown: [{ type: i0.Output }],
            onHidden: [{ type: i0.Output }],
            hidden: [{ type: i0.Output }],
            delay: [{ type: i0.Input }],
            customHeight: [{ type: i0.Input }],
            fadeDuration: [{ type: i0.Input }]
        };
        __decorate([
            OnChange$1(),
            __metadata("design:type", Object)
        ], TooltipDirective.prototype, "mdbTooltip", void 0);
        return TooltipDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipModule = /** @class */ (function () {
        function TooltipModule() {
        }
        /**
         * @return {?}
         */
        TooltipModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: TooltipModule,
                    providers: [TooltipConfig, ComponentLoaderFactory, PositioningService]
                };
            };
        TooltipModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [TooltipDirective, TooltipContainerComponent],
                        exports: [TooltipDirective],
                        entryComponents: [TooltipContainerComponent]
                    },] }
        ];
        return TooltipModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WavesDirective = /** @class */ (function () {
        function WavesDirective(el) {
            this.el = el;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        WavesDirective.prototype.click = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                // event.stopPropagation();
                if (!this.el.nativeElement.classList.contains('disabled')) {
                    /** @type {?} */
                    var button = this.el.nativeElement;
                    if (!button.classList.contains('waves-effect')) {
                        button.className += ' waves-effect';
                    }
                    /** @type {?} */
                    var xPos = event.clientX - button.getBoundingClientRect().left;
                    /** @type {?} */
                    var yPos = event.clientY - button.getBoundingClientRect().top;
                    /** @type {?} */
                    var tmp = document.createElement('div');
                    tmp.className += 'waves-ripple waves-rippling';
                    /** @type {?} */
                    var ripple = button.appendChild(tmp);
                    /** @type {?} */
                    var top_1 = yPos + 'px';
                    /** @type {?} */
                    var left = xPos + 'px';
                    tmp.style.top = top_1;
                    tmp.style.left = left;
                    /** @type {?} */
                    var scale = 'scale(' + ((button.clientWidth / 100) * 3) + ') translate(0,0)';
                    tmp.style.webkitTransform = scale;
                    tmp.style.transform = scale;
                    tmp.style.opacity = '1';
                    /** @type {?} */
                    var duration = 750;
                    tmp.style.webkitTransitionDuration = duration + 'ms';
                    tmp.style.transitionDuration = duration + 'ms';
                    this.removeRipple(button, ripple);
                }
            };
        /**
         * @param {?} button
         * @param {?} ripple
         * @return {?}
         */
        WavesDirective.prototype.removeRipple = /**
         * @param {?} button
         * @param {?} ripple
         * @return {?}
         */
            function (button, ripple) {
                ripple.classList.remove('waves-rippling');
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    ripple.style.opacity = '0';
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        button.removeChild(ripple);
                    }), 750);
                }), 200);
            };
        WavesDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbWavesEffect]'
                    },] }
        ];
        /** @nocollapse */
        WavesDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        WavesDirective.propDecorators = {
            click: [{ type: i0.HostListener, args: ['click', ['$event'],] }]
        };
        return WavesDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WavesModule = /** @class */ (function () {
        function WavesModule() {
        }
        /**
         * @return {?}
         */
        WavesModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: WavesModule, providers: [] };
            };
        WavesModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [WavesDirective],
                        exports: [WavesDirective]
                    },] }
        ];
        return WavesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var Direction$1 = {
        Up: 'Up',
        Down: 'Down',
    };
    var StickyHeaderDirective = /** @class */ (function () {
        function StickyHeaderDirective(_renderer, _el) {
            this._renderer = _renderer;
            this._el = _el;
            this.animationDuration = 200;
            this.transitionEnd = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        StickyHeaderDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var scroll$ = rxjs.fromEvent(win, 'scroll').pipe(operators.throttleTime(10), operators.map(( /**
                 * @return {?}
                 */function () { return win.pageYOffset; })), operators.pairwise(), operators.map(( /**
                 * @param {?} __0
                 * @return {?}
                 */function (_a) {
                    var _b = __read(_a, 2), y1 = _b[0], y2 = _b[1];
                    return (y2 < y1 ? Direction$1.Up : Direction$1.Down);
                })), operators.distinctUntilChanged(), operators.share());
                this.scrollUp$ = scroll$.pipe(operators.filter(( /**
                 * @param {?} direction
                 * @return {?}
                 */function (direction) { return direction === Direction$1.Up; })));
                this.scrollDown$ = scroll$.pipe(operators.filter(( /**
                 * @param {?} direction
                 * @return {?}
                 */function (direction) { return direction === Direction$1.Down; })));
                this._renderer.setStyle(this._el.nativeElement, 'position', 'fixed');
                this._renderer.setStyle(this._el.nativeElement, 'top', '0');
                this._renderer.setStyle(this._el.nativeElement, 'width', '100%');
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.scrollUp$.pipe(operators.skip(0)).subscribe(( /**
                     * @return {?}
                     */function () {
                        _this._renderer.setStyle(_this._el.nativeElement, 'transition', "all " + _this.animationDuration + "ms ease-in");
                        _this._renderer.setStyle(_this._el.nativeElement, 'transform', 'translateY(0%)');
                        _this.transitionEnd.emit({ state: 'Visible' });
                    }));
                    _this.scrollDown$.pipe(operators.skip(0)).subscribe(( /**
                     * @return {?}
                     */function () {
                        _this._renderer.setStyle(_this._el.nativeElement, 'transition', "all " + _this.animationDuration + "ms ease-in");
                        _this._renderer.setStyle(_this._el.nativeElement, 'transform', 'translateY(-100%)');
                        _this.transitionEnd.emit({ state: 'Hidden' });
                    }));
                }), 0);
            };
        StickyHeaderDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[mdbStickyHeader]',
                        exportAs: 'mdbStickyHeader'
                    },] }
        ];
        /** @nocollapse */
        StickyHeaderDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef }
            ];
        };
        StickyHeaderDirective.propDecorators = {
            animationDuration: [{ type: i0.Input }],
            transitionEnd: [{ type: i0.Output }]
        };
        return StickyHeaderDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StickyHeaderModule = /** @class */ (function () {
        function StickyHeaderModule() {
        }
        StickyHeaderModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [StickyHeaderDirective],
                        exports: [StickyHeaderDirective],
                        imports: [
                            common.CommonModule,
                        ]
                    },] }
        ];
        return StickyHeaderModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MODULES = [
        ButtonsModule,
        CardsFreeModule,
        WavesModule,
        InputsModule,
        NavbarModule,
        DropdownModule,
        CarouselModule,
        ChartsModule,
        CollapseModule,
        ModalModule,
        TooltipModule,
        PopoverModule,
        IconsModule,
        CheckboxModule,
        TableModule,
        BadgeModule,
        BreadcrumbModule,
        InputUtilitiesModule,
        StickyHeaderModule
    ];
    var MDBRootModule = /** @class */ (function () {
        function MDBRootModule() {
        }
        MDBRootModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [
                            ButtonsModule,
                            WavesModule.forRoot(),
                            InputsModule.forRoot(),
                            NavbarModule,
                            DropdownModule.forRoot(),
                            CarouselModule.forRoot(),
                            ChartsModule,
                            CollapseModule.forRoot(),
                            ModalModule.forRoot(),
                            TooltipModule.forRoot(),
                            PopoverModule.forRoot(),
                            IconsModule,
                            CardsFreeModule.forRoot(),
                            CheckboxModule,
                            TableModule,
                            BadgeModule,
                            BreadcrumbModule,
                            InputUtilitiesModule,
                            StickyHeaderModule
                        ],
                        exports: MODULES,
                        schemas: [i0.NO_ERRORS_SCHEMA]
                    },] }
        ];
        return MDBRootModule;
    }());
    var MDBBootstrapModule = /** @class */ (function () {
        function MDBBootstrapModule() {
        }
        /**
         * @return {?}
         */
        MDBBootstrapModule.forRoot = /**
         * @return {?}
         */
            function () {
                return { ngModule: MDBRootModule };
            };
        MDBBootstrapModule.decorators = [
            { type: i0.NgModule, args: [{ exports: MODULES },] }
        ];
        return MDBBootstrapModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.BadgeModule = BadgeModule;
    exports.MDBBadgeComponent = MDBBadgeComponent;
    exports.MdbBreadcrumbComponent = MdbBreadcrumbComponent;
    exports.MdbBreadcrumbItemComponent = MdbBreadcrumbItemComponent;
    exports.BreadcrumbModule = BreadcrumbModule;
    exports.MdbBtnDirective = MdbBtnDirective;
    exports.ButtonsModule = ButtonsModule;
    exports.ButtonRadioDirective = ButtonRadioDirective;
    exports.ButtonCheckboxDirective = ButtonCheckboxDirective;
    exports.FixedButtonCaptionDirective = FixedButtonCaptionDirective;
    exports.CardsFreeModule = CardsFreeModule;
    exports.MdbCardComponent = MdbCardComponent;
    exports.MdbCardBodyComponent = MdbCardBodyComponent;
    exports.MdbCardImageComponent = MdbCardImageComponent;
    exports.MdbCardTextComponent = MdbCardTextComponent;
    exports.MdbCardTitleComponent = MdbCardTitleComponent;
    exports.MdbCardFooterComponent = MdbCardFooterComponent;
    exports.MdbCardHeaderComponent = MdbCardHeaderComponent;
    exports.CarouselComponent = CarouselComponent;
    exports.CarouselModule = CarouselModule;
    exports.SlideComponent = SlideComponent;
    exports.CarouselConfig = CarouselConfig;
    exports.ChartsModule = ChartsModule;
    exports.BaseChartDirective = BaseChartDirective;
    exports.CHECKBOX_VALUE_ACCESSOR = CHECKBOX_VALUE_ACCESSOR;
    exports.CheckboxComponent = CheckboxComponent;
    exports.MdbCheckboxChange = MdbCheckboxChange;
    exports.CheckboxModule = CheckboxModule;
    exports.CollapseComponent = CollapseComponent;
    exports.CollapseModule = CollapseModule;
    exports.BsDropdownDirective = BsDropdownDirective;
    exports.BsDropdownMenuDirective = BsDropdownMenuDirective;
    exports.BsDropdownToggleDirective = BsDropdownToggleDirective;
    exports.BsDropdownContainerComponent = BsDropdownContainerComponent;
    exports.BsDropdownState = BsDropdownState;
    exports.BsDropdownConfig = BsDropdownConfig;
    exports.DropdownModule = DropdownModule;
    exports.MdbIconComponent = MdbIconComponent;
    exports.FalDirective = FalDirective;
    exports.FarDirective = FarDirective;
    exports.FasDirective = FasDirective;
    exports.FabDirective = FabDirective;
    exports.IconsModule = IconsModule;
    exports.InputUtilitiesModule = InputUtilitiesModule;
    exports.MdbErrorDirective = MdbErrorDirective;
    exports.MdbSuccessDirective = MdbSuccessDirective;
    exports.MdbValidateDirective = MdbValidateDirective;
    exports.InputsModule = InputsModule;
    exports.EqualValidatorDirective = EqualValidatorDirective;
    exports.MdbInputDirective = MdbInputDirective;
    exports.MdbInput = MdbInput;
    exports.ModalBackdropComponent = ModalBackdropComponent;
    exports.ModalBackdropOptions = ModalBackdropOptions;
    exports.ModalOptions = ModalOptions;
    exports.MDBModalRef = MDBModalRef;
    exports.ModalDirective = ModalDirective;
    exports.ModalModule = ModalModule;
    exports.MDBModalService = MDBModalService;
    exports.ModalContainerComponent = ModalContainerComponent;
    exports.NavbarComponent = NavbarComponent;
    exports.NavbarModule = NavbarModule;
    exports.LinksComponent = LinksComponent;
    exports.NavlinksComponent = NavlinksComponent;
    exports.LogoComponent = LogoComponent;
    exports.NavbarService = NavbarService;
    exports.PopoverDirective = PopoverDirective;
    exports.PopoverModule = PopoverModule;
    exports.PopoverConfig = PopoverConfig;
    exports.PopoverContainerComponent = PopoverContainerComponent;
    exports.TableModule = TableModule;
    exports.MdbTablePaginationComponent = MdbTablePaginationComponent;
    exports.MdbTableRowDirective = MdbTableRowDirective;
    exports.MdbTableScrollDirective = MdbTableScrollDirective;
    exports.MdbTableSortDirective = MdbTableSortDirective;
    exports.MdbTableDirective = MdbTableDirective;
    exports.MdbTableService = MdbTableService;
    exports.TooltipContainerComponent = TooltipContainerComponent;
    exports.TooltipDirective = TooltipDirective;
    exports.TooltipModule = TooltipModule;
    exports.TooltipConfig = TooltipConfig;
    exports.WavesDirective = WavesDirective;
    exports.WavesModule = WavesModule;
    exports.StickyHeaderDirective = StickyHeaderDirective;
    exports.StickyHeaderModule = StickyHeaderModule;
    exports.MDBRootModule = MDBRootModule;
    exports.MDBBootstrapModule = MDBBootstrapModule;
    exports.ɵb = CHECKBOX_CONTROL_VALUE_ACCESSOR;
    exports.ɵa = RADIO_CONTROL_VALUE_ACCESSOR;
    exports.ɵc = CHECKBOX_VALUE_ACCESSOR;
    exports.ɵd = CheckboxComponent;
    exports.ɵe = ComponentLoaderFactory;
    exports.ɵg = OnChange$1;
    exports.ɵf = PositioningService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-bootstrap-md.umd.js.map